((typeof self !== 'undefined' ? self : this)["webpackJsonpvisualization_cockpit"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvisualization_cockpit"] || []).push([[1],{

/***/ "2627":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module dependencies.
 */
__webpack_require__("9911");
var utils = __webpack_require__("8d5f");
/**
 * Expose `ResponseBase`.
 */

module.exports = ResponseBase;
/**
 * Initialize a new `ResponseBase`.
 *
 * @api public
 */

function ResponseBase(obj) {
  if (obj) return mixin(obj);
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in ResponseBase.prototype) {
    if (Object.prototype.hasOwnProperty.call(ResponseBase.prototype, key)) obj[key] = ResponseBase.prototype[key];
  }
  return obj;
}
/**
 * Get case-insensitive `field` value.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

ResponseBase.prototype.get = function (field) {
  return this.header[field.toLowerCase()];
};
/**
 * Set header related properties:
 *
 *   - `.type` the content type without params
 *
 * A response of "Content-Type: text/plain; charset=utf-8"
 * will provide you with a `.type` of "text/plain".
 *
 * @param {Object} header
 * @api private
 */

ResponseBase.prototype._setHeaderProperties = function (header) {
  // TODO: moar!
  // TODO: make this a util
  // content-type
  var ct = header['content-type'] || '';
  this.type = utils.type(ct); // params

  var params = utils.params(ct);
  for (var key in params) {
    if (Object.prototype.hasOwnProperty.call(params, key)) this[key] = params[key];
  }
  this.links = {}; // links

  try {
    if (header.link) {
      this.links = utils.parseLinks(header.link);
    }
  } catch (_unused) {// ignore
  }
};
/**
 * Set flags such as `.ok` based on `status`.
 *
 * For example a 2xx response will give you a `.ok` of __true__
 * whereas 5xx will be __false__ and `.error` will be __true__. The
 * `.clientError` and `.serverError` are also available to be more
 * specific, and `.statusType` is the class of error ranging from 1..5
 * sometimes useful for mapping respond colors etc.
 *
 * "sugar" properties are also defined for common cases. Currently providing:
 *
 *   - .noContent
 *   - .badRequest
 *   - .unauthorized
 *   - .notAcceptable
 *   - .notFound
 *
 * @param {Number} status
 * @api private
 */

ResponseBase.prototype._setStatusProperties = function (status) {
  var type = status / 100 | 0; // status / class

  this.statusCode = status;
  this.status = this.statusCode;
  this.statusType = type; // basics

  this.info = type === 1;
  this.ok = type === 2;
  this.redirect = type === 3;
  this.clientError = type === 4;
  this.serverError = type === 5;
  this.error = type === 4 || type === 5 ? this.toError() : false; // sugar

  this.created = status === 201;
  this.accepted = status === 202;
  this.noContent = status === 204;
  this.badRequest = status === 400;
  this.unauthorized = status === 401;
  this.notAcceptable = status === 406;
  this.forbidden = status === 403;
  this.notFound = status === 404;
  this.unprocessableEntity = status === 422;
};

/***/ }),

/***/ "3f91":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("99af");
__webpack_require__("caad");
__webpack_require__("e260");
__webpack_require__("a15b");
__webpack_require__("fb6a");
__webpack_require__("4e82");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("2532");
__webpack_require__("3ca3");
__webpack_require__("ddb0");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Module of mixed-in functions shared between node and client code
 */
var isObject = __webpack_require__("422b");
/**
 * Expose `RequestBase`.
 */

module.exports = RequestBase;
/**
 * Initialize a new `RequestBase`.
 *
 * @api public
 */

function RequestBase(obj) {
  if (obj) return mixin(obj);
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in RequestBase.prototype) {
    if (Object.prototype.hasOwnProperty.call(RequestBase.prototype, key)) obj[key] = RequestBase.prototype[key];
  }
  return obj;
}
/**
 * Clear previous timeout.
 *
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.clearTimeout = function () {
  clearTimeout(this._timer);
  clearTimeout(this._responseTimeoutTimer);
  clearTimeout(this._uploadTimeoutTimer);
  delete this._timer;
  delete this._responseTimeoutTimer;
  delete this._uploadTimeoutTimer;
  return this;
};
/**
 * Override default response body parser
 *
 * This function will be called to convert incoming data into request.body
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.parse = function (fn) {
  this._parser = fn;
  return this;
};
/**
 * Set format of binary response body.
 * In browser valid formats are 'blob' and 'arraybuffer',
 * which return Blob and ArrayBuffer, respectively.
 *
 * In Node all values result in Buffer.
 *
 * Examples:
 *
 *      req.get('/')
 *        .responseType('blob')
 *        .end(callback);
 *
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.responseType = function (val) {
  this._responseType = val;
  return this;
};
/**
 * Override default request body serializer
 *
 * This function will be called to convert data set via .send or .attach into payload to send
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.serialize = function (fn) {
  this._serializer = fn;
  return this;
};
/**
 * Set timeouts.
 *
 * - response timeout is time between sending request and receiving the first byte of the response. Includes DNS and connection time.
 * - deadline is the time from start of the request to receiving response body in full. If the deadline is too short large files may not load at all on slow connections.
 * - upload is the time  since last bit of data was sent or received. This timeout works only if deadline timeout is off
 *
 * Value of 0 or false means no timeout.
 *
 * @param {Number|Object} ms or {response, deadline}
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.timeout = function (options) {
  if (!options || _typeof(options) !== 'object') {
    this._timeout = options;
    this._responseTimeout = 0;
    this._uploadTimeout = 0;
    return this;
  }
  for (var option in options) {
    if (Object.prototype.hasOwnProperty.call(options, option)) {
      switch (option) {
        case 'deadline':
          this._timeout = options.deadline;
          break;
        case 'response':
          this._responseTimeout = options.response;
          break;
        case 'upload':
          this._uploadTimeout = options.upload;
          break;
        default:
          console.warn('Unknown timeout option', option);
      }
    }
  }
  return this;
};
/**
 * Set number of retry attempts on error.
 *
 * Failed requests will be retried 'count' times if timeout or err.code >= 500.
 *
 * @param {Number} count
 * @param {Function} [fn]
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.retry = function (count, fn) {
  // Default to 1 if no count passed or true
  if (arguments.length === 0 || count === true) count = 1;
  if (count <= 0) count = 0;
  this._maxRetries = count;
  this._retries = 0;
  this._retryCallback = fn;
  return this;
};
var ERROR_CODES = ['ECONNRESET', 'ETIMEDOUT', 'EADDRINFO', 'ESOCKETTIMEDOUT'];
/**
 * Determine if a request should be retried.
 * (Borrowed from segmentio/superagent-retry)
 *
 * @param {Error} err an error
 * @param {Response} [res] response
 * @returns {Boolean} if segment should be retried
 */

RequestBase.prototype._shouldRetry = function (err, res) {
  if (!this._maxRetries || this._retries++ >= this._maxRetries) {
    return false;
  }
  if (this._retryCallback) {
    try {
      var override = this._retryCallback(err, res);
      if (override === true) return true;
      if (override === false) return false; // undefined falls back to defaults
    } catch (err_) {
      console.error(err_);
    }
  }
  if (res && res.status && res.status >= 500 && res.status !== 501) return true;
  if (err) {
    if (err.code && ERROR_CODES.includes(err.code)) return true; // Superagent timeout

    if (err.timeout && err.code === 'ECONNABORTED') return true;
    if (err.crossDomain) return true;
  }
  return false;
};
/**
 * Retry request
 *
 * @return {Request} for chaining
 * @api private
 */

RequestBase.prototype._retry = function () {
  this.clearTimeout(); // node

  if (this.req) {
    this.req = null;
    this.req = this.request();
  }
  this._aborted = false;
  this.timedout = false;
  this.timedoutError = null;
  return this._end();
};
/**
 * Promise support
 *
 * @param {Function} resolve
 * @param {Function} [reject]
 * @return {Request}
 */

RequestBase.prototype.then = function (resolve, reject) {
  var _this = this;
  if (!this._fullfilledPromise) {
    var self = this;
    if (this._endCalled) {
      console.warn('Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises');
    }
    this._fullfilledPromise = new Promise(function (resolve, reject) {
      self.on('abort', function () {
        if (_this._maxRetries && _this._maxRetries > _this._retries) {
          return;
        }
        if (_this.timedout && _this.timedoutError) {
          reject(_this.timedoutError);
          return;
        }
        var err = new Error('Aborted');
        err.code = 'ABORTED';
        err.status = _this.status;
        err.method = _this.method;
        err.url = _this.url;
        reject(err);
      });
      self.end(function (err, res) {
        if (err) reject(err);else resolve(res);
      });
    });
  }
  return this._fullfilledPromise.then(resolve, reject);
};
RequestBase.prototype.catch = function (cb) {
  return this.then(undefined, cb);
};
/**
 * Allow for extension
 */

RequestBase.prototype.use = function (fn) {
  fn(this);
  return this;
};
RequestBase.prototype.ok = function (cb) {
  if (typeof cb !== 'function') throw new Error('Callback required');
  this._okCallback = cb;
  return this;
};
RequestBase.prototype._isResponseOK = function (res) {
  if (!res) {
    return false;
  }
  if (this._okCallback) {
    return this._okCallback(res);
  }
  return res.status >= 200 && res.status < 300;
};
/**
 * Get request header `field`.
 * Case-insensitive.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

RequestBase.prototype.get = function (field) {
  return this._header[field.toLowerCase()];
};
/**
 * Get case-insensitive header `field` value.
 * This is a deprecated internal API. Use `.get(field)` instead.
 *
 * (getHeader is no longer used internally by the superagent code base)
 *
 * @param {String} field
 * @return {String}
 * @api private
 * @deprecated
 */

RequestBase.prototype.getHeader = RequestBase.prototype.get;
/**
 * Set header `field` to `val`, or multiple fields with one object.
 * Case-insensitive.
 *
 * Examples:
 *
 *      req.get('/')
 *        .set('Accept', 'application/json')
 *        .set('X-API-Key', 'foobar')
 *        .end(callback);
 *
 *      req.get('/')
 *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
 *        .end(callback);
 *
 * @param {String|Object} field
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.set = function (field, val) {
  if (isObject(field)) {
    for (var key in field) {
      if (Object.prototype.hasOwnProperty.call(field, key)) this.set(key, field[key]);
    }
    return this;
  }
  this._header[field.toLowerCase()] = val;
  this.header[field] = val;
  return this;
};
/**
 * Remove header `field`.
 * Case-insensitive.
 *
 * Example:
 *
 *      req.get('/')
 *        .unset('User-Agent')
 *        .end(callback);
 *
 * @param {String} field field name
 */

RequestBase.prototype.unset = function (field) {
  delete this._header[field.toLowerCase()];
  delete this.header[field];
  return this;
};
/**
 * Write the field `name` and `val`, or multiple fields with one object
 * for "multipart/form-data" request bodies.
 *
 * ``` js
 * request.post('/upload')
 *   .field('foo', 'bar')
 *   .end(callback);
 *
 * request.post('/upload')
 *   .field({ foo: 'bar', baz: 'qux' })
 *   .end(callback);
 * ```
 *
 * @param {String|Object} name name of field
 * @param {String|Blob|File|Buffer|fs.ReadStream} val value of field
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.field = function (name, val) {
  // name should be either a string or an object.
  if (name === null || undefined === name) {
    throw new Error('.field(name, val) name can not be empty');
  }
  if (this._data) {
    throw new Error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObject(name)) {
    for (var key in name) {
      if (Object.prototype.hasOwnProperty.call(name, key)) this.field(key, name[key]);
    }
    return this;
  }
  if (Array.isArray(val)) {
    for (var i in val) {
      if (Object.prototype.hasOwnProperty.call(val, i)) this.field(name, val[i]);
    }
    return this;
  } // val should be defined now

  if (val === null || undefined === val) {
    throw new Error('.field(name, val) val can not be empty');
  }
  if (typeof val === 'boolean') {
    val = String(val);
  }
  this._getFormData().append(name, val);
  return this;
};
/**
 * Abort the request, and clear potential timeout.
 *
 * @return {Request} request
 * @api public
 */

RequestBase.prototype.abort = function () {
  if (this._aborted) {
    return this;
  }
  this._aborted = true;
  if (this.xhr) this.xhr.abort(); // browser

  if (this.req) this.req.abort(); // node

  this.clearTimeout();
  this.emit('abort');
  return this;
};
RequestBase.prototype._auth = function (user, pass, options, base64Encoder) {
  switch (options.type) {
    case 'basic':
      this.set('Authorization', "Basic ".concat(base64Encoder("".concat(user, ":").concat(pass))));
      break;
    case 'auto':
      this.username = user;
      this.password = pass;
      break;
    case 'bearer':
      // usage would be .auth(accessToken, { type: 'bearer' })
      this.set('Authorization', "Bearer ".concat(user));
      break;
    default:
      break;
  }
  return this;
};
/**
 * Enable transmission of cookies with x-domain requests.
 *
 * Note that for this to work the origin must not be
 * using "Access-Control-Allow-Origin" with a wildcard,
 * and also must set "Access-Control-Allow-Credentials"
 * to "true".
 *
 * @api public
 */

RequestBase.prototype.withCredentials = function (on) {
  // This is browser-only functionality. Node side is no-op.
  if (on === undefined) on = true;
  this._withCredentials = on;
  return this;
};
/**
 * Set the max redirects to `n`. Does nothing in browser XHR implementation.
 *
 * @param {Number} n
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.redirects = function (n) {
  this._maxRedirects = n;
  return this;
};
/**
 * Maximum size of buffered response body, in bytes. Counts uncompressed size.
 * Default 200MB.
 *
 * @param {Number} n number of bytes
 * @return {Request} for chaining
 */

RequestBase.prototype.maxResponseSize = function (n) {
  if (typeof n !== 'number') {
    throw new TypeError('Invalid argument');
  }
  this._maxResponseSize = n;
  return this;
};
/**
 * Convert to a plain javascript object (not JSON string) of scalar properties.
 * Note as this method is designed to return a useful non-this value,
 * it cannot be chained.
 *
 * @return {Object} describing method, url, and data of this request
 * @api public
 */

RequestBase.prototype.toJSON = function () {
  return {
    method: this.method,
    url: this.url,
    data: this._data,
    headers: this._header
  };
};
/**
 * Send `data` as the request body, defaulting the `.type()` to "json" when
 * an object is given.
 *
 * Examples:
 *
 *       // manual json
 *       request.post('/user')
 *         .type('json')
 *         .send('{"name":"tj"}')
 *         .end(callback)
 *
 *       // auto json
 *       request.post('/user')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // manual x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send('name=tj')
 *         .end(callback)
 *
 *       // auto x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // defaults to x-www-form-urlencoded
 *      request.post('/user')
 *        .send('name=tobi')
 *        .send('species=ferret')
 *        .end(callback)
 *
 * @param {String|Object} data
 * @return {Request} for chaining
 * @api public
 */
// eslint-disable-next-line complexity

RequestBase.prototype.send = function (data) {
  var isObj = isObject(data);
  var type = this._header['content-type'];
  if (this._formData) {
    throw new Error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObj && !this._data) {
    if (Array.isArray(data)) {
      this._data = [];
    } else if (!this._isHost(data)) {
      this._data = {};
    }
  } else if (data && this._data && this._isHost(this._data)) {
    throw new Error("Can't merge these send calls");
  } // merge

  if (isObj && isObject(this._data)) {
    for (var key in data) {
      if (Object.prototype.hasOwnProperty.call(data, key)) this._data[key] = data[key];
    }
  } else if (typeof data === 'string') {
    // default to x-www-form-urlencoded
    if (!type) this.type('form');
    type = this._header['content-type'];
    if (type === 'application/x-www-form-urlencoded') {
      this._data = this._data ? "".concat(this._data, "&").concat(data) : data;
    } else {
      this._data = (this._data || '') + data;
    }
  } else {
    this._data = data;
  }
  if (!isObj || this._isHost(data)) {
    return this;
  } // default to json

  if (!type) this.type('json');
  return this;
};
/**
 * Sort `querystring` by the sort function
 *
 *
 * Examples:
 *
 *       // default order
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery()
 *         .end(callback)
 *
 *       // customized sort function
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery(function(a, b){
 *           return a.length - b.length;
 *         })
 *         .end(callback)
 *
 *
 * @param {Function} sort
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.sortQuery = function (sort) {
  // _sort default to true but otherwise can be a function or boolean
  this._sort = typeof sort === 'undefined' ? true : sort;
  return this;
};
/**
 * Compose querystring to append to req.url
 *
 * @api private
 */

RequestBase.prototype._finalizeQueryString = function () {
  var query = this._query.join('&');
  if (query) {
    this.url += (this.url.includes('?') ? '&' : '?') + query;
  }
  this._query.length = 0; // Makes the call idempotent

  if (this._sort) {
    var index = this.url.indexOf('?');
    if (index >= 0) {
      var queryArr = this.url.slice(index + 1).split('&');
      if (typeof this._sort === 'function') {
        queryArr.sort(this._sort);
      } else {
        queryArr.sort();
      }
      this.url = this.url.slice(0, index) + '?' + queryArr.join('&');
    }
  }
}; // For backwards compat only

RequestBase.prototype._appendQueryString = function () {
  console.warn('Unsupported');
};
/**
 * Invoke callback with timeout error.
 *
 * @api private
 */

RequestBase.prototype._timeoutError = function (reason, timeout, errno) {
  if (this._aborted) {
    return;
  }
  var err = new Error("".concat(reason + timeout, "ms exceeded"));
  err.timeout = timeout;
  err.code = 'ECONNABORTED';
  err.errno = errno;
  this.timedout = true;
  this.timedoutError = err;
  this.abort();
  this.callback(err);
};
RequestBase.prototype._setTimeouts = function () {
  var self = this; // deadline

  if (this._timeout && !this._timer) {
    this._timer = setTimeout(function () {
      self._timeoutError('Timeout of ', self._timeout, 'ETIME');
    }, this._timeout);
  } // response timeout

  if (this._responseTimeout && !this._responseTimeoutTimer) {
    this._responseTimeoutTimer = setTimeout(function () {
      self._timeoutError('Response timeout of ', self._responseTimeout, 'ETIMEDOUT');
    }, this._responseTimeout);
  }
};

/***/ }),

/***/ "422b":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("e260");
__webpack_require__("d3b7");
__webpack_require__("3ca3");
__webpack_require__("ddb0");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Check if `obj` is an object.
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
function isObject(obj) {
  return obj !== null && _typeof(obj) === 'object';
}
module.exports = isObject;

/***/ }),

/***/ "8d5f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Return the mime type for the given `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */
__webpack_require__("fb6a");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("1276");
exports.type = function (str) {
  return str.split(/ *; */).shift();
};
/**
 * Return header field parameters.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.params = function (str) {
  return str.split(/ *; */).reduce(function (obj, str) {
    var parts = str.split(/ *= */);
    var key = parts.shift();
    var val = parts.shift();
    if (key && val) obj[key] = val;
    return obj;
  }, {});
};
/**
 * Parse Link header fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.parseLinks = function (str) {
  return str.split(/ *, */).reduce(function (obj, str) {
    var parts = str.split(/ *; */);
    var url = parts[0].slice(1, -1);
    var rel = parts[1].split(/ *= */)[1].slice(1, -1);
    obj[rel] = url;
    return obj;
  }, {});
};
/**
 * Strip content related fields from `header`.
 *
 * @param {Object} header
 * @return {Object} header
 * @api private
 */

exports.cleanHeader = function (header, changesOrigin) {
  delete header['content-type'];
  delete header['content-length'];
  delete header['transfer-encoding'];
  delete header.host; // secuirty

  if (changesOrigin) {
    delete header.authorization;
    delete header.cookie;
  }
  return header;
};

/***/ }),

/***/ "b28c":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("a630");
__webpack_require__("e260");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("3ca3");
__webpack_require__("159b");
__webpack_require__("ddb0");
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function Agent() {
  this._defaults = [];
}
['use', 'on', 'once', 'set', 'query', 'type', 'accept', 'auth', 'withCredentials', 'sortQuery', 'retry', 'ok', 'redirects', 'timeout', 'buffer', 'serialize', 'parse', 'ca', 'key', 'pfx', 'cert', 'disableTLSCerts'].forEach(function (fn) {
  // Default setting for all requests from this agent
  Agent.prototype[fn] = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    this._defaults.push({
      fn: fn,
      args: args
    });
    return this;
  };
});
Agent.prototype._setDefaults = function (req) {
  this._defaults.forEach(function (def) {
    req[def.fn].apply(req, _toConsumableArray(def.args));
  });
};
module.exports = Agent;

/***/ }),

/***/ "d672":
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, module) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;var _classCallCheck = __webpack_require__("970b").default;
var _createClass = __webpack_require__("5bc3").default;
var _typeof = __webpack_require__("7037").default;
__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("944a");
__webpack_require__("d9e2");
__webpack_require__("4de4");
__webpack_require__("caad");
__webpack_require__("a15b");
__webpack_require__("d81d");
__webpack_require__("b0c0");
__webpack_require__("6c57");
__webpack_require__("0c47");
__webpack_require__("23dc");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("ac1f");
__webpack_require__("25f0");
__webpack_require__("466d");
__webpack_require__("5319");
__webpack_require__("159b");
__webpack_require__("c73d");
(function (p, v) {
  ( false ? undefined : _typeof(exports)) == "object" && ( false ? undefined : _typeof(module)) < "u" ? v(exports, __webpack_require__("ddae")) :  true ? !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__("ddae")], __WEBPACK_AMD_DEFINE_FACTORY__ = (v),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)) : (undefined);
})(this, function (p, v) {
  "use strict";

  var Ve = Object.defineProperty;
  var Qe = function Qe(p, v, r) {
    return v in p ? Ve(p, v, {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: r
    }) : p[v] = r;
  };
  var ye = function ye(p, v, r) {
    return Qe(p, _typeof(v) != "symbol" ? v + "" : v, r), r;
  };
  var h = /*#__PURE__*/function () {
    function h() {
      _classCallCheck(this, h);
      this.basePath = "/".replace(/\/+$/, ""), this.authentications = {
        oauth2: {
          type: "oauth2"
        }
      }, this.defaultHeaders = {}, this.timeout = 6e4, this.cache = !0, this.enableCookies = !1, (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && (this.agent = new v.agent()), this.requestAgent = null;
    }
    return _createClass(h, [{
      key: "paramToString",
      value: function paramToString(e) {
        return e == null || e == null ? "" : e instanceof Date ? e.toJSON() : e.toString();
      }
    }, {
      key: "buildUrl",
      value: function buildUrl(e, t) {
        var _this = this;
        e.match(/^\//) || (e = "/" + e);
        var o = this.basePath + e;
        return o = o.replace(/\{([\w-]+)\}/g, function (n, i) {
          var s;
          return t.hasOwnProperty(i) ? s = _this.paramToString(t[i]) : s = n, encodeURIComponent(s);
        }), o;
      }
    }, {
      key: "isJsonMime",
      value: function isJsonMime(e) {
        return !!(e != null && e.match(/^application\/json(;.*)?$/i));
      }
    }, {
      key: "jsonPreferredMime",
      value: function jsonPreferredMime(e) {
        for (var t = 0; t < e.length; t++) if (this.isJsonMime(e[t])) return e[t];
        return e[0];
      }
    }, {
      key: "isFileParam",
      value: function isFileParam(e) {
        if (true) {
          var t;
          try {
            t = __webpack_require__(0);
          } catch (_unused) {}
          if (t && t.ReadStream && e instanceof t.ReadStream) return !0;
        }
        return typeof Buffer == "function" && e instanceof Buffer || typeof Blob == "function" && e instanceof Blob || typeof File == "function" && e instanceof File;
      }
    }, {
      key: "normalizeParams",
      value: function normalizeParams(e) {
        var t = {};
        for (var o in e) if (e.hasOwnProperty(o) && e[o] != null && e[o] != null) {
          var n = e[o];
          this.isFileParam(n) || Array.isArray(n) ? t[o] = n : t[o] = this.paramToString(n);
        }
        return t;
      }
    }, {
      key: "buildCollectionParam",
      value: function buildCollectionParam(e, t) {
        if (e == null) return null;
        switch (t) {
          case "csv":
            return e.map(this.paramToString).join(",");
          case "ssv":
            return e.map(this.paramToString).join(" ");
          case "tsv":
            return e.map(this.paramToString).join("	");
          case "pipes":
            return e.map(this.paramToString).join("|");
          case "multi":
            return e.map(this.paramToString);
          default:
            throw new Error("Unknown collection format: " + t);
        }
      }
    }, {
      key: "applyAuthToRequest",
      value: function applyAuthToRequest(e, t) {
        var _this2 = this;
        t.forEach(function (o) {
          var n = _this2.authentications[o];
          switch (n.type) {
            case "basic":
              (n.username || n.password) && e.auth(n.username || "", n.password || "");
              break;
            case "apiKey":
              if (n.apiKey) {
                var i = {};
                n.apiKeyPrefix ? i[n.name] = n.apiKeyPrefix + " " + n.apiKey : i[n.name] = n.apiKey, n.in === "header" ? e.set(i) : e.query(i);
              }
              break;
            case "oauth2":
              n.accessToken && e.set({
                Authorization: "Bearer " + n.accessToken
              });
              break;
            default:
              throw new Error("Unknown authentication type: " + n.type);
          }
        });
      }
    }, {
      key: "deserialize",
      value: function deserialize(e, t) {
        if (e == null || e.status == 204) return null;
        var o = e.body;
        if ((o == null || _typeof(o) == "object" && _typeof(o.length) > "u" && !Object.keys(o).length) && (o = e.text), t == null && ["easc3"].includes("guang-xi-shi-hua")) return {
          data: o
        };
        var n = h.convertToType(o.data, t);
        return {
          code: o.code,
          data: n
        };
      }
    }, {
      key: "callApi",
      value: function callApi(e, t, o, n, i, s, c, l, a, u, Fe) {
        var _this3 = this;
        var Me = this.buildUrl(e, o),
          T = v(t, Me);
        this.applyAuthToRequest(T, l), t.toUpperCase() === "GET" && this.cache === !1 && (n._ = new Date().getTime()), T.query(this.normalizeParams(n)), T.set(this.defaultHeaders).set(this.normalizeParams(i)), this.requestAgent && T.agent(this.requestAgent), T.timeout(this.timeout);
        var Ne = this.jsonPreferredMime(a);
        if (Ne ? Ne != "multipart/form-data" && T.type(Ne) : T.header["Content-Type"] || T.type("application/json"), Ne === "application/x-www-form-urlencoded") T.send(h.stringify(this.normalizeParams(s)));else if (Ne == "multipart/form-data") {
          var Le = this.normalizeParams(s);
          for (var De in Le) Le.hasOwnProperty(De) && (this.isFileParam(Le[De]) ? T.attach(De, Le[De]) : T.field(De, Le[De]));
        } else c && T.send(c);
        var ze = this.jsonPreferredMime(u);
        return ze && T.accept(ze), Fe === "Blob" ? T.responseType("blob") : Fe === "String" && T.responseType("string"), this.enableCookies && ((typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" ? this.agent.attachCookies(T) : T.withCredentials()), new Promise(function (qe, _e) {
          T.end(function (Ue, xe) {
            if (Ue) _e(Ue);else try {
              var Ke = _this3.deserialize(xe, Fe);
              _this3.enableCookies && (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && _this3.agent.saveCookies(xe), qe({
                data: Ke,
                response: xe
              });
            } catch (Ge) {
              _e(Ge);
            }
          });
        });
      }
    }], [{
      key: "parseDate",
      value: function parseDate(e) {
        return new Date(e);
      }
    }, {
      key: "convertToType",
      value: function convertToType(e, t) {
        if (e == null) return e;
        switch (t) {
          case "Boolean":
            return !!e;
          case "Integer":
            return parseInt(e, 10);
          case "Number":
            return parseFloat(e);
          case "String":
            return String(e);
          case "Date":
            return h.parseDate(String(e));
          case "Blob":
            return e;
          default:
            if (t === Object) return e;
            if (typeof t == "function") return t.constructFromObject(e);
            if (Array.isArray(t)) {
              var o = t[0];
              return e.map(function (u) {
                return h.convertToType(u, o);
              });
            } else if (_typeof(t) == "object") {
              var n, i;
              for (var s in t) if (t.hasOwnProperty(s)) {
                n = s, i = t[s];
                break;
              }
              var c = {};
              for (var s in e) if (e.hasOwnProperty(s)) {
                var l = h.convertToType(s, n),
                  a = h.convertToType(e[s], i);
                c[l] = a;
              }
              return c;
            } else return e;
        }
      }
    }, {
      key: "constructFromObject",
      value: function constructFromObject(e, t, o) {
        if (Array.isArray(e)) for (var n = 0; n < e.length; n++) e.hasOwnProperty(n) && (t[n] = h.convertToType(e[n], o));else for (var i in e) e.hasOwnProperty(i) && (t[i] = h.convertToType(e[i], o));
      }
    }, {
      key: "GetInstance",
      value: function GetInstance(e, t) {
        return Wiz ? Wiz.GetApiClientInstance(e, t) : new h();
      }
    }, {
      key: "stringifyPrimitive",
      value: function stringifyPrimitive(e) {
        switch (_typeof(e)) {
          case "string":
            return e;
          case "boolean":
            return e ? "true" : "false";
          case "number":
            return isFinite(e) ? e : "";
          default:
            return "";
        }
      }
    }, {
      key: "stringify",
      value: function stringify(e, t, o, n) {
        return t = t || "&", o = o || "=", e === null && (e = void 0), _typeof(e) == "object" ? Object.keys(e).map(function (i) {
          var s = encodeURIComponent(h.stringifyPrimitive(i)) + o;
          return Array.isArray(e[i]) ? e[i].map(function (c) {
            return s + encodeURIComponent(h.stringifyPrimitive(c));
          }).join(t) : s + encodeURIComponent(h.stringifyPrimitive(e[i]));
        }).filter(Boolean).join(t) : n ? encodeURIComponent(h.stringifyPrimitive(n)) + o + encodeURIComponent(h.stringifyPrimitive(e)) : "";
      }
    }]);
  }();
  ye(h, "CollectionFormatEnum", {
    CSV: ",",
    SSV: " ",
    TSV: "	",
    PIPES: "|",
    MULTI: "multi"
  });
  var r = h;
  var N = /*#__PURE__*/function () {
    function N() {
      _classCallCheck(this, N);
    }
    return _createClass(N, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new N(), e.hasOwnProperty("formEngineKey") && (t.formEngineKey = r.convertToType(e.formEngineKey, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("type") && (t.type = r.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = r.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  N.prototype.formEngineKey = void 0, N.prototype.name = void 0, N.prototype.type = void 0, N.prototype.value = void 0;
  var H = /*#__PURE__*/function () {
    function H() {
      _classCallCheck(this, H);
    }
    return _createClass(H, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new H(), e.hasOwnProperty("ModuleEngineKey") && (t.moduleEngineKey = r.convertToType(e.ModuleEngineKey, "String")), e.hasOwnProperty("_PageIndex") && (t.pageIndex = r.convertToType(e._PageIndex, "Number")), e.hasOwnProperty("_PageSize") && (t.pageSize = r.convertToType(e._PageSize, "Number")), e.hasOwnProperty("_SearchDateTime.CreateTime") && (t.searchDateTimeCreateTime = r.convertToType(e["_SearchDateTime.CreateTime"], ["Date"])), e.hasOwnProperty("_Where") && (t.where = r.convertToType(e._Where, [N]))), t;
      }
    }]);
  }();
  H.prototype.moduleEngineKey = void 0, H.prototype.pageIndex = void 0, H.prototype.pageSize = void 0, H.prototype.searchDateTimeCreateTime = void 0, H.prototype.where = void 0;
  var z = /*#__PURE__*/function () {
    function z() {
      _classCallCheck(this, z);
    }
    return _createClass(z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new z(), e.hasOwnProperty("ModuleEngineKey") && (t.moduleEngineKey = r.convertToType(e.ModuleEngineKey, "String")), e.hasOwnProperty("_PageIndex") && (t.pageIndex = r.convertToType(e._PageIndex, "Number")), e.hasOwnProperty("_PageSize") && (t.pageSize = r.convertToType(e._PageSize, "Number")), e.hasOwnProperty("_SearchDateTime.CreateTime") && (t.searchDateTimeCreateTime = r.convertToType(e["_SearchDateTime.CreateTime"], ["Date"])), e.hasOwnProperty("_Where") && (t.where = r.convertToType(e._Where, [N]))), t;
      }
    }]);
  }();
  z.prototype.moduleEngineKey = void 0, z.prototype.pageIndex = void 0, z.prototype.pageSize = void 0, z.prototype.searchDateTimeCreateTime = void 0, z.prototype.where = void 0;
  var y = /*#__PURE__*/function () {
    function y() {
      _classCallCheck(this, y);
    }
    return _createClass(y, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new y(), e.hasOwnProperty("createTime") && (t.createTime = r.convertToType(e.createTime, "Date")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = r.convertToType(e.isDeleted, "Number")), e.hasOwnProperty("pr_BlindPlateId") && (t.prBlindPlateId = r.convertToType(e.pr_BlindPlateId, "String")), e.hasOwnProperty("pr_ChangeStatus") && (t.prChangeStatus = r.convertToType(e.pr_ChangeStatus, "String")), e.hasOwnProperty("pr_Code") && (t.prCode = r.convertToType(e.pr_Code, "String")), e.hasOwnProperty("pr_ConfirmTime") && (t.prConfirmTime = r.convertToType(e.pr_ConfirmTime, "Date")), e.hasOwnProperty("pr_Confirmer") && (t.prConfirmer = r.convertToType(e.pr_Confirmer, "String")), e.hasOwnProperty("pr_Dept") && (t.prDept = r.convertToType(e.pr_Dept, "String")), e.hasOwnProperty("pr_Device") && (t.prDevice = r.convertToType(e.pr_Device, "String")), e.hasOwnProperty("pr_FlowStatus") && (t.prFlowStatus = r.convertToType(e.pr_FlowStatus, "String")), e.hasOwnProperty("pr_MaterialQuality") && (t.prMaterialQuality = r.convertToType(e.pr_MaterialQuality, "String")), e.hasOwnProperty("pr_Medium") && (t.prMedium = r.convertToType(e.pr_Medium, "String")), e.hasOwnProperty("pr_Operator") && (t.prOperator = r.convertToType(e.pr_Operator, "String")), e.hasOwnProperty("pr_Pid") && (t.prPid = r.convertToType(e.pr_Pid, "String")), e.hasOwnProperty("pr_Position") && (t.prPosition = r.convertToType(e.pr_Position, "String")), e.hasOwnProperty("pr_PositionDescription") && (t.prPositionDescription = r.convertToType(e.pr_PositionDescription, "String")), e.hasOwnProperty("pr_PressureLevel") && (t.prPressureLevel = r.convertToType(e.pr_PressureLevel, "String")), e.hasOwnProperty("pr_Shape") && (t.prShape = r.convertToType(e.pr_Shape, "String")), e.hasOwnProperty("pr_Specifications") && (t.prSpecifications = r.convertToType(e.pr_Specifications, "String")), e.hasOwnProperty("pr_Status") && (t.prStatus = r.convertToType(e.pr_Status, "String")), e.hasOwnProperty("pr_Type") && (t.prType = r.convertToType(e.pr_Type, "String")), e.hasOwnProperty("updateTime") && (t.updateTime = r.convertToType(e.updateTime, "Date")), e.hasOwnProperty("userId") && (t.userId = r.convertToType(e.userId, "String")), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String"))), t;
      }
    }]);
  }();
  y.prototype.createTime = void 0, y.prototype.id = void 0, y.prototype.isDeleted = void 0, y.prototype.prBlindPlateId = void 0, y.prototype.prChangeStatus = void 0, y.prototype.prCode = void 0, y.prototype.prConfirmTime = void 0, y.prototype.prConfirmer = void 0, y.prototype.prDept = void 0, y.prototype.prDevice = void 0, y.prototype.prFlowStatus = void 0, y.prototype.prMaterialQuality = void 0, y.prototype.prMedium = void 0, y.prototype.prOperator = void 0, y.prototype.prPid = void 0, y.prototype.prPosition = void 0, y.prototype.prPositionDescription = void 0, y.prototype.prPressureLevel = void 0, y.prototype.prShape = void 0, y.prototype.prSpecifications = void 0, y.prototype.prStatus = void 0, y.prototype.prType = void 0, y.prototype.updateTime = void 0, y.prototype.userId = void 0, y.prototype.userName = void 0;
  var F = /*#__PURE__*/function () {
    function F() {
      _classCallCheck(this, F);
    }
    return _createClass(F, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new F(), e.hasOwnProperty("Code") && (t.code = r.convertToType(e.Code, "Number")), e.hasOwnProperty("Data") && (t.data = r.convertToType(e.Data, [y])), e.hasOwnProperty("DataAppend") && (t.dataAppend = r.convertToType(e.DataAppend, Object)), e.hasOwnProperty("DataCount") && (t.dataCount = r.convertToType(e.DataCount, "Number")), e.hasOwnProperty("Msg") && (t.msg = r.convertToType(e.Msg, "String"))), t;
      }
    }]);
  }();
  F.prototype.code = void 0, F.prototype.data = void 0, F.prototype.dataAppend = void 0, F.prototype.dataCount = void 0, F.prototype.msg = void 0;
  var m = /*#__PURE__*/function () {
    function m() {
      _classCallCheck(this, m);
    }
    return _createClass(m, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new m(), e.hasOwnProperty("createTime") && (t.createTime = r.convertToType(e.createTime, "Date")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = r.convertToType(e.isDeleted, "Number")), e.hasOwnProperty("pr_Code") && (t.prCode = r.convertToType(e.pr_Code, "String")), e.hasOwnProperty("pr_MaterialQuality") && (t.prMaterialQuality = r.convertToType(e.pr_MaterialQuality, "String")), e.hasOwnProperty("pr_Medium") && (t.prMedium = r.convertToType(e.pr_Medium, "String")), e.hasOwnProperty("pr_Pid") && (t.prPid = r.convertToType(e.pr_Pid, "String")), e.hasOwnProperty("pr_PositionDescription") && (t.prPositionDescription = r.convertToType(e.pr_PositionDescription, "String")), e.hasOwnProperty("pr_PressureLevel") && (t.prPressureLevel = r.convertToType(e.pr_PressureLevel, "String")), e.hasOwnProperty("pr_Shape") && (t.prShape = r.convertToType(e.pr_Shape, "String")), e.hasOwnProperty("pr_Specifications") && (t.prSpecifications = r.convertToType(e.pr_Specifications, "String")), e.hasOwnProperty("pr_Status") && (t.prStatus = r.convertToType(e.pr_Status, "String")), e.hasOwnProperty("pr_Type") && (t.prType = r.convertToType(e.pr_Type, "String")), e.hasOwnProperty("updateTime") && (t.updateTime = r.convertToType(e.updateTime, "Date")), e.hasOwnProperty("userId") && (t.userId = r.convertToType(e.userId, "String")), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String"))), t;
      }
    }]);
  }();
  m.prototype.createTime = void 0, m.prototype.id = void 0, m.prototype.isDeleted = void 0, m.prototype.prCode = void 0, m.prototype.prMaterialQuality = void 0, m.prototype.prMedium = void 0, m.prototype.prPid = void 0, m.prototype.prPositionDescription = void 0, m.prototype.prPressureLevel = void 0, m.prototype.prShape = void 0, m.prototype.prSpecifications = void 0, m.prototype.prStatus = void 0, m.prototype.prType = void 0, m.prototype.updateTime = void 0, m.prototype.userId = void 0, m.prototype.userName = void 0;
  var x = /*#__PURE__*/function () {
    function x() {
      _classCallCheck(this, x);
    }
    return _createClass(x, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new x(), e.hasOwnProperty("Code") && (t.code = r.convertToType(e.Code, "Number")), e.hasOwnProperty("Data") && (t.data = r.convertToType(e.Data, [m])), e.hasOwnProperty("DataAppend") && (t.dataAppend = r.convertToType(e.DataAppend, Object)), e.hasOwnProperty("DataCount") && (t.dataCount = r.convertToType(e.DataCount, "Number")), e.hasOwnProperty("Msg") && (t.msg = r.convertToType(e.Msg, "String"))), t;
      }
    }]);
  }();
  x.prototype.code = void 0, x.prototype.data = void 0, x.prototype.dataAppend = void 0, x.prototype.dataCount = void 0, x.prototype.msg = void 0;
  var d = /*#__PURE__*/function () {
    function d() {
      _classCallCheck(this, d);
    }
    return _createClass(d, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new d(), e.hasOwnProperty("DeviceNameStr") && (t.deviceNameStr = r.convertToType(e.DeviceNameStr, "String")), e.hasOwnProperty("createTime") && (t.createTime = r.convertToType(e.createTime, "Date")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = r.convertToType(e.isDeleted, "Number")), e.hasOwnProperty("pr_ActualFinishedDate") && (t.prActualFinishedDate = r.convertToType(e.pr_ActualFinishedDate, "Date")), e.hasOwnProperty("pr_CreatedUserId") && (t.prCreatedUserId = r.convertToType(e.pr_CreatedUserId, "String")), e.hasOwnProperty("pr_Description") && (t.prDescription = r.convertToType(e.pr_Description, "String")), e.hasOwnProperty("pr_Device") && (t.prDevice = r.convertToType(e.pr_Device, "String")), e.hasOwnProperty("pr_DisciplineId") && (t.prDisciplineId = r.convertToType(e.pr_DisciplineId, "String")), e.hasOwnProperty("pr_FlowStatus") && (t.prFlowStatus = r.convertToType(e.pr_FlowStatus, "String")), e.hasOwnProperty("pr_HandledUserDept") && (t.prHandledUserDept = r.convertToType(e.pr_HandledUserDept, "String")), e.hasOwnProperty("pr_HandledUserId") && (t.prHandledUserId = r.convertToType(e.pr_HandledUserId, "String")), e.hasOwnProperty("pr_Level") && (t.prLevel = r.convertToType(e.pr_Level, "String")), e.hasOwnProperty("pr_PlanFinisedDate") && (t.prPlanFinisedDate = r.convertToType(e.pr_PlanFinisedDate, "Date")), e.hasOwnProperty("pr_Position") && (t.prPosition = r.convertToType(e.pr_Position, "String")), e.hasOwnProperty("pr_Solution") && (t.prSolution = r.convertToType(e.pr_Solution, "String")), e.hasOwnProperty("pr_Type") && (t.prType = r.convertToType(e.pr_Type, "String")), e.hasOwnProperty("pr_VerifiedDate") && (t.prVerifiedDate = r.convertToType(e.pr_VerifiedDate, "Date")), e.hasOwnProperty("pr_VerifiedUserId") && (t.prVerifiedUserId = r.convertToType(e.pr_VerifiedUserId, "String")), e.hasOwnProperty("updateTime") && (t.updateTime = r.convertToType(e.updateTime, "Date")), e.hasOwnProperty("userId") && (t.userId = r.convertToType(e.userId, "String")), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String"))), t;
      }
    }]);
  }();
  d.prototype.deviceNameStr = void 0, d.prototype.createTime = void 0, d.prototype.id = void 0, d.prototype.isDeleted = void 0, d.prototype.prActualFinishedDate = void 0, d.prototype.prCreatedUserId = void 0, d.prototype.prDescription = void 0, d.prototype.prDevice = void 0, d.prototype.prDisciplineId = void 0, d.prototype.prFlowStatus = void 0, d.prototype.prHandledUserDept = void 0, d.prototype.prHandledUserId = void 0, d.prototype.prLevel = void 0, d.prototype.prPlanFinisedDate = void 0, d.prototype.prPosition = void 0, d.prototype.prSolution = void 0, d.prototype.prType = void 0, d.prototype.prVerifiedDate = void 0, d.prototype.prVerifiedUserId = void 0, d.prototype.updateTime = void 0, d.prototype.userId = void 0, d.prototype.userName = void 0;
  var B = /*#__PURE__*/function () {
    function B() {
      _classCallCheck(this, B);
    }
    return _createClass(B, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new B(), e.hasOwnProperty("Code") && (t.code = r.convertToType(e.Code, "Number")), e.hasOwnProperty("Data") && (t.data = r.convertToType(e.Data, [d])), e.hasOwnProperty("DataAppend") && (t.dataAppend = r.convertToType(e.DataAppend, Object)), e.hasOwnProperty("DataCount") && (t.dataCount = r.convertToType(e.DataCount, "Number")), e.hasOwnProperty("Msg") && (t.msg = r.convertToType(e.Msg, "String"))), t;
      }
    }]);
  }();
  B.prototype.code = void 0, B.prototype.data = void 0, B.prototype.dataAppend = void 0, B.prototype.dataCount = void 0, B.prototype.msg = void 0;
  var P = /*#__PURE__*/function () {
    function P() {
      _classCallCheck(this, P);
    }
    return _createClass(P, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new P(), e.hasOwnProperty("deviceCode") && (t.deviceCode = r.convertToType(e.deviceCode, "String")), e.hasOwnProperty("deviceName") && (t.deviceName = r.convertToType(e.deviceName, "String")), e.hasOwnProperty("direction") && (t.direction = r.convertToType(e.direction, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("medium") && (t.medium = r.convertToType(e.medium, "String")), e.hasOwnProperty("mediumPhase") && (t.mediumPhase = r.convertToType(e.mediumPhase, "String")), e.hasOwnProperty("modelId") && (t.modelId = r.convertToType(e.modelId, "String")), e.hasOwnProperty("modelName") && (t.modelName = r.convertToType(e.modelName, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String")), e.hasOwnProperty("tagId") && (t.tagId = r.convertToType(e.tagId, "String")), e.hasOwnProperty("tagName") && (t.tagName = r.convertToType(e.tagName, "String"))), t;
      }
    }]);
  }();
  P.prototype.deviceCode = void 0, P.prototype.deviceName = void 0, P.prototype.direction = void 0, P.prototype.id = void 0, P.prototype.medium = void 0, P.prototype.mediumPhase = void 0, P.prototype.modelId = void 0, P.prototype.modelName = void 0, P.prototype.tagCode = void 0, P.prototype.tagId = void 0, P.prototype.tagName = void 0;
  var de = /*#__PURE__*/function () {
    function de() {
      _classCallCheck(this, de);
    }
    return _createClass(de, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new de(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [P])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  de.prototype.items = void 0, de.prototype.totalCount = void 0;
  var O = /*#__PURE__*/function () {
    function O() {
      _classCallCheck(this, O);
    }
    return _createClass(O, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new O(), e.hasOwnProperty("className") && (t.className = r.convertToType(e.className, "String")), e.hasOwnProperty("deviceCode") && (t.deviceCode = r.convertToType(e.deviceCode, "String")), e.hasOwnProperty("deviceName") && (t.deviceName = r.convertToType(e.deviceName, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("modelId") && (t.modelId = r.convertToType(e.modelId, "String")), e.hasOwnProperty("modelName") && (t.modelName = r.convertToType(e.modelName, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String")), e.hasOwnProperty("tagId") && (t.tagId = r.convertToType(e.tagId, "String")), e.hasOwnProperty("tagName") && (t.tagName = r.convertToType(e.tagName, "String"))), t;
      }
    }]);
  }();
  O.prototype.className = void 0, O.prototype.deviceCode = void 0, O.prototype.deviceName = void 0, O.prototype.id = void 0, O.prototype.modelId = void 0, O.prototype.modelName = void 0, O.prototype.tagCode = void 0, O.prototype.tagId = void 0, O.prototype.tagName = void 0;
  var fe = /*#__PURE__*/function () {
    function fe() {
      _classCallCheck(this, fe);
    }
    return _createClass(fe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new fe(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [O])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  fe.prototype.items = void 0, fe.prototype.totalCount = void 0;
  var R = /*#__PURE__*/function () {
    function R() {
      _classCallCheck(this, R);
    }
    return _createClass(R, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new R(), e.hasOwnProperty("cause") && (t.cause = r.convertToType(e.cause, "String")), e.hasOwnProperty("documentClassCode") && (t.documentClassCode = r.convertToType(e.documentClassCode, "String")), e.hasOwnProperty("documentCode") && (t.documentCode = r.convertToType(e.documentCode, "String")), e.hasOwnProperty("tagClassName") && (t.tagClassName = r.convertToType(e.tagClassName, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  R.prototype.cause = void 0, R.prototype.documentClassCode = void 0, R.prototype.documentCode = void 0, R.prototype.tagClassName = void 0, R.prototype.tagCode = void 0;
  var me = /*#__PURE__*/function () {
    function me() {
      _classCallCheck(this, me);
    }
    return _createClass(me, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new me(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [R])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  me.prototype.items = void 0, me.prototype.totalCount = void 0;
  var w = /*#__PURE__*/function () {
    function w() {
      _classCallCheck(this, w);
    }
    return _createClass(w, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new w(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("insulationThickness") && (t.insulationThickness = r.convertToType(e.insulationThickness, "String")), e.hasOwnProperty("length") && (t.length = r.convertToType(e.length, "String")), e.hasOwnProperty("medium") && (t.medium = r.convertToType(e.medium, "String")), e.hasOwnProperty("mediumPhase") && (t.mediumPhase = r.convertToType(e.mediumPhase, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("nominalSize") && (t.nominalSize = r.convertToType(e.nominalSize, "String")), e.hasOwnProperty("pressure") && (t.pressure = r.convertToType(e.pressure, "String"))), t;
      }
    }]);
  }();
  w.prototype.code = void 0, w.prototype.insulationThickness = void 0, w.prototype.length = void 0, w.prototype.medium = void 0, w.prototype.mediumPhase = void 0, w.prototype.name = void 0, w.prototype.nominalSize = void 0, w.prototype.pressure = void 0;
  var Te = /*#__PURE__*/function () {
    function Te() {
      _classCallCheck(this, Te);
    }
    return _createClass(Te, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Te(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [w])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  Te.prototype.items = void 0, Te.prototype.totalCount = void 0;
  var f = /*#__PURE__*/function () {
    function f() {
      _classCallCheck(this, f);
    }
    return _createClass(f, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new f(), e.hasOwnProperty("attachmentBeford") && (t.attachmentBeford = r.convertToType(e.attachmentBeford, "String")), e.hasOwnProperty("createdUser") && (t.createdUser = r.convertToType(e.createdUser, "String")), e.hasOwnProperty("createdUserDept") && (t.createdUserDept = r.convertToType(e.createdUserDept, "String")), e.hasOwnProperty("description") && (t.description = r.convertToType(e.description, "String")), e.hasOwnProperty("device") && (t.device = r.convertToType(e.device, "String")), e.hasOwnProperty("discipline") && (t.discipline = r.convertToType(e.discipline, "String")), e.hasOwnProperty("handledUser") && (t.handledUser = r.convertToType(e.handledUser, "String")), e.hasOwnProperty("handledUserDept") && (t.handledUserDept = r.convertToType(e.handledUserDept, "String")), e.hasOwnProperty("icon") && (t.icon = r.convertToType(e.icon, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isShow") && (t.isShow = r.convertToType(e.isShow, "Number")), e.hasOwnProperty("level") && (t.level = r.convertToType(e.level, "String")), e.hasOwnProperty("planFinisedDate") && (t.planFinisedDate = r.convertToType(e.planFinisedDate, "Date")), e.hasOwnProperty("pointId") && (t.pointId = r.convertToType(e.pointId, "String")), e.hasOwnProperty("position") && (t.position = r.convertToType(e.position, "String")), e.hasOwnProperty("solution") && (t.solution = r.convertToType(e.solution, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String")), e.hasOwnProperty("type") && (t.type = r.convertToType(e.type, "String")), e.hasOwnProperty("verifiedUser") && (t.verifiedUser = r.convertToType(e.verifiedUser, "String")), e.hasOwnProperty("verifiedUserDept") && (t.verifiedUserDept = r.convertToType(e.verifiedUserDept, "String")), e.hasOwnProperty("visualAngle") && (t.visualAngle = r.convertToType(e.visualAngle, "String"))), t;
      }
    }]);
  }();
  f.prototype.attachmentBeford = void 0, f.prototype.createdUser = void 0, f.prototype.createdUserDept = void 0, f.prototype.description = void 0, f.prototype.device = void 0, f.prototype.discipline = void 0, f.prototype.handledUser = void 0, f.prototype.handledUserDept = void 0, f.prototype.icon = void 0, f.prototype.id = void 0, f.prototype.isShow = void 0, f.prototype.level = void 0, f.prototype.planFinisedDate = void 0, f.prototype.pointId = void 0, f.prototype.position = void 0, f.prototype.solution = void 0, f.prototype.tagCode = void 0, f.prototype.type = void 0, f.prototype.verifiedUser = void 0, f.prototype.verifiedUserDept = void 0, f.prototype.visualAngle = void 0;
  var he = /*#__PURE__*/function () {
    function he() {
      _classCallCheck(this, he);
    }
    return _createClass(he, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new he(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [f])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  he.prototype.items = void 0, he.prototype.totalCount = void 0;
  var _ = /*#__PURE__*/function () {
    function _() {
      _classCallCheck(this, _);
    }
    return _createClass(_, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new _(), e.hasOwnProperty("count") && (t.count = r.convertToType(e.count, "Number")), e.hasOwnProperty("fileName") && (t.fileName = r.convertToType(e.fileName, "String")), e.hasOwnProperty("object") && (t._object = r.convertToType(e.object, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  _.prototype.count = void 0, _.prototype.fileName = void 0, _.prototype._object = void 0, _.prototype.tagCode = void 0;
  var Pe = /*#__PURE__*/function () {
    function Pe() {
      _classCallCheck(this, Pe);
    }
    return _createClass(Pe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Pe(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [_])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  Pe.prototype.items = void 0, Pe.prototype.totalCount = void 0;
  var k = /*#__PURE__*/function () {
    function k() {
      _classCallCheck(this, k);
    }
    return _createClass(k, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new k(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String"))), t;
      }
    }]);
  }();
  k.prototype.code = void 0, k.prototype.id = void 0, k.prototype.name = void 0;
  var ge = /*#__PURE__*/function () {
    function ge() {
      _classCallCheck(this, ge);
    }
    return _createClass(ge, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ge(), e.hasOwnProperty("items") && (t.items = r.convertToType(e.items, [k])), e.hasOwnProperty("totalCount") && (t.totalCount = r.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  ge.prototype.items = void 0, ge.prototype.totalCount = void 0;
  var L = /*#__PURE__*/function () {
    function L() {
      _classCallCheck(this, L);
    }
    return _createClass(L, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new L(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("deviceId") && (t.deviceId = r.convertToType(e.deviceId, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isValid") && (t.isValid = r.convertToType(e.isValid, "Number")), e.hasOwnProperty("maxResultCount") && (t.maxResultCount = r.convertToType(e.maxResultCount, "Number")), e.hasOwnProperty("skipCount") && (t.skipCount = r.convertToType(e.skipCount, "Number")), e.hasOwnProperty("sorting") && (t.sorting = r.convertToType(e.sorting, "String"))), t;
      }
    }]);
  }();
  L.prototype.code = void 0, L.prototype.deviceId = void 0, L.prototype.id = void 0, L.prototype.isValid = void 0, L.prototype.maxResultCount = void 0, L.prototype.skipCount = void 0, L.prototype.sorting = void 0;
  var ve = /*#__PURE__*/function () {
    function ve() {
      _classCallCheck(this, ve);
    }
    return _createClass(ve, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ve(), e.hasOwnProperty("deviceIds") && (t.deviceIds = r.convertToType(e.deviceIds, "String")), e.hasOwnProperty("roleId") && (t.roleId = r.convertToType(e.roleId, "String")), e.hasOwnProperty("type") && (t.type = r.convertToType(e.type, "Number"))), t;
      }
    }]);
  }();
  ve.prototype.deviceIds = void 0, ve.prototype.roleId = void 0, ve.prototype.type = void 0;
  var Oe = /*#__PURE__*/function () {
    function Oe() {
      _classCallCheck(this, Oe);
    }
    return _createClass(Oe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Oe(), e.hasOwnProperty("documentDescription") && (t.documentDescription = r.convertToType(e.documentDescription, "String")), e.hasOwnProperty("documentType") && (t.documentType = r.convertToType(e.documentType, "String"))), t;
      }
    }]);
  }();
  Oe.prototype.documentDescription = void 0, Oe.prototype.documentType = void 0;
  var J = /*#__PURE__*/function () {
    function J() {
      _classCallCheck(this, J);
    }
    return _createClass(J, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new J(), e.hasOwnProperty("classCode") && (t.classCode = r.convertToType(e.classCode, "String")), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String"))), t;
      }
    }]);
  }();
  J.prototype.classCode = void 0, J.prototype.code = void 0, J.prototype.name = void 0;
  var S = /*#__PURE__*/function () {
    function S() {
      _classCallCheck(this, S);
    }
    return _createClass(S, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new S(), e.hasOwnProperty("documentClassAttributes") && (t.documentClassAttributes = Oe.constructFromObject(e.documentClassAttributes)), e.hasOwnProperty("documentClassCode") && (t.documentClassCode = r.convertToType(e.documentClassCode, "String")), e.hasOwnProperty("documentClassName") && (t.documentClassName = r.convertToType(e.documentClassName, "String")), e.hasOwnProperty("fileCode") && (t.fileCode = r.convertToType(e.fileCode, "String")), e.hasOwnProperty("fileName") && (t.fileName = r.convertToType(e.fileName, "String")), e.hasOwnProperty("fileUrl") && (t.fileUrl = r.convertToType(e.fileUrl, "String")), e.hasOwnProperty("folderPath") && (t.folderPath = r.convertToType(e.folderPath, "String")), e.hasOwnProperty("tags") && (t.tags = r.convertToType(e.tags, [J]))), t;
      }
    }]);
  }();
  S.prototype.documentClassAttributes = void 0, S.prototype.documentClassCode = void 0, S.prototype.documentClassName = void 0, S.prototype.fileCode = void 0, S.prototype.fileName = void 0, S.prototype.fileUrl = void 0, S.prototype.folderPath = void 0, S.prototype.tags = void 0;
  var we = /*#__PURE__*/function () {
    function we() {
      _classCallCheck(this, we);
    }
    return _createClass(we, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new we(), e.hasOwnProperty("folderPathSplit") && (t.folderPathSplit = r.convertToType(e.folderPathSplit, "String")), e.hasOwnProperty("params") && (t.params = r.convertToType(e.params, [S])), e.hasOwnProperty("standardCode") && (t.standardCode = r.convertToType(e.standardCode, "String"))), t;
      }
    }]);
  }();
  we.prototype.folderPathSplit = void 0, we.prototype.params = void 0, we.prototype.standardCode = void 0;
  var I = /*#__PURE__*/function () {
    function I() {
      _classCallCheck(this, I);
    }
    return _createClass(I, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new I(), e.hasOwnProperty("businessId") && (t.businessId = r.convertToType(e.businessId, "String")), e.hasOwnProperty("icon") && (t.icon = r.convertToType(e.icon, "String")), e.hasOwnProperty("isShow") && (t.isShow = r.convertToType(e.isShow, "Number")), e.hasOwnProperty("position") && (t.position = r.convertToType(e.position, "String")), e.hasOwnProperty("sceneId") && (t.sceneId = r.convertToType(e.sceneId, "String")), e.hasOwnProperty("type") && (t.type = r.convertToType(e.type, "String")), e.hasOwnProperty("visualAngle") && (t.visualAngle = r.convertToType(e.visualAngle, "String"))), t;
      }
    }]);
  }();
  I.prototype.businessId = void 0, I.prototype.icon = void 0, I.prototype.isShow = void 0, I.prototype.position = void 0, I.prototype.sceneId = void 0, I.prototype.type = void 0, I.prototype.visualAngle = void 0;
  var Ie = /*#__PURE__*/function () {
    function Ie() {
      _classCallCheck(this, Ie);
    }
    return _createClass(Ie, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Ie(), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String"))), t;
      }
    }]);
  }();
  Ie.prototype.id = void 0;
  var Se = /*#__PURE__*/function () {
    function Se() {
      _classCallCheck(this, Se);
    }
    return _createClass(Se, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Se(), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number"))), t;
      }
    }]);
  }();
  Se.prototype.name = void 0, Se.prototype.pageNo = void 0, Se.prototype.pageSize = void 0;
  var U = /*#__PURE__*/function () {
    function U() {
      _classCallCheck(this, U);
    }
    return _createClass(U, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new U(), e.hasOwnProperty("deviceId") && (t.deviceId = r.convertToType(e.deviceId, "String")), e.hasOwnProperty("medium") && (t.medium = r.convertToType(e.medium, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  U.prototype.deviceId = void 0, U.prototype.medium = void 0, U.prototype.pageNo = void 0, U.prototype.pageSize = void 0, U.prototype.tagCode = void 0;
  var $ = /*#__PURE__*/function () {
    function $() {
      _classCallCheck(this, $);
    }
    return _createClass($, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new $(), e.hasOwnProperty("deviceId") && (t.deviceId = r.convertToType(e.deviceId, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  $.prototype.deviceId = void 0, $.prototype.pageNo = void 0, $.prototype.pageSize = void 0, $.prototype.tagCode = void 0;
  var M = /*#__PURE__*/function () {
    function M() {
      _classCallCheck(this, M);
    }
    return _createClass(M, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new M(), e.hasOwnProperty("classId") && (t.classId = r.convertToType(e.classId, "String")), e.hasOwnProperty("documentCode") && (t.documentCode = r.convertToType(e.documentCode, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  M.prototype.classId = void 0, M.prototype.documentCode = void 0, M.prototype.pageNo = void 0, M.prototype.pageSize = void 0, M.prototype.tagCode = void 0;
  var q = /*#__PURE__*/function () {
    function q() {
      _classCallCheck(this, q);
    }
    return _createClass(q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new q(), e.hasOwnProperty("classId") && (t.classId = r.convertToType(e.classId, "String")), e.hasOwnProperty("documentCode") && (t.documentCode = r.convertToType(e.documentCode, "String")), e.hasOwnProperty("documentName") && (t.documentName = r.convertToType(e.documentName, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number"))), t;
      }
    }]);
  }();
  q.prototype.classId = void 0, q.prototype.documentCode = void 0, q.prototype.documentName = void 0, q.prototype.pageNo = void 0, q.prototype.pageSize = void 0;
  var K = /*#__PURE__*/function () {
    function K() {
      _classCallCheck(this, K);
    }
    return _createClass(K, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new K(), e.hasOwnProperty("children") && (t.children = r.convertToType(e.children, [K])), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("title") && (t.title = r.convertToType(e.title, "String"))), t;
      }
    }]);
  }();
  K.prototype.children = void 0, K.prototype.code = void 0, K.prototype.title = void 0;
  var A = /*#__PURE__*/function () {
    function A() {
      _classCallCheck(this, A);
    }
    return _createClass(A, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new A(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("description") && (t.description = r.convertToType(e.description, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("quantity") && (t.quantity = r.convertToType(e.quantity, "String")), e.hasOwnProperty("tagId") && (t.tagId = r.convertToType(e.tagId, "String")), e.hasOwnProperty("unit") && (t.unit = r.convertToType(e.unit, "String"))), t;
      }
    }]);
  }();
  A.prototype.code = void 0, A.prototype.description = void 0, A.prototype.id = void 0, A.prototype.quantity = void 0, A.prototype.tagId = void 0, A.prototype.unit = void 0;
  var X = /*#__PURE__*/function () {
    function X() {
      _classCallCheck(this, X);
    }
    return _createClass(X, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new X(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("codes") && (t.codes = r.convertToType(e.codes, ["String"])), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number"))), t;
      }
    }]);
  }();
  X.prototype.code = void 0, X.prototype.codes = void 0, X.prototype.pageNo = void 0, X.prototype.pageSize = void 0;
  var E = /*#__PURE__*/function () {
    function E() {
      _classCallCheck(this, E);
    }
    return _createClass(E, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new E(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("count") && (t.count = r.convertToType(e.count, "Number"))), t;
      }
    }]);
  }();
  E.prototype.code = void 0, E.prototype.count = void 0;
  var g = /*#__PURE__*/function () {
    function g() {
      _classCallCheck(this, g);
    }
    return _createClass(g, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new g(), e.hasOwnProperty("dept") && (t.dept = r.convertToType(e.dept, "String")), e.hasOwnProperty("organization") && (t.organization = r.convertToType(e.organization, "String")), e.hasOwnProperty("outputProblemCount") && (t.outputProblemCount = r.convertToType(e.outputProblemCount, "Number")), e.hasOwnProperty("outputProblemType") && (t.outputProblemType = r.convertToType(e.outputProblemType, [E])), e.hasOwnProperty("periodOutputProblemCount") && (t.periodOutputProblemCount = r.convertToType(e.periodOutputProblemCount, "Number")), e.hasOwnProperty("periodOutputProblemType") && (t.periodOutputProblemType = r.convertToType(e.periodOutputProblemType, [E])), e.hasOwnProperty("problemCount") && (t.problemCount = r.convertToType(e.problemCount, "Number")), e.hasOwnProperty("problemType") && (t.problemType = r.convertToType(e.problemType, [E])), e.hasOwnProperty("remainderProblemCount") && (t.remainderProblemCount = r.convertToType(e.remainderProblemCount, "Number")), e.hasOwnProperty("remainderProblemType") && (t.remainderProblemType = r.convertToType(e.remainderProblemType, [E])), e.hasOwnProperty("seqNo") && (t.seqNo = r.convertToType(e.seqNo, "Number"))), t;
      }
    }]);
  }();
  g.prototype.dept = void 0, g.prototype.organization = void 0, g.prototype.outputProblemCount = void 0, g.prototype.outputProblemType = void 0, g.prototype.periodOutputProblemCount = void 0, g.prototype.periodOutputProblemType = void 0, g.prototype.problemCount = void 0, g.prototype.problemType = void 0, g.prototype.remainderProblemCount = void 0, g.prototype.remainderProblemType = void 0, g.prototype.seqNo = void 0;
  var Ce = /*#__PURE__*/function () {
    function Ce() {
      _classCallCheck(this, Ce);
    }
    return _createClass(Ce, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Ce(), e.hasOwnProperty("datas") && (t.datas = r.convertToType(e.datas, [g])), e.hasOwnProperty("headers") && (t.headers = r.convertToType(e.headers, [K]))), t;
      }
    }]);
  }();
  Ce.prototype.datas = void 0, Ce.prototype.headers = void 0;
  var W = /*#__PURE__*/function () {
    function W() {
      _classCallCheck(this, W);
    }
    return _createClass(W, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new W(), e.hasOwnProperty("description") && (t.description = r.convertToType(e.description, "String")), e.hasOwnProperty("deviceId") && (t.deviceId = r.convertToType(e.deviceId, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("maxResultCount") && (t.maxResultCount = r.convertToType(e.maxResultCount, "Number")), e.hasOwnProperty("skipCount") && (t.skipCount = r.convertToType(e.skipCount, "Number")), e.hasOwnProperty("sorting") && (t.sorting = r.convertToType(e.sorting, "String"))), t;
      }
    }]);
  }();
  W.prototype.description = void 0, W.prototype.deviceId = void 0, W.prototype.id = void 0, W.prototype.maxResultCount = void 0, W.prototype.skipCount = void 0, W.prototype.sorting = void 0;
  var C = /*#__PURE__*/function () {
    function C() {
      _classCallCheck(this, C);
    }
    return _createClass(C, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new C(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, Object)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  C.prototype.code = void 0, C.prototype.data = void 0, C.prototype.msg = void 0;
  var Y = /*#__PURE__*/function () {
    function Y() {
      _classCallCheck(this, Y);
    }
    return _createClass(Y, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Y(), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("key") && (t.key = r.convertToType(e.key, "String")), e.hasOwnProperty("value") && (t.value = r.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  Y.prototype.id = void 0, Y.prototype.key = void 0, Y.prototype.value = void 0;
  var Z = /*#__PURE__*/function () {
    function Z() {
      _classCallCheck(this, Z);
    }
    return _createClass(Z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Z(), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number")), e.hasOwnProperty("suffix") && (t.suffix = r.convertToType(e.suffix, "String")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String"))), t;
      }
    }]);
  }();
  Z.prototype.pageNo = void 0, Z.prototype.pageSize = void 0, Z.prototype.suffix = void 0, Z.prototype.tagCode = void 0;
  var G = /*#__PURE__*/function () {
    function G() {
      _classCallCheck(this, G);
    }
    return _createClass(G, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new G(), e.hasOwnProperty("classCode") && (t.classCode = r.convertToType(e.classCode, "String")), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("codes") && (t.codes = r.convertToType(e.codes, ["String"])), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number"))), t;
      }
    }]);
  }();
  G.prototype.classCode = void 0, G.prototype.code = void 0, G.prototype.codes = void 0, G.prototype.pageNo = void 0, G.prototype.pageSize = void 0;
  var V = /*#__PURE__*/function () {
    function V() {
      _classCallCheck(this, V);
    }
    return _createClass(V, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new V(), e.hasOwnProperty("classId") && (t.classId = r.convertToType(e.classId, "String")), e.hasOwnProperty("pageNo") && (t.pageNo = r.convertToType(e.pageNo, "Number")), e.hasOwnProperty("pageSize") && (t.pageSize = r.convertToType(e.pageSize, "Number")), e.hasOwnProperty("tagCode") && (t.tagCode = r.convertToType(e.tagCode, "String")), e.hasOwnProperty("tagName") && (t.tagName = r.convertToType(e.tagName, "String"))), t;
      }
    }]);
  }();
  V.prototype.classId = void 0, V.prototype.pageNo = void 0, V.prototype.pageSize = void 0, V.prototype.tagCode = void 0, V.prototype.tagName = void 0;
  var D = /*#__PURE__*/function () {
    function D() {
      _classCallCheck(this, D);
    }
    return _createClass(D, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new D(), e.hasOwnProperty("businessId") && (t.businessId = r.convertToType(e.businessId, "String")), e.hasOwnProperty("icon") && (t.icon = r.convertToType(e.icon, "String")), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("isShow") && (t.isShow = r.convertToType(e.isShow, "Number")), e.hasOwnProperty("position") && (t.position = r.convertToType(e.position, "String")), e.hasOwnProperty("sceneId") && (t.sceneId = r.convertToType(e.sceneId, "String")), e.hasOwnProperty("type") && (t.type = r.convertToType(e.type, "String")), e.hasOwnProperty("visualAngle") && (t.visualAngle = r.convertToType(e.visualAngle, "String"))), t;
      }
    }]);
  }();
  D.prototype.businessId = void 0, D.prototype.icon = void 0, D.prototype.id = void 0, D.prototype.isShow = void 0, D.prototype.position = void 0, D.prototype.sceneId = void 0, D.prototype.type = void 0, D.prototype.visualAngle = void 0;
  var b = /*#__PURE__*/function () {
    function b() {
      _classCallCheck(this, b);
    }
    return _createClass(b, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new b(), e.hasOwnProperty("classId") && (t.classId = r.convertToType(e.classId, "String")), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String"))), t;
      }
    }]);
  }();
  b.prototype.classId = void 0, b.prototype.code = void 0, b.prototype.name = void 0;
  var Q = /*#__PURE__*/function () {
    function Q() {
      _classCallCheck(this, Q);
    }
    return _createClass(Q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Q(), e.hasOwnProperty("ModuleEngineKey") && (t.moduleEngineKey = r.convertToType(e.ModuleEngineKey, "String")), e.hasOwnProperty("_PageIndex") && (t.pageIndex = r.convertToType(e._PageIndex, "Number")), e.hasOwnProperty("_PageSize") && (t.pageSize = r.convertToType(e._PageSize, "Number")), e.hasOwnProperty("_SearchDateTime.CreateTime") && (t.searchDateTimeCreateTime = r.convertToType(e["_SearchDateTime.CreateTime"], ["Date"])), e.hasOwnProperty("_Where") && (t.where = r.convertToType(e._Where, [N]))), t;
      }
    }]);
  }();
  Q.prototype.moduleEngineKey = void 0, Q.prototype.pageIndex = void 0, Q.prototype.pageSize = void 0, Q.prototype.searchDateTimeCreateTime = void 0, Q.prototype.where = void 0;
  var j = /*#__PURE__*/function () {
    function j() {
      _classCallCheck(this, j);
    }
    return _createClass(j, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new j(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [I])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  j.prototype.code = void 0, j.prototype.data = void 0, j.prototype.msg = void 0;
  var ee = /*#__PURE__*/function () {
    function ee() {
      _classCallCheck(this, ee);
    }
    return _createClass(ee, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ee(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [Ie])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ee.prototype.code = void 0, ee.prototype.data = void 0, ee.prototype.msg = void 0;
  var te = /*#__PURE__*/function () {
    function te() {
      _classCallCheck(this, te);
    }
    return _createClass(te, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new te(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [A])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  te.prototype.code = void 0, te.prototype.data = void 0, te.prototype.msg = void 0;
  var re = /*#__PURE__*/function () {
    function re() {
      _classCallCheck(this, re);
    }
    return _createClass(re, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new re(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [Y])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  re.prototype.code = void 0, re.prototype.data = void 0, re.prototype.msg = void 0;
  var ne = /*#__PURE__*/function () {
    function ne() {
      _classCallCheck(this, ne);
    }
    return _createClass(ne, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ne(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [D])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ne.prototype.code = void 0, ne.prototype.data = void 0, ne.prototype.msg = void 0;
  var oe = /*#__PURE__*/function () {
    function oe() {
      _classCallCheck(this, oe);
    }
    return _createClass(oe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new oe(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, [b])), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  oe.prototype.code = void 0, oe.prototype.data = void 0, oe.prototype.msg = void 0;
  var ie = /*#__PURE__*/function () {
    function ie() {
      _classCallCheck(this, ie);
    }
    return _createClass(ie, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ie(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = de.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ie.prototype.code = void 0, ie.prototype.data = void 0, ie.prototype.msg = void 0;
  var pe = /*#__PURE__*/function () {
    function pe() {
      _classCallCheck(this, pe);
    }
    return _createClass(pe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new pe(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = fe.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  pe.prototype.code = void 0, pe.prototype.data = void 0, pe.prototype.msg = void 0;
  var se = /*#__PURE__*/function () {
    function se() {
      _classCallCheck(this, se);
    }
    return _createClass(se, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new se(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = me.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  se.prototype.code = void 0, se.prototype.data = void 0, se.prototype.msg = void 0;
  var ce = /*#__PURE__*/function () {
    function ce() {
      _classCallCheck(this, ce);
    }
    return _createClass(ce, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ce(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = Te.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ce.prototype.code = void 0, ce.prototype.data = void 0, ce.prototype.msg = void 0;
  var le = /*#__PURE__*/function () {
    function le() {
      _classCallCheck(this, le);
    }
    return _createClass(le, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new le(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = he.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  le.prototype.code = void 0, le.prototype.data = void 0, le.prototype.msg = void 0;
  var ae = /*#__PURE__*/function () {
    function ae() {
      _classCallCheck(this, ae);
    }
    return _createClass(ae, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ae(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = Pe.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ae.prototype.code = void 0, ae.prototype.data = void 0, ae.prototype.msg = void 0;
  var ue = /*#__PURE__*/function () {
    function ue() {
      _classCallCheck(this, ue);
    }
    return _createClass(ue, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ue(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = ge.constructFromObject(e.data)), e.hasOwnProperty("msg") && (t.msg = r.convertToType(e.msg, "String"))), t;
      }
    }]);
  }();
  ue.prototype.code = void 0, ue.prototype.data = void 0, ue.prototype.msg = void 0;
  var Be = /*#__PURE__*/function () {
    function Be(e) {
      _classCallCheck(this, Be);
      this.apiClient = e || r.GetInstance("guang-xi-shi-hua", "BlindApi");
    }
    return _createClass(Be, [{
      key: "getBlindPermissionsWithHttpInfo",
      value: function getBlindPermissionsWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            roleId: e.roleId,
            type: e.type
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = "String";
        return this.apiClient.callApi("/api/blind/get-permissions", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getBlindPermissions",
      value: function getBlindPermissions(e) {
        return this.getBlindPermissionsWithHttpInfo(e);
      }
    }, {
      key: "getBlindPlateChangeLogLitsWithHttpInfo",
      value: function getBlindPlateChangeLogLitsWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {},
          i = e.header || {},
          s = {
            ModuleEngineKey: e.moduleEngineKey,
            _PageIndex: e.pageIndex,
            _PageSize: e.pageSize,
            "_SearchDateTime.CreateTime": this.apiClient.buildCollectionParam(e.searchDateTimeCreateTime, "multi"),
            _Where: this.apiClient.buildCollectionParam(e.where, "multi")
          },
          c = ["oauth2"],
          l = ["multipart/form-data"],
          a = ["application/json", "text/json", "text/plain"],
          u = F;
        return this.apiClient.callApi("/api/blind/low-code-blind-plate-change-log-list", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getBlindPlateChangeLogLits",
      value: function getBlindPlateChangeLogLits(e) {
        return this.getBlindPlateChangeLogLitsWithHttpInfo(e);
      }
    }, {
      key: "getBlindPlateLitsWithHttpInfo",
      value: function getBlindPlateLitsWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {},
          i = e.header || {},
          s = {
            ModuleEngineKey: e.moduleEngineKey,
            _PageIndex: e.pageIndex,
            _PageSize: e.pageSize,
            "_SearchDateTime.CreateTime": this.apiClient.buildCollectionParam(e.searchDateTimeCreateTime, "multi"),
            _Where: this.apiClient.buildCollectionParam(e.where, "multi")
          },
          c = ["oauth2"],
          l = ["multipart/form-data"],
          a = ["application/json", "text/json", "text/plain"],
          u = x;
        return this.apiClient.callApi("/api/blind/low-code-blind-plate-list", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getBlindPlateLits",
      value: function getBlindPlateLits(e) {
        return this.getBlindPlateLitsWithHttpInfo(e);
      }
    }, {
      key: "saveBlindPermissionsWithHttpInfo",
      value: function saveBlindPermissionsWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/blind/save-permissions", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "saveBlindPermissions",
      value: function saveBlindPermissions(e) {
        return this.saveBlindPermissionsWithHttpInfo(e);
      }
    }]);
  }();
  ye(Be, "Methods", {
    getBlindPermissions: {
      method: "GET",
      path: "/api/blind/get-permissions"
    },
    getBlindPlateChangeLogLits: {
      method: "POST",
      path: "/api/blind/low-code-blind-plate-change-log-list"
    },
    getBlindPlateLits: {
      method: "POST",
      path: "/api/blind/low-code-blind-plate-list"
    },
    saveBlindPermissions: {
      method: "POST",
      path: "/api/blind/save-permissions"
    }
  });
  var Re = /*#__PURE__*/function () {
    function Re(e) {
      _classCallCheck(this, Re);
      this.apiClient = e || r.GetInstance("guang-xi-shi-hua", "DataValidationReportApi");
    }
    return _createClass(Re, [{
      key: "documentAssociationListExportToExcelWithHttpInfo",
      value: function documentAssociationListExportToExcelWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = [],
          u = e.returnType || null;
        return this.apiClient.callApi("/api/data-validation-report/document-association-list-export-excel-file", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "documentAssociationListExportToExcel",
      value: function documentAssociationListExportToExcel(e) {
        return this.documentAssociationListExportToExcelWithHttpInfo(e);
      }
    }, {
      key: "documentMessageListExportToExcelWithHttpInfo",
      value: function documentMessageListExportToExcelWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = [],
          u = e.returnType || null;
        return this.apiClient.callApi("/api/data-validation-report/document-message-list-export-excel-file", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "documentMessageListExportToExcel",
      value: function documentMessageListExportToExcel(e) {
        return this.documentMessageListExportToExcelWithHttpInfo(e);
      }
    }, {
      key: "getDocumentAssociationListWithHttpInfo",
      value: function getDocumentAssociationListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = se;
        return this.apiClient.callApi("/api/data-validation-report/get-document-association-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getDocumentAssociationList",
      value: function getDocumentAssociationList(e) {
        return this.getDocumentAssociationListWithHttpInfo(e);
      }
    }, {
      key: "getDocumentMessageListWithHttpInfo",
      value: function getDocumentMessageListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/data-validation-report/get-document-message-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getDocumentMessageList",
      value: function getDocumentMessageList(e) {
        return this.getDocumentMessageListWithHttpInfo(e);
      }
    }, {
      key: "getDocumntClassIdsWithHttpInfo",
      value: function getDocumntClassIdsWithHttpInfo() {
        var e = null,
          t = {},
          o = {},
          n = {},
          i = {},
          s = ["oauth2"],
          c = [],
          l = [],
          a = null;
        return this.apiClient.callApi("/api/data-validation-report/get-document-class-ids-async", "GET", t, o, n, i, e, s, c, l, a);
      }
    }, {
      key: "getDocumntClassIds",
      value: function getDocumntClassIds() {
        return this.getDocumntClassIdsWithHttpInfo();
      }
    }, {
      key: "getObjectListReportWithHttpInfo",
      value: function getObjectListReportWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/data-validation-report/get-object-list-report-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getObjectListReport",
      value: function getObjectListReport(e) {
        return this.getObjectListReportWithHttpInfo(e);
      }
    }, {
      key: "getTagClassIdsWithHttpInfo",
      value: function getTagClassIdsWithHttpInfo() {
        var e = null,
          t = {},
          o = {},
          n = {},
          i = {},
          s = ["oauth2"],
          c = [],
          l = [],
          a = null;
        return this.apiClient.callApi("/api/data-validation-report/get-tag-class-ids-async", "GET", t, o, n, i, e, s, c, l, a);
      }
    }, {
      key: "getTagClassIds",
      value: function getTagClassIds() {
        return this.getTagClassIdsWithHttpInfo();
      }
    }, {
      key: "getTagCompletenessListWithHttpInfo",
      value: function getTagCompletenessListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ae;
        return this.apiClient.callApi("/api/data-validation-report/get-tag-completeness-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getTagCompletenessList",
      value: function getTagCompletenessList(e) {
        return this.getTagCompletenessListWithHttpInfo(e);
      }
    }, {
      key: "objectListReportExportToExcelWithHttpInfo",
      value: function objectListReportExportToExcelWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = [],
          u = e.returnType || null;
        return this.apiClient.callApi("/api/data-validation-report/objec-list-report-export-excel-file", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "objectListReportExportToExcel",
      value: function objectListReportExportToExcel(e) {
        return this.objectListReportExportToExcelWithHttpInfo(e);
      }
    }, {
      key: "tagCompletenessListExportToExcelWithHttpInfo",
      value: function tagCompletenessListExportToExcelWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = [],
          u = e.returnType || null;
        return this.apiClient.callApi("/api/data-validation-report/tag-completeness-list-export-excel-file", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "tagCompletenessListExportToExcel",
      value: function tagCompletenessListExportToExcel(e) {
        return this.tagCompletenessListExportToExcelWithHttpInfo(e);
      }
    }]);
  }();
  ye(Re, "Methods", {
    documentAssociationListExportToExcel: {
      method: "POST",
      path: "/api/data-validation-report/document-association-list-export-excel-file"
    },
    documentMessageListExportToExcel: {
      method: "POST",
      path: "/api/data-validation-report/document-message-list-export-excel-file"
    },
    getDocumentAssociationList: {
      method: "POST",
      path: "/api/data-validation-report/get-document-association-list-async"
    },
    getDocumentMessageList: {
      method: "POST",
      path: "/api/data-validation-report/get-document-message-list-async"
    },
    getDocumntClassIds: {
      method: "GET",
      path: "/api/data-validation-report/get-document-class-ids-async"
    },
    getObjectListReport: {
      method: "POST",
      path: "/api/data-validation-report/get-object-list-report-async"
    },
    getTagClassIds: {
      method: "GET",
      path: "/api/data-validation-report/get-tag-class-ids-async"
    },
    getTagCompletenessList: {
      method: "POST",
      path: "/api/data-validation-report/get-tag-completeness-list-async"
    },
    objectListReportExportToExcel: {
      method: "POST",
      path: "/api/data-validation-report/objec-list-report-export-excel-file"
    },
    tagCompletenessListExportToExcel: {
      method: "POST",
      path: "/api/data-validation-report/tag-completeness-list-export-excel-file"
    }
  });
  var Ee = /*#__PURE__*/function () {
    function Ee(e) {
      _classCallCheck(this, Ee);
      this.apiClient = e || r.GetInstance("guang-xi-shi-hua", "DocumentApi");
    }
    return _createClass(Ee, [{
      key: "addDocumentInfoWithHttpInfo",
      value: function addDocumentInfoWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/document/add-document-info", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "addDocumentInfo",
      value: function addDocumentInfo(e) {
        return this.addDocumentInfoWithHttpInfo(e);
      }
    }, {
      key: "asyncDocumentWithHttpInfo",
      value: function asyncDocumentWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            type: e.type
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/document/async-document", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "asyncDocument",
      value: function asyncDocument(e) {
        return this.asyncDocumentWithHttpInfo(e);
      }
    }]);
  }();
  ye(Ee, "Methods", {
    addDocumentInfo: {
      method: "POST",
      path: "/api/document/add-document-info"
    },
    asyncDocument: {
      method: "GET",
      path: "/api/document/async-document"
    }
  });
  var We = /*#__PURE__*/function () {
    function We(e) {
      _classCallCheck(this, We);
      this.apiClient = e || r.GetInstance("guang-xi-shi-hua", "ProblemApi");
    }
    return _createClass(We, [{
      key: "exportProblemStatisticsReportWithHttpInfo",
      value: function exportProblemStatisticsReportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            deviceId: e.deviceId,
            startTime: e.startTime,
            endTime: e.endTime
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = "Blob";
        return this.apiClient.callApi("/api/problem/export-excel-file", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "exportProblemStatisticsReport",
      value: function exportProblemStatisticsReport(e) {
        return this.exportProblemStatisticsReportWithHttpInfo(e);
      }
    }, {
      key: "getProblemListWithHttpInfo",
      value: function getProblemListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {},
          i = e.header || {},
          s = {
            ModuleEngineKey: e.moduleEngineKey,
            _PageIndex: e.pageIndex,
            _PageSize: e.pageSize,
            "_SearchDateTime.CreateTime": this.apiClient.buildCollectionParam(e.searchDateTimeCreateTime, "multi"),
            _Where: this.apiClient.buildCollectionParam(e.where, "multi")
          },
          c = ["oauth2"],
          l = ["multipart/form-data"],
          a = ["application/json", "text/json", "text/plain"],
          u = B;
        return this.apiClient.callApi("/api/problem/low-code-problem-list", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getProblemList",
      value: function getProblemList(e) {
        return this.getProblemListWithHttpInfo(e);
      }
    }, {
      key: "getProblemStatisticsReportWithHttpInfo",
      value: function getProblemStatisticsReportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            deviceId: e.deviceId,
            startTime: e.startTime,
            endTime: e.endTime
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = Ce;
        return this.apiClient.callApi("/api/problem/problem-statistics-report", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getProblemStatisticsReport",
      value: function getProblemStatisticsReport(e) {
        return this.getProblemStatisticsReportWithHttpInfo(e);
      }
    }]);
  }();
  ye(We, "Methods", {
    exportProblemStatisticsReport: {
      method: "GET",
      path: "/api/problem/export-excel-file"
    },
    getProblemList: {
      method: "POST",
      path: "/api/problem/low-code-problem-list"
    },
    getProblemStatisticsReport: {
      method: "GET",
      path: "/api/problem/problem-statistics-report"
    }
  });
  var He = /*#__PURE__*/function () {
    function He(e) {
      _classCallCheck(this, He);
      this.apiClient = e || r.GetInstance("guang-xi-shi-hua", "ThreeDimensionsApi");
    }
    return _createClass(He, [{
      key: "deletedPointWithHttpInfo",
      value: function deletedPointWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ee;
        return this.apiClient.callApi("/api/three-dimensions/deleted-point-async", "DELETE", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "deletedPoint",
      value: function deletedPoint(e) {
        return this.deletedPointWithHttpInfo(e);
      }
    }, {
      key: "getBlindPlateListWithHttpInfo",
      value: function getBlindPlateListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = C;
        return this.apiClient.callApi("/api/three-dimensions/get-blind-plate-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getBlindPlateList",
      value: function getBlindPlateList(e) {
        return this.getBlindPlateListWithHttpInfo(e);
      }
    }, {
      key: "getDeviceListWithHttpInfo",
      value: function getDeviceListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {
            isTree: e.isTree
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = [],
          u = e.returnType || null;
        return this.apiClient.callApi("/api/three-dimensions/get-device-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getDeviceList",
      value: function getDeviceList(e) {
        return this.getDeviceListWithHttpInfo(e);
      }
    }, {
      key: "getDeviceRelationPipeLineListWithHttpInfo",
      value: function getDeviceRelationPipeLineListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ie;
        return this.apiClient.callApi("/api/three-dimensions/get-device-relation-pipe-line-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getDeviceRelationPipeLineList",
      value: function getDeviceRelationPipeLineList(e) {
        return this.getDeviceRelationPipeLineListWithHttpInfo(e);
      }
    }, {
      key: "getDeviceRelationTagListWithHttpInfo",
      value: function getDeviceRelationTagListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = pe;
        return this.apiClient.callApi("/api/three-dimensions/get-device-relation-tag-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getDeviceRelationTagList",
      value: function getDeviceRelationTagList(e) {
        return this.getDeviceRelationTagListWithHttpInfo(e);
      }
    }, {
      key: "getMaterialByTagIdWithHttpInfo",
      value: function getMaterialByTagIdWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            tagId: e.tagId
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = te;
        return this.apiClient.callApi("/api/three-dimensions/get-material-by-tag-id-async", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getMaterialByTagId",
      value: function getMaterialByTagId(e) {
        return this.getMaterialByTagIdWithHttpInfo(e);
      }
    }, {
      key: "getPipeLineListWithHttpInfo",
      value: function getPipeLineListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ce;
        return this.apiClient.callApi("/api/three-dimensions/get-pipe-line-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getPipeLineList",
      value: function getPipeLineList(e) {
        return this.getPipeLineListWithHttpInfo(e);
      }
    }, {
      key: "getProblemsListWithHttpInfo",
      value: function getProblemsListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = le;
        return this.apiClient.callApi("/api/three-dimensions/get-problems-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getProblemsList",
      value: function getProblemsList(e) {
        return this.getProblemsListWithHttpInfo(e);
      }
    }, {
      key: "getSysDatatWithHttpInfo",
      value: function getSysDatatWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            parentKey: e.parentKey
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = re;
        return this.apiClient.callApi("/api/three-dimensions/get-sys-data-async", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getSysDatat",
      value: function getSysDatat(e) {
        return this.getSysDatatWithHttpInfo(e);
      }
    }, {
      key: "getTagListWithHttpInfo",
      value: function getTagListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ue;
        return this.apiClient.callApi("/api/three-dimensions/get-tag-list-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getTagList",
      value: function getTagList(e) {
        return this.getTagListWithHttpInfo(e);
      }
    }, {
      key: "getValveListWithHttpInfo",
      value: function getValveListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          o = {},
          n = {
            code: e.code
          },
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = [],
          a = ["application/json", "text/json", "text/plain"],
          u = oe;
        return this.apiClient.callApi("/api/three-dimensions/get-valve-list-async", "GET", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "getValveList",
      value: function getValveList(e) {
        return this.getValveListWithHttpInfo(e);
      }
    }, {
      key: "insertPointWithHttpInfo",
      value: function insertPointWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = j;
        return this.apiClient.callApi("/api/three-dimensions/insert-point-async", "POST", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "insertPoint",
      value: function insertPoint(e) {
        return this.insertPointWithHttpInfo(e);
      }
    }, {
      key: "updatePointWithHttpInfo",
      value: function updatePointWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          a = ["application/json", "text/json", "text/plain"],
          u = ne;
        return this.apiClient.callApi("/api/three-dimensions/update-point-async", "PUT", o, n, i, s, t, c, l, a, u);
      }
    }, {
      key: "updatePoint",
      value: function updatePoint(e) {
        return this.updatePointWithHttpInfo(e);
      }
    }]);
  }();
  ye(He, "Methods", {
    deletedPoint: {
      method: "DELETE",
      path: "/api/three-dimensions/deleted-point-async"
    },
    getBlindPlateList: {
      method: "POST",
      path: "/api/three-dimensions/get-blind-plate-list-async"
    },
    getDeviceList: {
      method: "POST",
      path: "/api/three-dimensions/get-device-list-async"
    },
    getDeviceRelationPipeLineList: {
      method: "POST",
      path: "/api/three-dimensions/get-device-relation-pipe-line-list-async"
    },
    getDeviceRelationTagList: {
      method: "POST",
      path: "/api/three-dimensions/get-device-relation-tag-list-async"
    },
    getMaterialByTagId: {
      method: "GET",
      path: "/api/three-dimensions/get-material-by-tag-id-async"
    },
    getPipeLineList: {
      method: "POST",
      path: "/api/three-dimensions/get-pipe-line-list-async"
    },
    getProblemsList: {
      method: "POST",
      path: "/api/three-dimensions/get-problems-list-async"
    },
    getSysDatat: {
      method: "GET",
      path: "/api/three-dimensions/get-sys-data-async"
    },
    getTagList: {
      method: "POST",
      path: "/api/three-dimensions/get-tag-list-async"
    },
    getValveList: {
      method: "GET",
      path: "/api/three-dimensions/get-valve-list-async"
    },
    insertPoint: {
      method: "POST",
      path: "/api/three-dimensions/insert-point-async"
    },
    updatePoint: {
      method: "PUT",
      path: "/api/three-dimensions/update-point-async"
    }
  }), p.ApiClient = r, p.BlindApi = Be, p.BlindLowcodeblindplatechangeloglistBody = H, p.BlindLowcodeblindplatelistBody = z, p.DataValidationReportApi = Re, p.DocumentApi = Ee, p.LowCodeResultDtoListPortalBlindPlateChangeLogListDto = F, p.LowCodeResultDtoListPortalLowCodeBlindPlateListDto = x, p.LowCodeResultDtoListPortalProblemListDto = B, p.PagedResultDtoPortalDeviceRelationPipeLineDto = de, p.PagedResultDtoPortalDeviceRelationTagDto = fe, p.PagedResultDtoPortalDocumentAssociationListDto = me, p.PagedResultDtoPortalPipeLineListDto = Te, p.PagedResultDtoPortalProblemsListDto = he, p.PagedResultDtoPortalTagCompletenessListDto = Pe, p.PagedResultDtoPortalTagListDto = ge, p.PortalBlindPlateChangeLogListDto = y, p.PortalBlindPlateQueryDto = L, p.PortalCreateBlindPermissionsDto = ve, p.PortalCreatedDocumentDto = we, p.PortalCreatedPointDto = I, p.PortalDeletedPoint = Ie, p.PortalDeviceQueryDto = Se, p.PortalDeviceRelationPipeLineDto = P, p.PortalDeviceRelationPipeLineQueryDto = U, p.PortalDeviceRelationTagDto = O, p.PortalDeviceRelationTagQueryDto = $, p.PortalDocumentAssociationListDto = R, p.PortalDocumentAssociationQueryDto = M, p.PortalDocumentClassAttribute = Oe, p.PortalDocumentQueryDto = q, p.PortalHeader = K, p.PortalLowCodeBlindPlateListDto = m, p.PortalMaterialListDto = A, p.PortalParam = S, p.PortalPipeLineListDto = w, p.PortalPipeLineQueryDto = X, p.PortalProblemListDto = d, p.PortalProblemStatisticsReport = Ce, p.PortalProblemType = E, p.PortalProblemsListDto = f, p.PortalProblemsQueryDto = W, p.PortalResultDto = C, p.PortalStatisticsReport = g, p.PortalSysDataDto = Y, p.PortalTag = J, p.PortalTagCompletenessListDto = _, p.PortalTagCompletenessQueryDto = Z, p.PortalTagListDto = k, p.PortalTagListQueryDto = G, p.PortalTagQueryInputDto = V, p.PortalUpdatePointDto = D, p.PortalValveListDto = b, p.PortalWhere = N, p.ProblemApi = We, p.ProblemLowcodeproblemlistBody = Q, p.ResultDtoListPortalCreatedPointDto = j, p.ResultDtoListPortalDeletedPoint = ee, p.ResultDtoListPortalMaterialListDto = te, p.ResultDtoListPortalSysDataDto = re, p.ResultDtoListPortalUpdatePointDto = ne, p.ResultDtoListPortalValveListDto = oe, p.ResultDtoPagedResultDtoPortalDeviceRelationPipeLineDto = ie, p.ResultDtoPagedResultDtoPortalDeviceRelationTagDto = pe, p.ResultDtoPagedResultDtoPortalDocumentAssociationListDto = se, p.ResultDtoPagedResultDtoPortalPipeLineListDto = ce, p.ResultDtoPagedResultDtoPortalProblemsListDto = le, p.ResultDtoPagedResultDtoPortalTagCompletenessListDto = ae, p.ResultDtoPagedResultDtoPortalTagListDto = ue, p.ThreeDimensionsApi = He, Object.defineProperty(p, Symbol.toStringTag, {
    value: "Module"
  });
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer, __webpack_require__("62e4")(module)))

/***/ }),

/***/ "ddae":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("99af");
__webpack_require__("e260");
__webpack_require__("a15b");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("3ca3");
__webpack_require__("5319");
__webpack_require__("1276");
__webpack_require__("498a");
__webpack_require__("313d");
__webpack_require__("159b");
__webpack_require__("ddb0");
__webpack_require__("0eb6");
__webpack_require__("b7ef");
__webpack_require__("8bd4");
__webpack_require__("c73d");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Root reference for iframes.
 */
var root;
if (typeof window !== 'undefined') {
  // Browser window
  root = window;
} else if (typeof self === 'undefined') {
  // Other environments
  console.warn('Using browser-only version of superagent in non-browser environment');
  root = void 0;
} else {
  // Web Worker
  root = self;
}
var Emitter = __webpack_require__("7297");
var safeStringify = __webpack_require__("375a");
var RequestBase = __webpack_require__("3f91");
var isObject = __webpack_require__("422b");
var ResponseBase = __webpack_require__("2627");
var Agent = __webpack_require__("b28c");
/**
 * Noop.
 */

function noop() {}
/**
 * Expose `request`.
 */

module.exports = function (method, url) {
  // callback
  if (typeof url === 'function') {
    return new exports.Request('GET', method).end(url);
  } // url first

  if (arguments.length === 1) {
    return new exports.Request('GET', method);
  }
  return new exports.Request(method, url);
};
exports = module.exports;
var request = exports;
exports.Request = Request;
/**
 * Determine XHR.
 */

request.getXHR = function () {
  if (root.XMLHttpRequest && (!root.location || root.location.protocol !== 'file:' || !root.ActiveXObject)) {
    return new XMLHttpRequest();
  }
  try {
    return new ActiveXObject('Microsoft.XMLHTTP');
  } catch (_unused) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP.6.0');
  } catch (_unused2) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP.3.0');
  } catch (_unused3) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP');
  } catch (_unused4) {}
  throw new Error('Browser-only version of superagent could not find XHR');
};
/**
 * Removes leading and trailing whitespace, added to support IE.
 *
 * @param {String} s
 * @return {String}
 * @api private
 */

var trim = ''.trim ? function (s) {
  return s.trim();
} : function (s) {
  return s.replace(/(^\s*|\s*$)/g, '');
};
/**
 * Serialize the given `obj`.
 *
 * @param {Object} obj
 * @return {String}
 * @api private
 */

function serialize(obj) {
  if (!isObject(obj)) return obj;
  var pairs = [];
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) pushEncodedKeyValuePair(pairs, key, obj[key]);
  }
  return pairs.join('&');
}
/**
 * Helps 'serialize' with serializing arrays.
 * Mutates the pairs array.
 *
 * @param {Array} pairs
 * @param {String} key
 * @param {Mixed} val
 */

function pushEncodedKeyValuePair(pairs, key, val) {
  if (val === undefined) return;
  if (val === null) {
    pairs.push(encodeURI(key));
    return;
  }
  if (Array.isArray(val)) {
    val.forEach(function (v) {
      pushEncodedKeyValuePair(pairs, key, v);
    });
  } else if (isObject(val)) {
    for (var subkey in val) {
      if (Object.prototype.hasOwnProperty.call(val, subkey)) pushEncodedKeyValuePair(pairs, "".concat(key, "[").concat(subkey, "]"), val[subkey]);
    }
  } else {
    pairs.push(encodeURI(key) + '=' + encodeURIComponent(val));
  }
}
/**
 * Expose serialization method.
 */

request.serializeObject = serialize;
/**
 * Parse the given x-www-form-urlencoded `str`.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseString(str) {
  var obj = {};
  var pairs = str.split('&');
  var pair;
  var pos;
  for (var i = 0, len = pairs.length; i < len; ++i) {
    pair = pairs[i];
    pos = pair.indexOf('=');
    if (pos === -1) {
      obj[decodeURIComponent(pair)] = '';
    } else {
      obj[decodeURIComponent(pair.slice(0, pos))] = decodeURIComponent(pair.slice(pos + 1));
    }
  }
  return obj;
}
/**
 * Expose parser.
 */

request.parseString = parseString;
/**
 * Default MIME type map.
 *
 *     superagent.types.xml = 'application/xml';
 *
 */

request.types = {
  html: 'text/html',
  json: 'application/json',
  xml: 'text/xml',
  urlencoded: 'application/x-www-form-urlencoded',
  form: 'application/x-www-form-urlencoded',
  'form-data': 'application/x-www-form-urlencoded'
};
/**
 * Default serialization map.
 *
 *     superagent.serialize['application/xml'] = function(obj){
 *       return 'generated xml here';
 *     };
 *
 */

request.serialize = {
  'application/x-www-form-urlencoded': serialize,
  'application/json': safeStringify
};
/**
 * Default parsers.
 *
 *     superagent.parse['application/xml'] = function(str){
 *       return { object parsed from str };
 *     };
 *
 */

request.parse = {
  'application/x-www-form-urlencoded': parseString,
  'application/json': JSON.parse
};
/**
 * Parse the given header `str` into
 * an object containing the mapped fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseHeader(str) {
  var lines = str.split(/\r?\n/);
  var fields = {};
  var index;
  var line;
  var field;
  var val;
  for (var i = 0, len = lines.length; i < len; ++i) {
    line = lines[i];
    index = line.indexOf(':');
    if (index === -1) {
      // could be empty line, just skip it
      continue;
    }
    field = line.slice(0, index).toLowerCase();
    val = trim(line.slice(index + 1));
    fields[field] = val;
  }
  return fields;
}
/**
 * Check if `mime` is json or has +json structured syntax suffix.
 *
 * @param {String} mime
 * @return {Boolean}
 * @api private
 */

function isJSON(mime) {
  // should match /json or +json
  // but not /json-seq
  return /[/+]json($|[^-\w])/.test(mime);
}
/**
 * Initialize a new `Response` with the given `xhr`.
 *
 *  - set flags (.ok, .error, etc)
 *  - parse header
 *
 * Examples:
 *
 *  Aliasing `superagent` as `request` is nice:
 *
 *      request = superagent;
 *
 *  We can use the promise-like API, or pass callbacks:
 *
 *      request.get('/').end(function(res){});
 *      request.get('/', function(res){});
 *
 *  Sending data can be chained:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' })
 *        .end(function(res){});
 *
 *  Or passed to `.send()`:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' }, function(res){});
 *
 *  Or passed to `.post()`:
 *
 *      request
 *        .post('/user', { name: 'tj' })
 *        .end(function(res){});
 *
 * Or further reduced to a single call for simple cases:
 *
 *      request
 *        .post('/user', { name: 'tj' }, function(res){});
 *
 * @param {XMLHTTPRequest} xhr
 * @param {Object} options
 * @api private
 */

function Response(req) {
  this.req = req;
  this.xhr = this.req.xhr; // responseText is accessible only if responseType is '' or 'text' and on older browsers

  this.text = this.req.method !== 'HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text') || typeof this.xhr.responseType === 'undefined' ? this.xhr.responseText : null;
  this.statusText = this.req.xhr.statusText;
  var status = this.xhr.status; // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request

  if (status === 1223) {
    status = 204;
  }
  this._setStatusProperties(status);
  this.headers = parseHeader(this.xhr.getAllResponseHeaders());
  this.header = this.headers; // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
  // getResponseHeader still works. so we get content-type even if getting
  // other headers fails.

  this.header['content-type'] = this.xhr.getResponseHeader('content-type');
  this._setHeaderProperties(this.header);
  if (this.text === null && req._responseType) {
    this.body = this.xhr.response;
  } else {
    this.body = this.req.method === 'HEAD' ? null : this._parseBody(this.text ? this.text : this.xhr.response);
  }
} // eslint-disable-next-line new-cap

ResponseBase(Response.prototype);
/**
 * Parse the given body `str`.
 *
 * Used for auto-parsing of bodies. Parsers
 * are defined on the `superagent.parse` object.
 *
 * @param {String} str
 * @return {Mixed}
 * @api private
 */

Response.prototype._parseBody = function (str) {
  var parse = request.parse[this.type];
  if (this.req._parser) {
    return this.req._parser(this, str);
  }
  if (!parse && isJSON(this.type)) {
    parse = request.parse['application/json'];
  }
  return parse && str && (str.length > 0 || str instanceof Object) ? parse(str) : null;
};
/**
 * Return an `Error` representative of this response.
 *
 * @return {Error}
 * @api public
 */

Response.prototype.toError = function () {
  var req = this.req;
  var method = req.method;
  var url = req.url;
  var msg = "cannot ".concat(method, " ").concat(url, " (").concat(this.status, ")");
  var err = new Error(msg);
  err.status = this.status;
  err.method = method;
  err.url = url;
  return err;
};
/**
 * Expose `Response`.
 */

request.Response = Response;
/**
 * Initialize a new `Request` with the given `method` and `url`.
 *
 * @param {String} method
 * @param {String} url
 * @api public
 */

function Request(method, url) {
  var self = this;
  this._query = this._query || [];
  this.method = method;
  this.url = url;
  this.header = {}; // preserves header name case

  this._header = {}; // coerces header names to lowercase

  this.on('end', function () {
    var err = null;
    var res = null;
    try {
      res = new Response(self);
    } catch (err_) {
      err = new Error('Parser is unable to parse the response');
      err.parse = true;
      err.original = err_; // issue #675: return the raw response if the response parsing fails

      if (self.xhr) {
        // ie9 doesn't have 'response' property
        err.rawResponse = typeof self.xhr.responseType === 'undefined' ? self.xhr.responseText : self.xhr.response; // issue #876: return the http status code if the response parsing fails

        err.status = self.xhr.status ? self.xhr.status : null;
        err.statusCode = err.status; // backwards-compat only
      } else {
        err.rawResponse = null;
        err.status = null;
      }
      return self.callback(err);
    }
    self.emit('response', res);
    var new_err;
    try {
      if (!self._isResponseOK(res)) {
        new_err = new Error(res.statusText || res.text || 'Unsuccessful HTTP response');
      }
    } catch (err_) {
      new_err = err_; // ok() callback can throw
    } // #1000 don't catch errors from the callback to avoid double calling it

    if (new_err) {
      new_err.original = err;
      new_err.response = res;
      new_err.status = res.status;
      self.callback(new_err, res);
    } else {
      self.callback(null, res);
    }
  });
}
/**
 * Mixin `Emitter` and `RequestBase`.
 */
// eslint-disable-next-line new-cap

Emitter(Request.prototype); // eslint-disable-next-line new-cap

RequestBase(Request.prototype);
/**
 * Set Content-Type to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.xml = 'application/xml';
 *
 *      request.post('/')
 *        .type('xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 *      request.post('/')
 *        .type('application/xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 * @param {String} type
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.type = function (type) {
  this.set('Content-Type', request.types[type] || type);
  return this;
};
/**
 * Set Accept to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.json = 'application/json';
 *
 *      request.get('/agent')
 *        .accept('json')
 *        .end(callback);
 *
 *      request.get('/agent')
 *        .accept('application/json')
 *        .end(callback);
 *
 * @param {String} accept
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.accept = function (type) {
  this.set('Accept', request.types[type] || type);
  return this;
};
/**
 * Set Authorization field value with `user` and `pass`.
 *
 * @param {String} user
 * @param {String} [pass] optional in case of using 'bearer' as type
 * @param {Object} options with 'type' property 'auto', 'basic' or 'bearer' (default 'basic')
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.auth = function (user, pass, options) {
  if (arguments.length === 1) pass = '';
  if (_typeof(pass) === 'object' && pass !== null) {
    // pass is optional and can be replaced with options
    options = pass;
    pass = '';
  }
  if (!options) {
    options = {
      type: typeof btoa === 'function' ? 'basic' : 'auto'
    };
  }
  var encoder = function encoder(string) {
    if (typeof btoa === 'function') {
      return btoa(string);
    }
    throw new Error('Cannot use basic auth, btoa is not a function');
  };
  return this._auth(user, pass, options, encoder);
};
/**
 * Add query-string `val`.
 *
 * Examples:
 *
 *   request.get('/shoes')
 *     .query('size=10')
 *     .query({ color: 'blue' })
 *
 * @param {Object|String} val
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.query = function (val) {
  if (typeof val !== 'string') val = serialize(val);
  if (val) this._query.push(val);
  return this;
};
/**
 * Queue the given `file` as an attachment to the specified `field`,
 * with optional `options` (or filename).
 *
 * ``` js
 * request.post('/upload')
 *   .attach('content', new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
 *   .end(callback);
 * ```
 *
 * @param {String} field
 * @param {Blob|File} file
 * @param {String|Object} options
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.attach = function (field, file, options) {
  if (file) {
    if (this._data) {
      throw new Error("superagent can't mix .send() and .attach()");
    }
    this._getFormData().append(field, file, options || file.name);
  }
  return this;
};
Request.prototype._getFormData = function () {
  if (!this._formData) {
    this._formData = new root.FormData();
  }
  return this._formData;
};
/**
 * Invoke the callback with `err` and `res`
 * and handle arity check.
 *
 * @param {Error} err
 * @param {Response} res
 * @api private
 */

Request.prototype.callback = function (err, res) {
  if (this._shouldRetry(err, res)) {
    return this._retry();
  }
  var fn = this._callback;
  this.clearTimeout();
  if (err) {
    if (this._maxRetries) err.retries = this._retries - 1;
    this.emit('error', err);
  }
  fn(err, res);
};
/**
 * Invoke callback with x-domain error.
 *
 * @api private
 */

Request.prototype.crossDomainError = function () {
  var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
  err.crossDomain = true;
  err.status = this.status;
  err.method = this.method;
  err.url = this.url;
  this.callback(err);
}; // This only warns, because the request is still likely to work

Request.prototype.agent = function () {
  console.warn('This is not supported in browser version of superagent');
  return this;
};
Request.prototype.ca = Request.prototype.agent;
Request.prototype.buffer = Request.prototype.ca; // This throws, because it can't send/receive data as expected

Request.prototype.write = function () {
  throw new Error('Streaming is not supported in browser version of superagent');
};
Request.prototype.pipe = Request.prototype.write;
/**
 * Check if `obj` is a host object,
 * we don't want to serialize these :)
 *
 * @param {Object} obj host object
 * @return {Boolean} is a host object
 * @api private
 */

Request.prototype._isHost = function (obj) {
  // Native objects stringify to [object File], [object Blob], [object FormData], etc.
  return obj && _typeof(obj) === 'object' && !Array.isArray(obj) && Object.prototype.toString.call(obj) !== '[object Object]';
};
/**
 * Initiate request, invoking callback `fn(res)`
 * with an instanceof `Response`.
 *
 * @param {Function} fn
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.end = function (fn) {
  if (this._endCalled) {
    console.warn('Warning: .end() was called twice. This is not supported in superagent');
  }
  this._endCalled = true; // store callback

  this._callback = fn || noop; // querystring

  this._finalizeQueryString();
  this._end();
};
Request.prototype._setUploadTimeout = function () {
  var self = this; // upload timeout it's wokrs only if deadline timeout is off

  if (this._uploadTimeout && !this._uploadTimeoutTimer) {
    this._uploadTimeoutTimer = setTimeout(function () {
      self._timeoutError('Upload timeout of ', self._uploadTimeout, 'ETIMEDOUT');
    }, this._uploadTimeout);
  }
}; // eslint-disable-next-line complexity

Request.prototype._end = function () {
  if (this._aborted) return this.callback(new Error('The request has been aborted even before .end() was called'));
  var self = this;
  this.xhr = request.getXHR();
  var xhr = this.xhr;
  var data = this._formData || this._data;
  this._setTimeouts(); // state change

  xhr.onreadystatechange = function () {
    var readyState = xhr.readyState;
    if (readyState >= 2 && self._responseTimeoutTimer) {
      clearTimeout(self._responseTimeoutTimer);
    }
    if (readyState !== 4) {
      return;
    } // In IE9, reads to any property (e.g. status) off of an aborted XHR will
    // result in the error "Could not complete the operation due to error c00c023f"

    var status;
    try {
      status = xhr.status;
    } catch (_unused5) {
      status = 0;
    }
    if (!status) {
      if (self.timedout || self._aborted) return;
      return self.crossDomainError();
    }
    self.emit('end');
  }; // progress

  var handleProgress = function handleProgress(direction, e) {
    if (e.total > 0) {
      e.percent = e.loaded / e.total * 100;
      if (e.percent === 100) {
        clearTimeout(self._uploadTimeoutTimer);
      }
    }
    e.direction = direction;
    self.emit('progress', e);
  };
  if (this.hasListeners('progress')) {
    try {
      xhr.addEventListener('progress', handleProgress.bind(null, 'download'));
      if (xhr.upload) {
        xhr.upload.addEventListener('progress', handleProgress.bind(null, 'upload'));
      }
    } catch (_unused6) {// Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
      // Reported here:
      // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
    }
  }
  if (xhr.upload) {
    this._setUploadTimeout();
  } // initiate request

  try {
    if (this.username && this.password) {
      xhr.open(this.method, this.url, true, this.username, this.password);
    } else {
      xhr.open(this.method, this.url, true);
    }
  } catch (err) {
    // see #1149
    return this.callback(err);
  } // CORS

  if (this._withCredentials) xhr.withCredentials = true; // body

  if (!this._formData && this.method !== 'GET' && this.method !== 'HEAD' && typeof data !== 'string' && !this._isHost(data)) {
    // serialize stuff
    var contentType = this._header['content-type'];
    var _serialize = this._serializer || request.serialize[contentType ? contentType.split(';')[0] : ''];
    if (!_serialize && isJSON(contentType)) {
      _serialize = request.serialize['application/json'];
    }
    if (_serialize) data = _serialize(data);
  } // set header fields

  for (var field in this.header) {
    if (this.header[field] === null) continue;
    if (Object.prototype.hasOwnProperty.call(this.header, field)) xhr.setRequestHeader(field, this.header[field]);
  }
  if (this._responseType) {
    xhr.responseType = this._responseType;
  } // send stuff

  this.emit('request', this); // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
  // We need null here if data is undefined

  xhr.send(typeof data === 'undefined' ? null : data);
};
request.agent = function () {
  return new Agent();
};
['GET', 'POST', 'OPTIONS', 'PATCH', 'PUT', 'DELETE'].forEach(function (method) {
  Agent.prototype[method.toLowerCase()] = function (url, fn) {
    var req = new request.Request(method, url);
    this._setDefaults(req);
    if (fn) {
      req.end(fn);
    }
    return req;
  };
});
Agent.prototype.del = Agent.prototype.delete;
/**
 * GET `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.get = function (url, data, fn) {
  var req = request('GET', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * HEAD `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.head = function (url, data, fn) {
  var req = request('HEAD', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * OPTIONS query to `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.options = function (url, data, fn) {
  var req = request('OPTIONS', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * DELETE `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

function del(url, data, fn) {
  var req = request('DELETE', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
}
request.del = del;
request.delete = del;
/**
 * PATCH `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.patch = function (url, data, fn) {
  var req = request('PATCH', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * POST `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.post = function (url, data, fn) {
  var req = request('POST', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * PUT `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.put = function (url, data, fn) {
  var req = request('PUT', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/***/ })

}]);
//# sourceMappingURL=visualization-cockpit.umd.1.js.map