((typeof self !== 'undefined' ? self : this)["webpackJsonpvisualization_cockpit"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpvisualization_cockpit"] || []).push([[73],{

/***/ "1e20":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module dependencies.
 */
__webpack_require__("9911");
var utils = __webpack_require__("9286");
/**
 * Expose `ResponseBase`.
 */

module.exports = ResponseBase;
/**
 * Initialize a new `ResponseBase`.
 *
 * @api public
 */

function ResponseBase(obj) {
  if (obj) return mixin(obj);
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in ResponseBase.prototype) {
    if (Object.prototype.hasOwnProperty.call(ResponseBase.prototype, key)) obj[key] = ResponseBase.prototype[key];
  }
  return obj;
}
/**
 * Get case-insensitive `field` value.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

ResponseBase.prototype.get = function (field) {
  return this.header[field.toLowerCase()];
};
/**
 * Set header related properties:
 *
 *   - `.type` the content type without params
 *
 * A response of "Content-Type: text/plain; charset=utf-8"
 * will provide you with a `.type` of "text/plain".
 *
 * @param {Object} header
 * @api private
 */

ResponseBase.prototype._setHeaderProperties = function (header) {
  // TODO: moar!
  // TODO: make this a util
  // content-type
  var ct = header['content-type'] || '';
  this.type = utils.type(ct); // params

  var params = utils.params(ct);
  for (var key in params) {
    if (Object.prototype.hasOwnProperty.call(params, key)) this[key] = params[key];
  }
  this.links = {}; // links

  try {
    if (header.link) {
      this.links = utils.parseLinks(header.link);
    }
  } catch (_unused) {// ignore
  }
};
/**
 * Set flags such as `.ok` based on `status`.
 *
 * For example a 2xx response will give you a `.ok` of __true__
 * whereas 5xx will be __false__ and `.error` will be __true__. The
 * `.clientError` and `.serverError` are also available to be more
 * specific, and `.statusType` is the class of error ranging from 1..5
 * sometimes useful for mapping respond colors etc.
 *
 * "sugar" properties are also defined for common cases. Currently providing:
 *
 *   - .noContent
 *   - .badRequest
 *   - .unauthorized
 *   - .notAcceptable
 *   - .notFound
 *
 * @param {Number} status
 * @api private
 */

ResponseBase.prototype._setStatusProperties = function (status) {
  var type = status / 100 | 0; // status / class

  this.statusCode = status;
  this.status = this.statusCode;
  this.statusType = type; // basics

  this.info = type === 1;
  this.ok = type === 2;
  this.redirect = type === 3;
  this.clientError = type === 4;
  this.serverError = type === 5;
  this.error = type === 4 || type === 5 ? this.toError() : false; // sugar

  this.created = status === 201;
  this.accepted = status === 202;
  this.noContent = status === 204;
  this.badRequest = status === 400;
  this.unauthorized = status === 401;
  this.notAcceptable = status === 406;
  this.forbidden = status === 403;
  this.notFound = status === 404;
  this.unprocessableEntity = status === 422;
};

/***/ }),

/***/ "8622":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("e260");
__webpack_require__("d3b7");
__webpack_require__("3ca3");
__webpack_require__("ddb0");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Check if `obj` is an object.
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
function isObject(obj) {
  return obj !== null && _typeof(obj) === 'object';
}
module.exports = isObject;

/***/ }),

/***/ "884f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("99af");
__webpack_require__("e260");
__webpack_require__("a15b");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("3ca3");
__webpack_require__("5319");
__webpack_require__("1276");
__webpack_require__("498a");
__webpack_require__("313d");
__webpack_require__("159b");
__webpack_require__("ddb0");
__webpack_require__("0eb6");
__webpack_require__("b7ef");
__webpack_require__("8bd4");
__webpack_require__("c73d");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Root reference for iframes.
 */
var root;
if (typeof window !== 'undefined') {
  // Browser window
  root = window;
} else if (typeof self === 'undefined') {
  // Other environments
  console.warn('Using browser-only version of superagent in non-browser environment');
  root = void 0;
} else {
  // Web Worker
  root = self;
}
var Emitter = __webpack_require__("7297");
var safeStringify = __webpack_require__("375a");
var RequestBase = __webpack_require__("f018");
var isObject = __webpack_require__("8622");
var ResponseBase = __webpack_require__("1e20");
var Agent = __webpack_require__("8b8d");
/**
 * Noop.
 */

function noop() {}
/**
 * Expose `request`.
 */

module.exports = function (method, url) {
  // callback
  if (typeof url === 'function') {
    return new exports.Request('GET', method).end(url);
  } // url first

  if (arguments.length === 1) {
    return new exports.Request('GET', method);
  }
  return new exports.Request(method, url);
};
exports = module.exports;
var request = exports;
exports.Request = Request;
/**
 * Determine XHR.
 */

request.getXHR = function () {
  if (root.XMLHttpRequest && (!root.location || root.location.protocol !== 'file:' || !root.ActiveXObject)) {
    return new XMLHttpRequest();
  }
  try {
    return new ActiveXObject('Microsoft.XMLHTTP');
  } catch (_unused) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP.6.0');
  } catch (_unused2) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP.3.0');
  } catch (_unused3) {}
  try {
    return new ActiveXObject('Msxml2.XMLHTTP');
  } catch (_unused4) {}
  throw new Error('Browser-only version of superagent could not find XHR');
};
/**
 * Removes leading and trailing whitespace, added to support IE.
 *
 * @param {String} s
 * @return {String}
 * @api private
 */

var trim = ''.trim ? function (s) {
  return s.trim();
} : function (s) {
  return s.replace(/(^\s*|\s*$)/g, '');
};
/**
 * Serialize the given `obj`.
 *
 * @param {Object} obj
 * @return {String}
 * @api private
 */

function serialize(obj) {
  if (!isObject(obj)) return obj;
  var pairs = [];
  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) pushEncodedKeyValuePair(pairs, key, obj[key]);
  }
  return pairs.join('&');
}
/**
 * Helps 'serialize' with serializing arrays.
 * Mutates the pairs array.
 *
 * @param {Array} pairs
 * @param {String} key
 * @param {Mixed} val
 */

function pushEncodedKeyValuePair(pairs, key, val) {
  if (val === undefined) return;
  if (val === null) {
    pairs.push(encodeURI(key));
    return;
  }
  if (Array.isArray(val)) {
    val.forEach(function (v) {
      pushEncodedKeyValuePair(pairs, key, v);
    });
  } else if (isObject(val)) {
    for (var subkey in val) {
      if (Object.prototype.hasOwnProperty.call(val, subkey)) pushEncodedKeyValuePair(pairs, "".concat(key, "[").concat(subkey, "]"), val[subkey]);
    }
  } else {
    pairs.push(encodeURI(key) + '=' + encodeURIComponent(val));
  }
}
/**
 * Expose serialization method.
 */

request.serializeObject = serialize;
/**
 * Parse the given x-www-form-urlencoded `str`.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseString(str) {
  var obj = {};
  var pairs = str.split('&');
  var pair;
  var pos;
  for (var i = 0, len = pairs.length; i < len; ++i) {
    pair = pairs[i];
    pos = pair.indexOf('=');
    if (pos === -1) {
      obj[decodeURIComponent(pair)] = '';
    } else {
      obj[decodeURIComponent(pair.slice(0, pos))] = decodeURIComponent(pair.slice(pos + 1));
    }
  }
  return obj;
}
/**
 * Expose parser.
 */

request.parseString = parseString;
/**
 * Default MIME type map.
 *
 *     superagent.types.xml = 'application/xml';
 *
 */

request.types = {
  html: 'text/html',
  json: 'application/json',
  xml: 'text/xml',
  urlencoded: 'application/x-www-form-urlencoded',
  form: 'application/x-www-form-urlencoded',
  'form-data': 'application/x-www-form-urlencoded'
};
/**
 * Default serialization map.
 *
 *     superagent.serialize['application/xml'] = function(obj){
 *       return 'generated xml here';
 *     };
 *
 */

request.serialize = {
  'application/x-www-form-urlencoded': serialize,
  'application/json': safeStringify
};
/**
 * Default parsers.
 *
 *     superagent.parse['application/xml'] = function(str){
 *       return { object parsed from str };
 *     };
 *
 */

request.parse = {
  'application/x-www-form-urlencoded': parseString,
  'application/json': JSON.parse
};
/**
 * Parse the given header `str` into
 * an object containing the mapped fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseHeader(str) {
  var lines = str.split(/\r?\n/);
  var fields = {};
  var index;
  var line;
  var field;
  var val;
  for (var i = 0, len = lines.length; i < len; ++i) {
    line = lines[i];
    index = line.indexOf(':');
    if (index === -1) {
      // could be empty line, just skip it
      continue;
    }
    field = line.slice(0, index).toLowerCase();
    val = trim(line.slice(index + 1));
    fields[field] = val;
  }
  return fields;
}
/**
 * Check if `mime` is json or has +json structured syntax suffix.
 *
 * @param {String} mime
 * @return {Boolean}
 * @api private
 */

function isJSON(mime) {
  // should match /json or +json
  // but not /json-seq
  return /[/+]json($|[^-\w])/.test(mime);
}
/**
 * Initialize a new `Response` with the given `xhr`.
 *
 *  - set flags (.ok, .error, etc)
 *  - parse header
 *
 * Examples:
 *
 *  Aliasing `superagent` as `request` is nice:
 *
 *      request = superagent;
 *
 *  We can use the promise-like API, or pass callbacks:
 *
 *      request.get('/').end(function(res){});
 *      request.get('/', function(res){});
 *
 *  Sending data can be chained:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' })
 *        .end(function(res){});
 *
 *  Or passed to `.send()`:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' }, function(res){});
 *
 *  Or passed to `.post()`:
 *
 *      request
 *        .post('/user', { name: 'tj' })
 *        .end(function(res){});
 *
 * Or further reduced to a single call for simple cases:
 *
 *      request
 *        .post('/user', { name: 'tj' }, function(res){});
 *
 * @param {XMLHTTPRequest} xhr
 * @param {Object} options
 * @api private
 */

function Response(req) {
  this.req = req;
  this.xhr = this.req.xhr; // responseText is accessible only if responseType is '' or 'text' and on older browsers

  this.text = this.req.method !== 'HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text') || typeof this.xhr.responseType === 'undefined' ? this.xhr.responseText : null;
  this.statusText = this.req.xhr.statusText;
  var status = this.xhr.status; // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request

  if (status === 1223) {
    status = 204;
  }
  this._setStatusProperties(status);
  this.headers = parseHeader(this.xhr.getAllResponseHeaders());
  this.header = this.headers; // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
  // getResponseHeader still works. so we get content-type even if getting
  // other headers fails.

  this.header['content-type'] = this.xhr.getResponseHeader('content-type');
  this._setHeaderProperties(this.header);
  if (this.text === null && req._responseType) {
    this.body = this.xhr.response;
  } else {
    this.body = this.req.method === 'HEAD' ? null : this._parseBody(this.text ? this.text : this.xhr.response);
  }
} // eslint-disable-next-line new-cap

ResponseBase(Response.prototype);
/**
 * Parse the given body `str`.
 *
 * Used for auto-parsing of bodies. Parsers
 * are defined on the `superagent.parse` object.
 *
 * @param {String} str
 * @return {Mixed}
 * @api private
 */

Response.prototype._parseBody = function (str) {
  var parse = request.parse[this.type];
  if (this.req._parser) {
    return this.req._parser(this, str);
  }
  if (!parse && isJSON(this.type)) {
    parse = request.parse['application/json'];
  }
  return parse && str && (str.length > 0 || str instanceof Object) ? parse(str) : null;
};
/**
 * Return an `Error` representative of this response.
 *
 * @return {Error}
 * @api public
 */

Response.prototype.toError = function () {
  var req = this.req;
  var method = req.method;
  var url = req.url;
  var msg = "cannot ".concat(method, " ").concat(url, " (").concat(this.status, ")");
  var err = new Error(msg);
  err.status = this.status;
  err.method = method;
  err.url = url;
  return err;
};
/**
 * Expose `Response`.
 */

request.Response = Response;
/**
 * Initialize a new `Request` with the given `method` and `url`.
 *
 * @param {String} method
 * @param {String} url
 * @api public
 */

function Request(method, url) {
  var self = this;
  this._query = this._query || [];
  this.method = method;
  this.url = url;
  this.header = {}; // preserves header name case

  this._header = {}; // coerces header names to lowercase

  this.on('end', function () {
    var err = null;
    var res = null;
    try {
      res = new Response(self);
    } catch (err_) {
      err = new Error('Parser is unable to parse the response');
      err.parse = true;
      err.original = err_; // issue #675: return the raw response if the response parsing fails

      if (self.xhr) {
        // ie9 doesn't have 'response' property
        err.rawResponse = typeof self.xhr.responseType === 'undefined' ? self.xhr.responseText : self.xhr.response; // issue #876: return the http status code if the response parsing fails

        err.status = self.xhr.status ? self.xhr.status : null;
        err.statusCode = err.status; // backwards-compat only
      } else {
        err.rawResponse = null;
        err.status = null;
      }
      return self.callback(err);
    }
    self.emit('response', res);
    var new_err;
    try {
      if (!self._isResponseOK(res)) {
        new_err = new Error(res.statusText || res.text || 'Unsuccessful HTTP response');
      }
    } catch (err_) {
      new_err = err_; // ok() callback can throw
    } // #1000 don't catch errors from the callback to avoid double calling it

    if (new_err) {
      new_err.original = err;
      new_err.response = res;
      new_err.status = res.status;
      self.callback(new_err, res);
    } else {
      self.callback(null, res);
    }
  });
}
/**
 * Mixin `Emitter` and `RequestBase`.
 */
// eslint-disable-next-line new-cap

Emitter(Request.prototype); // eslint-disable-next-line new-cap

RequestBase(Request.prototype);
/**
 * Set Content-Type to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.xml = 'application/xml';
 *
 *      request.post('/')
 *        .type('xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 *      request.post('/')
 *        .type('application/xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 * @param {String} type
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.type = function (type) {
  this.set('Content-Type', request.types[type] || type);
  return this;
};
/**
 * Set Accept to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.json = 'application/json';
 *
 *      request.get('/agent')
 *        .accept('json')
 *        .end(callback);
 *
 *      request.get('/agent')
 *        .accept('application/json')
 *        .end(callback);
 *
 * @param {String} accept
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.accept = function (type) {
  this.set('Accept', request.types[type] || type);
  return this;
};
/**
 * Set Authorization field value with `user` and `pass`.
 *
 * @param {String} user
 * @param {String} [pass] optional in case of using 'bearer' as type
 * @param {Object} options with 'type' property 'auto', 'basic' or 'bearer' (default 'basic')
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.auth = function (user, pass, options) {
  if (arguments.length === 1) pass = '';
  if (_typeof(pass) === 'object' && pass !== null) {
    // pass is optional and can be replaced with options
    options = pass;
    pass = '';
  }
  if (!options) {
    options = {
      type: typeof btoa === 'function' ? 'basic' : 'auto'
    };
  }
  var encoder = function encoder(string) {
    if (typeof btoa === 'function') {
      return btoa(string);
    }
    throw new Error('Cannot use basic auth, btoa is not a function');
  };
  return this._auth(user, pass, options, encoder);
};
/**
 * Add query-string `val`.
 *
 * Examples:
 *
 *   request.get('/shoes')
 *     .query('size=10')
 *     .query({ color: 'blue' })
 *
 * @param {Object|String} val
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.query = function (val) {
  if (typeof val !== 'string') val = serialize(val);
  if (val) this._query.push(val);
  return this;
};
/**
 * Queue the given `file` as an attachment to the specified `field`,
 * with optional `options` (or filename).
 *
 * ``` js
 * request.post('/upload')
 *   .attach('content', new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
 *   .end(callback);
 * ```
 *
 * @param {String} field
 * @param {Blob|File} file
 * @param {String|Object} options
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.attach = function (field, file, options) {
  if (file) {
    if (this._data) {
      throw new Error("superagent can't mix .send() and .attach()");
    }
    this._getFormData().append(field, file, options || file.name);
  }
  return this;
};
Request.prototype._getFormData = function () {
  if (!this._formData) {
    this._formData = new root.FormData();
  }
  return this._formData;
};
/**
 * Invoke the callback with `err` and `res`
 * and handle arity check.
 *
 * @param {Error} err
 * @param {Response} res
 * @api private
 */

Request.prototype.callback = function (err, res) {
  if (this._shouldRetry(err, res)) {
    return this._retry();
  }
  var fn = this._callback;
  this.clearTimeout();
  if (err) {
    if (this._maxRetries) err.retries = this._retries - 1;
    this.emit('error', err);
  }
  fn(err, res);
};
/**
 * Invoke callback with x-domain error.
 *
 * @api private
 */

Request.prototype.crossDomainError = function () {
  var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
  err.crossDomain = true;
  err.status = this.status;
  err.method = this.method;
  err.url = this.url;
  this.callback(err);
}; // This only warns, because the request is still likely to work

Request.prototype.agent = function () {
  console.warn('This is not supported in browser version of superagent');
  return this;
};
Request.prototype.ca = Request.prototype.agent;
Request.prototype.buffer = Request.prototype.ca; // This throws, because it can't send/receive data as expected

Request.prototype.write = function () {
  throw new Error('Streaming is not supported in browser version of superagent');
};
Request.prototype.pipe = Request.prototype.write;
/**
 * Check if `obj` is a host object,
 * we don't want to serialize these :)
 *
 * @param {Object} obj host object
 * @return {Boolean} is a host object
 * @api private
 */

Request.prototype._isHost = function (obj) {
  // Native objects stringify to [object File], [object Blob], [object FormData], etc.
  return obj && _typeof(obj) === 'object' && !Array.isArray(obj) && Object.prototype.toString.call(obj) !== '[object Object]';
};
/**
 * Initiate request, invoking callback `fn(res)`
 * with an instanceof `Response`.
 *
 * @param {Function} fn
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.end = function (fn) {
  if (this._endCalled) {
    console.warn('Warning: .end() was called twice. This is not supported in superagent');
  }
  this._endCalled = true; // store callback

  this._callback = fn || noop; // querystring

  this._finalizeQueryString();
  this._end();
};
Request.prototype._setUploadTimeout = function () {
  var self = this; // upload timeout it's wokrs only if deadline timeout is off

  if (this._uploadTimeout && !this._uploadTimeoutTimer) {
    this._uploadTimeoutTimer = setTimeout(function () {
      self._timeoutError('Upload timeout of ', self._uploadTimeout, 'ETIMEDOUT');
    }, this._uploadTimeout);
  }
}; // eslint-disable-next-line complexity

Request.prototype._end = function () {
  if (this._aborted) return this.callback(new Error('The request has been aborted even before .end() was called'));
  var self = this;
  this.xhr = request.getXHR();
  var xhr = this.xhr;
  var data = this._formData || this._data;
  this._setTimeouts(); // state change

  xhr.onreadystatechange = function () {
    var readyState = xhr.readyState;
    if (readyState >= 2 && self._responseTimeoutTimer) {
      clearTimeout(self._responseTimeoutTimer);
    }
    if (readyState !== 4) {
      return;
    } // In IE9, reads to any property (e.g. status) off of an aborted XHR will
    // result in the error "Could not complete the operation due to error c00c023f"

    var status;
    try {
      status = xhr.status;
    } catch (_unused5) {
      status = 0;
    }
    if (!status) {
      if (self.timedout || self._aborted) return;
      return self.crossDomainError();
    }
    self.emit('end');
  }; // progress

  var handleProgress = function handleProgress(direction, e) {
    if (e.total > 0) {
      e.percent = e.loaded / e.total * 100;
      if (e.percent === 100) {
        clearTimeout(self._uploadTimeoutTimer);
      }
    }
    e.direction = direction;
    self.emit('progress', e);
  };
  if (this.hasListeners('progress')) {
    try {
      xhr.addEventListener('progress', handleProgress.bind(null, 'download'));
      if (xhr.upload) {
        xhr.upload.addEventListener('progress', handleProgress.bind(null, 'upload'));
      }
    } catch (_unused6) {// Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
      // Reported here:
      // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
    }
  }
  if (xhr.upload) {
    this._setUploadTimeout();
  } // initiate request

  try {
    if (this.username && this.password) {
      xhr.open(this.method, this.url, true, this.username, this.password);
    } else {
      xhr.open(this.method, this.url, true);
    }
  } catch (err) {
    // see #1149
    return this.callback(err);
  } // CORS

  if (this._withCredentials) xhr.withCredentials = true; // body

  if (!this._formData && this.method !== 'GET' && this.method !== 'HEAD' && typeof data !== 'string' && !this._isHost(data)) {
    // serialize stuff
    var contentType = this._header['content-type'];
    var _serialize = this._serializer || request.serialize[contentType ? contentType.split(';')[0] : ''];
    if (!_serialize && isJSON(contentType)) {
      _serialize = request.serialize['application/json'];
    }
    if (_serialize) data = _serialize(data);
  } // set header fields

  for (var field in this.header) {
    if (this.header[field] === null) continue;
    if (Object.prototype.hasOwnProperty.call(this.header, field)) xhr.setRequestHeader(field, this.header[field]);
  }
  if (this._responseType) {
    xhr.responseType = this._responseType;
  } // send stuff

  this.emit('request', this); // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
  // We need null here if data is undefined

  xhr.send(typeof data === 'undefined' ? null : data);
};
request.agent = function () {
  return new Agent();
};
['GET', 'POST', 'OPTIONS', 'PATCH', 'PUT', 'DELETE'].forEach(function (method) {
  Agent.prototype[method.toLowerCase()] = function (url, fn) {
    var req = new request.Request(method, url);
    this._setDefaults(req);
    if (fn) {
      req.end(fn);
    }
    return req;
  };
});
Agent.prototype.del = Agent.prototype.delete;
/**
 * GET `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.get = function (url, data, fn) {
  var req = request('GET', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * HEAD `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.head = function (url, data, fn) {
  var req = request('HEAD', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * OPTIONS query to `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.options = function (url, data, fn) {
  var req = request('OPTIONS', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * DELETE `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

function del(url, data, fn) {
  var req = request('DELETE', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
}
request.del = del;
request.delete = del;
/**
 * PATCH `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.patch = function (url, data, fn) {
  var req = request('PATCH', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * POST `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.post = function (url, data, fn) {
  var req = request('POST', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};
/**
 * PUT `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.put = function (url, data, fn) {
  var req = request('PUT', url);
  if (typeof data === 'function') {
    fn = data;
    data = null;
  }
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/***/ }),

/***/ "8b8d":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("a630");
__webpack_require__("e260");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("3ca3");
__webpack_require__("159b");
__webpack_require__("ddb0");
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function Agent() {
  this._defaults = [];
}
['use', 'on', 'once', 'set', 'query', 'type', 'accept', 'auth', 'withCredentials', 'sortQuery', 'retry', 'ok', 'redirects', 'timeout', 'buffer', 'serialize', 'parse', 'ca', 'key', 'pfx', 'cert', 'disableTLSCerts'].forEach(function (fn) {
  // Default setting for all requests from this agent
  Agent.prototype[fn] = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    this._defaults.push({
      fn: fn,
      args: args
    });
    return this;
  };
});
Agent.prototype._setDefaults = function (req) {
  this._defaults.forEach(function (def) {
    req[def.fn].apply(req, _toConsumableArray(def.args));
  });
};
module.exports = Agent;

/***/ }),

/***/ "9286":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Return the mime type for the given `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */
__webpack_require__("fb6a");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("1276");
exports.type = function (str) {
  return str.split(/ *; */).shift();
};
/**
 * Return header field parameters.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.params = function (str) {
  return str.split(/ *; */).reduce(function (obj, str) {
    var parts = str.split(/ *= */);
    var key = parts.shift();
    var val = parts.shift();
    if (key && val) obj[key] = val;
    return obj;
  }, {});
};
/**
 * Parse Link header fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.parseLinks = function (str) {
  return str.split(/ *, */).reduce(function (obj, str) {
    var parts = str.split(/ *; */);
    var url = parts[0].slice(1, -1);
    var rel = parts[1].split(/ *= */)[1].slice(1, -1);
    obj[rel] = url;
    return obj;
  }, {});
};
/**
 * Strip content related fields from `header`.
 *
 * @param {Object} header
 * @return {Object} header
 * @api private
 */

exports.cleanHeader = function (header, changesOrigin) {
  delete header['content-type'];
  delete header['content-length'];
  delete header['transfer-encoding'];
  delete header.host; // secuirty

  if (changesOrigin) {
    delete header.authorization;
    delete header.cookie;
  }
  return header;
};

/***/ }),

/***/ "b41b":
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, module) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;var _classCallCheck = __webpack_require__("970b").default;
var _createClass = __webpack_require__("5bc3").default;
var _typeof = __webpack_require__("7037").default;
__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("944a");
__webpack_require__("d9e2");
__webpack_require__("4de4");
__webpack_require__("caad");
__webpack_require__("a15b");
__webpack_require__("d81d");
__webpack_require__("b0c0");
__webpack_require__("6c57");
__webpack_require__("0c47");
__webpack_require__("23dc");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("ac1f");
__webpack_require__("25f0");
__webpack_require__("466d");
__webpack_require__("5319");
__webpack_require__("159b");
__webpack_require__("c73d");
(function (y, v) {
  ( false ? undefined : _typeof(exports)) == "object" && ( false ? undefined : _typeof(module)) < "u" ? v(exports, __webpack_require__("884f")) :  true ? !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__("884f")], __WEBPACK_AMD_DEFINE_FACTORY__ = (v),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)) : (undefined);
})(this, function (y, v) {
  "use strict";

  var Ye = Object.defineProperty;
  var Ze = function Ze(y, v, n) {
    return v in y ? Ye(y, v, {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: n
    }) : y[v] = n;
  };
  var ee = function ee(y, v, n) {
    return Ze(y, _typeof(v) != "symbol" ? v + "" : v, n), n;
  };
  var S = /*#__PURE__*/function () {
    function S() {
      _classCallCheck(this, S);
      this.basePath = "/".replace(/\/+$/, ""), this.authentications = {
        oauth2: {
          type: "oauth2"
        }
      }, this.defaultHeaders = {}, this.timeout = 6e4, this.cache = !0, this.enableCookies = !1, (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && (this.agent = new v.agent()), this.requestAgent = null;
    }
    return _createClass(S, [{
      key: "paramToString",
      value: function paramToString(e) {
        return e == null || e == null ? "" : e instanceof Date ? e.toJSON() : e.toString();
      }
    }, {
      key: "buildUrl",
      value: function buildUrl(e, t) {
        var _this = this;
        e.match(/^\//) || (e = "/" + e);
        var r = this.basePath + e;
        return r = r.replace(/\{([\w-]+)\}/g, function (p, i) {
          var o;
          return t.hasOwnProperty(i) ? o = _this.paramToString(t[i]) : o = p, encodeURIComponent(o);
        }), r;
      }
    }, {
      key: "isJsonMime",
      value: function isJsonMime(e) {
        return !!(e != null && e.match(/^application\/json(;.*)?$/i));
      }
    }, {
      key: "jsonPreferredMime",
      value: function jsonPreferredMime(e) {
        for (var t = 0; t < e.length; t++) if (this.isJsonMime(e[t])) return e[t];
        return e[0];
      }
    }, {
      key: "isFileParam",
      value: function isFileParam(e) {
        if (true) {
          var t;
          try {
            t = __webpack_require__(34);
          } catch (_unused) {}
          if (t && t.ReadStream && e instanceof t.ReadStream) return !0;
        }
        return typeof Buffer == "function" && e instanceof Buffer || typeof Blob == "function" && e instanceof Blob || typeof File == "function" && e instanceof File;
      }
    }, {
      key: "normalizeParams",
      value: function normalizeParams(e) {
        var t = {};
        for (var r in e) if (e.hasOwnProperty(r) && e[r] != null && e[r] != null) {
          var p = e[r];
          this.isFileParam(p) || Array.isArray(p) ? t[r] = p : t[r] = this.paramToString(p);
        }
        return t;
      }
    }, {
      key: "buildCollectionParam",
      value: function buildCollectionParam(e, t) {
        if (e == null) return null;
        switch (t) {
          case "csv":
            return e.map(this.paramToString).join(",");
          case "ssv":
            return e.map(this.paramToString).join(" ");
          case "tsv":
            return e.map(this.paramToString).join("	");
          case "pipes":
            return e.map(this.paramToString).join("|");
          case "multi":
            return e.map(this.paramToString);
          default:
            throw new Error("Unknown collection format: " + t);
        }
      }
    }, {
      key: "applyAuthToRequest",
      value: function applyAuthToRequest(e, t) {
        var _this2 = this;
        t.forEach(function (r) {
          var p = _this2.authentications[r];
          switch (p.type) {
            case "basic":
              (p.username || p.password) && e.auth(p.username || "", p.password || "");
              break;
            case "apiKey":
              if (p.apiKey) {
                var i = {};
                p.apiKeyPrefix ? i[p.name] = p.apiKeyPrefix + " " + p.apiKey : i[p.name] = p.apiKey, p.in === "header" ? e.set(i) : e.query(i);
              }
              break;
            case "oauth2":
              p.accessToken && e.set({
                Authorization: "Bearer " + p.accessToken
              });
              break;
            default:
              throw new Error("Unknown authentication type: " + p.type);
          }
        });
      }
    }, {
      key: "deserialize",
      value: function deserialize(e, t) {
        if (e == null || e.status == 204) return null;
        var r = e.body;
        if ((r == null || _typeof(r) == "object" && _typeof(r.length) > "u" && !Object.keys(r).length) && (r = e.text), t == null && ["easc3"].includes("open-api-management")) return {
          data: r
        };
        var p = S.convertToType(r.data, t);
        return {
          code: r.code,
          data: p
        };
      }
    }, {
      key: "callApi",
      value: function callApi(e, t, r, p, i, o, a, s, l, c, x) {
        var _this3 = this;
        var Qe = this.buildUrl(e, r),
          P = v(t, Qe);
        this.applyAuthToRequest(P, s), t.toUpperCase() === "GET" && this.cache === !1 && (p._ = new Date().getTime()), P.query(this.normalizeParams(p)), P.set(this.defaultHeaders).set(this.normalizeParams(i)), this.requestAgent && P.agent(this.requestAgent), P.timeout(this.timeout);
        var Pe = this.jsonPreferredMime(l);
        if (Pe ? Pe != "multipart/form-data" && P.type(Pe) : P.header["Content-Type"] || P.type("application/json"), Pe === "application/x-www-form-urlencoded") P.send(S.stringify(this.normalizeParams(o)));else if (Pe == "multipart/form-data") {
          var Oe = this.normalizeParams(o);
          for (var me in Oe) Oe.hasOwnProperty(me) && (this.isFileParam(Oe[me]) ? P.attach(me, Oe[me]) : P.field(me, Oe[me]));
        } else a && P.send(a);
        var ke = this.jsonPreferredMime(c);
        return ke && P.accept(ke), x === "Blob" ? P.responseType("blob") : x === "String" && P.responseType("string"), this.enableCookies && ((typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" ? this.agent.attachCookies(P) : P.withCredentials()), new Promise(function (Je, Ve) {
          P.end(function (ze, We) {
            if (ze) Ve(ze);else try {
              var $e = _this3.deserialize(We, x);
              _this3.enableCookies && (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && _this3.agent.saveCookies(We), Je({
                data: $e,
                response: We
              });
            } catch (Xe) {
              Ve(Xe);
            }
          });
        });
      }
    }], [{
      key: "parseDate",
      value: function parseDate(e) {
        return new Date(e);
      }
    }, {
      key: "convertToType",
      value: function convertToType(e, t) {
        if (e == null) return e;
        switch (t) {
          case "Boolean":
            return !!e;
          case "Integer":
            return parseInt(e, 10);
          case "Number":
            return parseFloat(e);
          case "String":
            return String(e);
          case "Date":
            return S.parseDate(String(e));
          case "Blob":
            return e;
          default:
            if (t === Object) return e;
            if (typeof t == "function") return t.constructFromObject(e);
            if (Array.isArray(t)) {
              var r = t[0];
              return e.map(function (c) {
                return S.convertToType(c, r);
              });
            } else if (_typeof(t) == "object") {
              var p, i;
              for (var o in t) if (t.hasOwnProperty(o)) {
                p = o, i = t[o];
                break;
              }
              var a = {};
              for (var o in e) if (e.hasOwnProperty(o)) {
                var s = S.convertToType(o, p),
                  l = S.convertToType(e[o], i);
                a[s] = l;
              }
              return a;
            } else return e;
        }
      }
    }, {
      key: "constructFromObject",
      value: function constructFromObject(e, t, r) {
        if (Array.isArray(e)) for (var p = 0; p < e.length; p++) e.hasOwnProperty(p) && (t[p] = S.convertToType(e[p], r));else for (var i in e) e.hasOwnProperty(i) && (t[i] = S.convertToType(e[i], r));
      }
    }, {
      key: "GetInstance",
      value: function GetInstance(e, t) {
        return Wiz ? Wiz.GetApiClientInstance(e, t) : new S();
      }
    }, {
      key: "stringifyPrimitive",
      value: function stringifyPrimitive(e) {
        switch (_typeof(e)) {
          case "string":
            return e;
          case "boolean":
            return e ? "true" : "false";
          case "number":
            return isFinite(e) ? e : "";
          default:
            return "";
        }
      }
    }, {
      key: "stringify",
      value: function stringify(e, t, r, p) {
        return t = t || "&", r = r || "=", e === null && (e = void 0), _typeof(e) == "object" ? Object.keys(e).map(function (i) {
          var o = encodeURIComponent(S.stringifyPrimitive(i)) + r;
          return Array.isArray(e[i]) ? e[i].map(function (a) {
            return o + encodeURIComponent(S.stringifyPrimitive(a));
          }).join(t) : o + encodeURIComponent(S.stringifyPrimitive(e[i]));
        }).filter(Boolean).join(t) : p ? encodeURIComponent(S.stringifyPrimitive(p)) + r + encodeURIComponent(S.stringifyPrimitive(e)) : "";
      }
    }]);
  }();
  ee(S, "CollectionFormatEnum", {
    CSV: ",",
    SSV: " ",
    TSV: "	",
    PIPES: "|",
    MULTI: "multi"
  });
  var n = S;
  var te = /*#__PURE__*/function () {
    function te() {
      _classCallCheck(this, te);
    }
    return _createClass(te, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new te(), e.hasOwnProperty("members") && (t.members = n.convertToType(e.members, ["String"])), e.hasOwnProperty("message") && (t.message = n.convertToType(e.message, "String"))), t;
      }
    }]);
  }();
  te.prototype.members = void 0, te.prototype.message = void 0;
  var L = /*#__PURE__*/function () {
    function L() {
      _classCallCheck(this, L);
    }
    return _createClass(L, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new L(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = n.convertToType(e.data, {
          String: Object
        })), e.hasOwnProperty("details") && (t.details = n.convertToType(e.details, "String")), e.hasOwnProperty("message") && (t.message = n.convertToType(e.message, "String")), e.hasOwnProperty("validationErrors") && (t.validationErrors = n.convertToType(e.validationErrors, [te]))), t;
      }
    }]);
  }();
  L.prototype.code = void 0, L.prototype.data = void 0, L.prototype.details = void 0, L.prototype.message = void 0, L.prototype.validationErrors = void 0;
  var Se = /*#__PURE__*/function () {
    function Se() {
      _classCallCheck(this, Se);
    }
    return _createClass(Se, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Se(), e.hasOwnProperty("error") && (t.error = L.constructFromObject(e.error))), t;
      }
    }]);
  }();
  Se.prototype.error = void 0;
  var we = /*#__PURE__*/function () {
    function we() {
      _classCallCheck(this, we);
    }
    return _createClass(we, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new we(), e.hasOwnProperty("encryptSecretKey") && (t.encryptSecretKey = n.convertToType(e.encryptSecretKey, "String"))), t;
      }
    }]);
  }();
  we.prototype.encryptSecretKey = void 0;
  var Ae = /*#__PURE__*/function () {
    function Ae() {
      _classCallCheck(this, Ae);
    }
    return _createClass(Ae, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Ae(), e.hasOwnProperty("file") && (t.file = n.convertToType(e.file, "Blob"))), t;
      }
    }]);
  }();
  Ae.prototype.file = void 0;
  var Ie = /*#__PURE__*/function () {
    function Ie() {
      _classCallCheck(this, Ie);
    }
    return _createClass(Ie, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Ie(), e.hasOwnProperty("file") && (t.file = n.convertToType(e.file, "Blob"))), t;
      }
    }]);
  }();
  Ie.prototype.file = void 0;
  var ne = {
    _1: 1,
    _2: 2,
    _3: 3,
    _4: 4,
    constructFromObject: function constructFromObject(d) {
      return d;
    }
  };
  var ue = /*#__PURE__*/function () {
    function ue() {
      _classCallCheck(this, ue);
    }
    return _createClass(ue, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ue(), e.hasOwnProperty("connectionString") && (t.connectionString = n.convertToType(e.connectionString, "String")), e.hasOwnProperty("dbType") && (t.dbType = ne.constructFromObject(e.dbType))), t;
      }
    }]);
  }();
  ue.prototype.connectionString = void 0, ue.prototype.dbType = void 0;
  var pe = /*#__PURE__*/function () {
    function pe() {
      _classCallCheck(this, pe);
    }
    return _createClass(pe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new pe(), e.hasOwnProperty("request") && (t.request = n.convertToType(e.request, "String")), e.hasOwnProperty("response") && (t.response = n.convertToType(e.response, "String"))), t;
      }
    }]);
  }();
  pe.prototype.request = void 0, pe.prototype.response = void 0;
  var J = /*#__PURE__*/function () {
    function J() {
      _classCallCheck(this, J);
    }
    return _createClass(J, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new J(), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String"))), t;
      }
    }]);
  }();
  J.prototype.flag = void 0, J.prototype.openApiId = void 0;
  var G = /*#__PURE__*/function () {
    function G(e, t, r, p) {
      _classCallCheck(this, G);
      this.applyDepartment = e, this.applyUser = t, this.name = r, this.secretKey = p;
    }
    return _createClass(G, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new G(), e.hasOwnProperty("applyDepartment") && (t.applyDepartment = n.convertToType(e.applyDepartment, "String")), e.hasOwnProperty("applyOpenApiRecords") && (t.applyOpenApiRecords = n.convertToType(e.applyOpenApiRecords, [J])), e.hasOwnProperty("applyUser") && (t.applyUser = n.convertToType(e.applyUser, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("remark") && (t.remark = n.convertToType(e.remark, "String")), e.hasOwnProperty("secretKey") && (t.secretKey = n.convertToType(e.secretKey, "String"))), t;
      }
    }]);
  }();
  G.prototype.applyDepartment = void 0, G.prototype.applyOpenApiRecords = void 0, G.prototype.applyUser = void 0, G.prototype.description = void 0, G.prototype.flag = void 0, G.prototype.name = void 0, G.prototype.remark = void 0, G.prototype.secretKey = void 0;
  var Ee = {
    _1: 1,
    _2: 2,
    _3: 3,
    _4: 4,
    constructFromObject: function constructFromObject(d) {
      return d;
    }
  };
  var C = /*#__PURE__*/function () {
    function C() {
      _classCallCheck(this, C);
    }
    return _createClass(C, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new C(), e.hasOwnProperty("applyApplicationId") && (t.applyApplicationId = n.convertToType(e.applyApplicationId, "String")), e.hasOwnProperty("auditStatus") && (t.auditStatus = Ee.constructFromObject(e.auditStatus)), e.hasOwnProperty("auditTime") && (t.auditTime = n.convertToType(e.auditTime, "Date")), e.hasOwnProperty("auditUser") && (t.auditUser = n.convertToType(e.auditUser, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String"))), t;
      }
    }]);
  }();
  C.prototype.applyApplicationId = void 0, C.prototype.auditStatus = void 0, C.prototype.auditTime = void 0, C.prototype.auditUser = void 0, C.prototype.flag = void 0, C.prototype.id = void 0, C.prototype.openApiId = void 0;
  var u = /*#__PURE__*/function () {
    function u() {
      _classCallCheck(this, u);
    }
    return _createClass(u, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new u(), e.hasOwnProperty("applyDepartment") && (t.applyDepartment = n.convertToType(e.applyDepartment, "String")), e.hasOwnProperty("applyOpenApiRecords") && (t.applyOpenApiRecords = n.convertToType(e.applyOpenApiRecords, [C])), e.hasOwnProperty("applyTime") && (t.applyTime = n.convertToType(e.applyTime, "Date")), e.hasOwnProperty("applyUser") && (t.applyUser = n.convertToType(e.applyUser, "String")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("remark") && (t.remark = n.convertToType(e.remark, "String")), e.hasOwnProperty("secretKey") && (t.secretKey = n.convertToType(e.secretKey, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String"))), t;
      }
    }]);
  }();
  u.prototype.applyDepartment = void 0, u.prototype.applyOpenApiRecords = void 0, u.prototype.applyTime = void 0, u.prototype.applyUser = void 0, u.prototype.concurrencyStamp = void 0, u.prototype.creationTime = void 0, u.prototype.creatorId = void 0, u.prototype.deleterId = void 0, u.prototype.deletionTime = void 0, u.prototype.description = void 0, u.prototype.flag = void 0, u.prototype.id = void 0, u.prototype.isDeleted = void 0, u.prototype.lastModificationTime = void 0, u.prototype.lastModifierId = void 0, u.prototype.name = void 0, u.prototype.remark = void 0, u.prototype.secretKey = void 0, u.prototype.tenantId = void 0;
  var de = /*#__PURE__*/function () {
    function de() {
      _classCallCheck(this, de);
    }
    return _createClass(de, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new de(), e.hasOwnProperty("department") && (t.department = n.convertToType(e.department, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String"))), t;
      }
    }]);
  }();
  de.prototype.department = void 0, de.prototype.name = void 0;
  var H = /*#__PURE__*/function () {
    function H(e, t, r) {
      _classCallCheck(this, H);
      this.applyDepartment = e, this.applyUser = t, this.name = r;
    }
    return _createClass(H, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new H(), e.hasOwnProperty("applyDepartment") && (t.applyDepartment = n.convertToType(e.applyDepartment, "String")), e.hasOwnProperty("applyOpenApiRecords") && (t.applyOpenApiRecords = n.convertToType(e.applyOpenApiRecords, [J])), e.hasOwnProperty("applyUser") && (t.applyUser = n.convertToType(e.applyUser, "String")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("remark") && (t.remark = n.convertToType(e.remark, "String"))), t;
      }
    }]);
  }();
  H.prototype.applyDepartment = void 0, H.prototype.applyOpenApiRecords = void 0, H.prototype.applyUser = void 0, H.prototype.concurrencyStamp = void 0, H.prototype.description = void 0, H.prototype.flag = void 0, H.prototype.id = void 0, H.prototype.name = void 0, H.prototype.remark = void 0;
  var O = /*#__PURE__*/function () {
    function O() {
      _classCallCheck(this, O);
    }
    return _createClass(O, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new O(), e.hasOwnProperty("applyApplicationId") && (t.applyApplicationId = n.convertToType(e.applyApplicationId, "String")), e.hasOwnProperty("applyApplicationName") && (t.applyApplicationName = n.convertToType(e.applyApplicationName, "String")), e.hasOwnProperty("applyDepartment") && (t.applyDepartment = n.convertToType(e.applyDepartment, "String")), e.hasOwnProperty("applyOpenApiRecordId") && (t.applyOpenApiRecordId = n.convertToType(e.applyOpenApiRecordId, "String")), e.hasOwnProperty("applyUser") && (t.applyUser = n.convertToType(e.applyUser, "String")), e.hasOwnProperty("auditStatus") && (t.auditStatus = Ee.constructFromObject(e.auditStatus)), e.hasOwnProperty("auditStatusName") && (t.auditStatusName = n.convertToType(e.auditStatusName, "String")), e.hasOwnProperty("auditTime") && (t.auditTime = n.convertToType(e.auditTime, "Date")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("openApiDescription") && (t.openApiDescription = n.convertToType(e.openApiDescription, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiName") && (t.openApiName = n.convertToType(e.openApiName, "String")), e.hasOwnProperty("openApiType") && (t.openApiType = n.convertToType(e.openApiType, "String"))), t;
      }
    }]);
  }();
  O.prototype.applyApplicationId = void 0, O.prototype.applyApplicationName = void 0, O.prototype.applyDepartment = void 0, O.prototype.applyOpenApiRecordId = void 0, O.prototype.applyUser = void 0, O.prototype.auditStatus = void 0, O.prototype.auditStatusName = void 0, O.prototype.auditTime = void 0, O.prototype.creationTime = void 0, O.prototype.openApiDescription = void 0, O.prototype.openApiId = void 0, O.prototype.openApiName = void 0, O.prototype.openApiType = void 0;
  var he = /*#__PURE__*/function () {
    function he() {
      _classCallCheck(this, he);
    }
    return _createClass(he, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new he(), e.hasOwnProperty("applyOpenApiRecordIds") && (t.applyOpenApiRecordIds = n.convertToType(e.applyOpenApiRecordIds, ["String"])), e.hasOwnProperty("isPass") && (t.isPass = n.convertToType(e.isPass, "Boolean"))), t;
      }
    }]);
  }();
  he.prototype.applyOpenApiRecordIds = void 0, he.prototype.isPass = void 0;
  var D = /*#__PURE__*/function () {
    function D() {
      _classCallCheck(this, D);
    }
    return _createClass(D, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new D(), e.hasOwnProperty("extra") && (t.extra = n.convertToType(e.extra, "String")), e.hasOwnProperty("x") && (t.x = n.convertToType(e.x, "String")), e.hasOwnProperty("y") && (t.y = n.convertToType(e.y, "String"))), t;
      }
    }]);
  }();
  D.prototype.extra = void 0, D.prototype.x = void 0, D.prototype.y = void 0;
  var A = /*#__PURE__*/function () {
    function A() {
      _classCallCheck(this, A);
    }
    return _createClass(A, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new A(), e.hasOwnProperty("apiCallCount") && (t.apiCallCount = n.convertToType(e.apiCallCount, "Number")), e.hasOwnProperty("apiCallTrendAnalysis") && (t.apiCallTrendAnalysis = n.convertToType(e.apiCallTrendAnalysis, {
          String: [D]
        })), e.hasOwnProperty("apiCount") && (t.apiCount = n.convertToType(e.apiCount, "Number")), e.hasOwnProperty("appCallCountTop10") && (t.appCallCountTop10 = n.convertToType(e.appCallCountTop10, [D])), e.hasOwnProperty("averageCallDurationTop10") && (t.averageCallDurationTop10 = n.convertToType(e.averageCallDurationTop10, [D])), e.hasOwnProperty("callApiCount") && (t.callApiCount = n.convertToType(e.callApiCount, "Number")), e.hasOwnProperty("callApiCountTop10") && (t.callApiCountTop10 = n.convertToType(e.callApiCountTop10, {
          String: [D]
        })), e.hasOwnProperty("callApiErrorReason") && (t.callApiErrorReason = n.convertToType(e.callApiErrorReason, [D])), e.hasOwnProperty("callApiFailureRateTop10") && (t.callApiFailureRateTop10 = n.convertToType(e.callApiFailureRateTop10, [D])), e.hasOwnProperty("callSuccessCount") && (t.callSuccessCount = n.convertToType(e.callSuccessCount, "Number")), e.hasOwnProperty("supportedAppCount") && (t.supportedAppCount = n.convertToType(e.supportedAppCount, "Number"))), t;
      }
    }]);
  }();
  A.prototype.apiCallCount = void 0, A.prototype.apiCallTrendAnalysis = void 0, A.prototype.apiCount = void 0, A.prototype.appCallCountTop10 = void 0, A.prototype.averageCallDurationTop10 = void 0, A.prototype.callApiCount = void 0, A.prototype.callApiCountTop10 = void 0, A.prototype.callApiErrorReason = void 0, A.prototype.callApiFailureRateTop10 = void 0, A.prototype.callSuccessCount = void 0, A.prototype.supportedAppCount = void 0;
  var $ = /*#__PURE__*/function () {
    function $() {
      _classCallCheck(this, $);
    }
    return _createClass($, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new $(), e.hasOwnProperty("connectionString") && (t.connectionString = n.convertToType(e.connectionString, "String")), e.hasOwnProperty("dbName") && (t.dbName = n.convertToType(e.dbName, "String")), e.hasOwnProperty("dbType") && (t.dbType = ne.constructFromObject(e.dbType)), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number"))), t;
      }
    }]);
  }();
  $.prototype.connectionString = void 0, $.prototype.dbName = void 0, $.prototype.dbType = void 0, $.prototype.flag = void 0;
  var f = /*#__PURE__*/function () {
    function f() {
      _classCallCheck(this, f);
    }
    return _createClass(f, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new f(), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("connectionString") && (t.connectionString = n.convertToType(e.connectionString, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("dbName") && (t.dbName = n.convertToType(e.dbName, "String")), e.hasOwnProperty("dbType") && (t.dbType = ne.constructFromObject(e.dbType)), e.hasOwnProperty("dbTypeName") && (t.dbTypeName = n.convertToType(e.dbTypeName, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String"))), t;
      }
    }]);
  }();
  f.prototype.concurrencyStamp = void 0, f.prototype.connectionString = void 0, f.prototype.creationTime = void 0, f.prototype.creatorId = void 0, f.prototype.dbName = void 0, f.prototype.dbType = void 0, f.prototype.dbTypeName = void 0, f.prototype.deleterId = void 0, f.prototype.deletionTime = void 0, f.prototype.flag = void 0, f.prototype.id = void 0, f.prototype.isDeleted = void 0, f.prototype.lastModificationTime = void 0, f.prototype.lastModifierId = void 0, f.prototype.tenantId = void 0;
  var fe = /*#__PURE__*/function () {
    function fe() {
      _classCallCheck(this, fe);
    }
    return _createClass(fe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new fe(), e.hasOwnProperty("dbName") && (t.dbName = n.convertToType(e.dbName, "String")), e.hasOwnProperty("dbType") && (t.dbType = ne.constructFromObject(e.dbType))), t;
      }
    }]);
  }();
  fe.prototype.dbName = void 0, fe.prototype.dbType = void 0;
  var k = /*#__PURE__*/function () {
    function k() {
      _classCallCheck(this, k);
    }
    return _createClass(k, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new k(), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("connectionString") && (t.connectionString = n.convertToType(e.connectionString, "String")), e.hasOwnProperty("dbName") && (t.dbName = n.convertToType(e.dbName, "String")), e.hasOwnProperty("dbType") && (t.dbType = ne.constructFromObject(e.dbType)), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String"))), t;
      }
    }]);
  }();
  k.prototype.concurrencyStamp = void 0, k.prototype.connectionString = void 0, k.prototype.dbName = void 0, k.prototype.dbType = void 0, k.prototype.flag = void 0, k.prototype.id = void 0;
  var re = /*#__PURE__*/function () {
    function re() {
      _classCallCheck(this, re);
    }
    return _createClass(re, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new re(), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String"))), t;
      }
    }]);
  }();
  re.prototype.id = void 0, re.prototype.tenantId = void 0;
  var X = /*#__PURE__*/function () {
    function X() {
      _classCallCheck(this, X);
    }
    return _createClass(X, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new X(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String"))), t;
      }
    }]);
  }();
  X.prototype.code = void 0, X.prototype.name = void 0;
  var V = /*#__PURE__*/function () {
    function V() {
      _classCallCheck(this, V);
    }
    return _createClass(V, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new V(), e.hasOwnProperty("apiCallCount") && (t.apiCallCount = n.convertToType(e.apiCallCount, "Number")), e.hasOwnProperty("apiPublishedCount") && (t.apiPublishedCount = n.convertToType(e.apiPublishedCount, "Number")), e.hasOwnProperty("appCallDetails") && (t.appCallDetails = n.convertToType(e.appCallDetails, {
          String: [D]
        })), e.hasOwnProperty("callFailCount") && (t.callFailCount = n.convertToType(e.callFailCount, "Number")), e.hasOwnProperty("supportedAppCount") && (t.supportedAppCount = n.convertToType(e.supportedAppCount, "Number"))), t;
      }
    }]);
  }();
  V.prototype.apiCallCount = void 0, V.prototype.apiPublishedCount = void 0, V.prototype.appCallDetails = void 0, V.prototype.callFailCount = void 0, V.prototype.supportedAppCount = void 0;
  var Fe = {
      _0: 0,
      _1: 1,
      _2: 2,
      _3: 3,
      _4: 4,
      _5: 5,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    },
    Te = {
      _0: 0,
      _1: 1,
      _2: 2,
      _4: 4,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    },
    Re = {
      _0: 0,
      _1: 1,
      _2: 2,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    };
  var W = /*#__PURE__*/function () {
    function W() {
      _classCallCheck(this, W);
    }
    return _createClass(W, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new W(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("expreSqlExpressionssion") && (t.expreSqlExpressionssion = n.convertToType(e.expreSqlExpressionssion, "String")), e.hasOwnProperty("expression") && (t.expression = n.convertToType(e.expression, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("tableName") && (t.tableName = n.convertToType(e.tableName, "String")), e.hasOwnProperty("type") && (t.type = Re.constructFromObject(e.type)), e.hasOwnProperty("typeName") && (t.typeName = n.convertToType(e.typeName, "String"))), t;
      }
    }]);
  }();
  W.prototype.code = void 0, W.prototype.expreSqlExpressionssion = void 0, W.prototype.expression = void 0, W.prototype.id = void 0, W.prototype.name = void 0, W.prototype.tableName = void 0, W.prototype.type = void 0, W.prototype.typeName = void 0;
  var T = /*#__PURE__*/function () {
    function T() {
      _classCallCheck(this, T);
    }
    return _createClass(T, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new T(), e.hasOwnProperty("applyApplicationId") && (t.applyApplicationId = n.convertToType(e.applyApplicationId, "String")), e.hasOwnProperty("applyApplicationName") && (t.applyApplicationName = n.convertToType(e.applyApplicationName, "String")), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "Number")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("ipAddresss") && (t.ipAddresss = n.convertToType(e.ipAddresss, "String")), e.hasOwnProperty("openApiCode") && (t.openApiCode = n.convertToType(e.openApiCode, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiName") && (t.openApiName = n.convertToType(e.openApiName, "String")), e.hasOwnProperty("remark") && (t.remark = n.convertToType(e.remark, "String")), e.hasOwnProperty("requestAddress") && (t.requestAddress = n.convertToType(e.requestAddress, "String")), e.hasOwnProperty("requestMethod") && (t.requestMethod = n.convertToType(e.requestMethod, "String")), e.hasOwnProperty("result") && (t.result = n.convertToType(e.result, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String")), e.hasOwnProperty("timing") && (t.timing = n.convertToType(e.timing, "Number"))), t;
      }
    }]);
  }();
  T.prototype.applyApplicationId = void 0, T.prototype.applyApplicationName = void 0, T.prototype.code = void 0, T.prototype.creationTime = void 0, T.prototype.id = void 0, T.prototype.ipAddresss = void 0, T.prototype.openApiCode = void 0, T.prototype.openApiId = void 0, T.prototype.openApiName = void 0, T.prototype.remark = void 0, T.prototype.requestAddress = void 0, T.prototype.requestMethod = void 0, T.prototype.result = void 0, T.prototype.tenantId = void 0, T.prototype.timing = void 0;
  var N = /*#__PURE__*/function () {
    function N() {
      _classCallCheck(this, N);
    }
    return _createClass(N, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new N(), e.hasOwnProperty("applyApplicationName") && (t.applyApplicationName = n.convertToType(e.applyApplicationName, "String")), e.hasOwnProperty("endTime") && (t.endTime = n.convertToType(e.endTime, "Date")), e.hasOwnProperty("isJumpRequest") && (t.isJumpRequest = n.convertToType(e.isJumpRequest, "Boolean")), e.hasOwnProperty("isSuccess") && (t.isSuccess = n.convertToType(e.isSuccess, "Boolean")), e.hasOwnProperty("jumpRequestParams") && (t.jumpRequestParams = n.convertToType(e.jumpRequestParams, ["String"])), e.hasOwnProperty("jumpRequestType") && (t.jumpRequestType = Fe.constructFromObject(e.jumpRequestType)), e.hasOwnProperty("maxResultCount") && (t.maxResultCount = n.convertToType(e.maxResultCount, "Number")), e.hasOwnProperty("openApiKeyWord") && (t.openApiKeyWord = n.convertToType(e.openApiKeyWord, "String")), e.hasOwnProperty("skipCount") && (t.skipCount = n.convertToType(e.skipCount, "Number")), e.hasOwnProperty("sorting") && (t.sorting = n.convertToType(e.sorting, "String")), e.hasOwnProperty("startTime") && (t.startTime = n.convertToType(e.startTime, "Date"))), t;
      }
    }]);
  }();
  N.prototype.applyApplicationName = void 0, N.prototype.endTime = void 0, N.prototype.isJumpRequest = void 0, N.prototype.isSuccess = void 0, N.prototype.jumpRequestParams = void 0, N.prototype.jumpRequestType = void 0, N.prototype.maxResultCount = void 0, N.prototype.openApiKeyWord = void 0, N.prototype.skipCount = void 0, N.prototype.sorting = void 0, N.prototype.startTime = void 0;
  var ve = {
      _1: 1,
      _2: 2,
      _3: 3,
      _4: 4,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    },
    xe = {
      _1: 1,
      _2: 2,
      _3: 3,
      _4: 4,
      _5: 5,
      _6: 6,
      _7: 7,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    },
    Ce = {
      _1: 1,
      _2: 2,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    },
    ie = {
      _1: 1,
      _2: 2,
      _3: 3,
      constructFromObject: function constructFromObject(d) {
        return d;
      }
    };
  var U = /*#__PURE__*/function () {
    function U() {
      _classCallCheck(this, U);
    }
    return _createClass(U, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new U(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("paramType") && (t.paramType = Ce.constructFromObject(e.paramType)), e.hasOwnProperty("queryMode") && (t.queryMode = xe.constructFromObject(e.queryMode)), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("type") && (t.type = ie.constructFromObject(e.type))), t;
      }
    }]);
  }();
  U.prototype.code = void 0, U.prototype.name = void 0, U.prototype.paramType = void 0, U.prototype.queryMode = void 0, U.prototype.seqNo = void 0, U.prototype.type = void 0;
  var I = /*#__PURE__*/function () {
    function I() {
      _classCallCheck(this, I);
    }
    return _createClass(I, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new I(), e.hasOwnProperty("address") && (t.address = n.convertToType(e.address, "String")), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("method") && (t.method = ve.constructFromObject(e.method)), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openApiParamSettings") && (t.openApiParamSettings = n.convertToType(e.openApiParamSettings, [U])), e.hasOwnProperty("propose") && (t.propose = n.convertToType(e.propose, "String")), e.hasOwnProperty("qps") && (t.qps = n.convertToType(e.qps, "Number")), e.hasOwnProperty("secretKey") && (t.secretKey = n.convertToType(e.secretKey, "String")), e.hasOwnProperty("timeout") && (t.timeout = n.convertToType(e.timeout, "Number")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("usageScene") && (t.usageScene = n.convertToType(e.usageScene, "String"))), t;
      }
    }]);
  }();
  I.prototype.address = void 0, I.prototype.code = void 0, I.prototype.description = void 0, I.prototype.method = void 0, I.prototype.name = void 0, I.prototype.openApiParamSettings = void 0, I.prototype.propose = void 0, I.prototype.qps = void 0, I.prototype.secretKey = void 0, I.prototype.timeout = void 0, I.prototype.type = void 0, I.prototype.usageScene = void 0;
  var Ne = {
    _1: 1,
    _2: 2,
    _3: 3,
    _4: 4,
    _5: 5,
    _6: 6,
    constructFromObject: function constructFromObject(d) {
      return d;
    }
  };
  var E = /*#__PURE__*/function () {
    function E() {
      _classCallCheck(this, E);
    }
    return _createClass(E, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new E(), e.hasOwnProperty("destParamCode") && (t.destParamCode = n.convertToType(e.destParamCode, "String")), e.hasOwnProperty("destParamName") && (t.destParamName = n.convertToType(e.destParamName, "String")), e.hasOwnProperty("paramValueType") && (t.paramValueType = ie.constructFromObject(e.paramValueType)), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("sourceParamCode") && (t.sourceParamCode = n.convertToType(e.sourceParamCode, "String")), e.hasOwnProperty("sourceParamName") && (t.sourceParamName = n.convertToType(e.sourceParamName, "String")), e.hasOwnProperty("sqlParamType") && (t.sqlParamType = Ne.constructFromObject(e.sqlParamType))), t;
      }
    }]);
  }();
  E.prototype.destParamCode = void 0, E.prototype.destParamName = void 0, E.prototype.paramValueType = void 0, E.prototype.seqNo = void 0, E.prototype.sourceParamCode = void 0, E.prototype.sourceParamName = void 0, E.prototype.sqlParamType = void 0;
  var K = /*#__PURE__*/function () {
    function K() {
      _classCallCheck(this, K);
    }
    return _createClass(K, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new K(), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("mappingType") && (t.mappingType = Te.constructFromObject(e.mappingType)), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiParamMappings") && (t.openApiParamMappings = n.convertToType(e.openApiParamMappings, [E])), e.hasOwnProperty("sql") && (t.sql = n.convertToType(e.sql, "String")), e.hasOwnProperty("tableName") && (t.tableName = n.convertToType(e.tableName, "String"))), t;
      }
    }]);
  }();
  K.prototype.dbConnectionStringId = void 0, K.prototype.flag = void 0, K.prototype.mappingType = void 0, K.prototype.openApiId = void 0, K.prototype.openApiParamMappings = void 0, K.prototype.sql = void 0, K.prototype.tableName = void 0;
  var M = /*#__PURE__*/function () {
    function M() {
      _classCallCheck(this, M);
    }
    return _createClass(M, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new M(), e.hasOwnProperty("destParamCode") && (t.destParamCode = n.convertToType(e.destParamCode, "String")), e.hasOwnProperty("destParamName") && (t.destParamName = n.convertToType(e.destParamName, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("openApiDataMappingId") && (t.openApiDataMappingId = n.convertToType(e.openApiDataMappingId, "String")), e.hasOwnProperty("paramType") && (t.paramType = Ce.constructFromObject(e.paramType)), e.hasOwnProperty("paramValueType") && (t.paramValueType = ie.constructFromObject(e.paramValueType)), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("sourceParamCode") && (t.sourceParamCode = n.convertToType(e.sourceParamCode, "String")), e.hasOwnProperty("sourceParamName") && (t.sourceParamName = n.convertToType(e.sourceParamName, "String")), e.hasOwnProperty("sqlParamType") && (t.sqlParamType = Ne.constructFromObject(e.sqlParamType))), t;
      }
    }]);
  }();
  M.prototype.destParamCode = void 0, M.prototype.destParamName = void 0, M.prototype.id = void 0, M.prototype.openApiDataMappingId = void 0, M.prototype.paramType = void 0, M.prototype.paramValueType = void 0, M.prototype.seqNo = void 0, M.prototype.sourceParamCode = void 0, M.prototype.sourceParamName = void 0, M.prototype.sqlParamType = void 0;
  var h = /*#__PURE__*/function () {
    function h() {
      _classCallCheck(this, h);
    }
    return _createClass(h, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new h(), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("mappingType") && (t.mappingType = Te.constructFromObject(e.mappingType)), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiParamMappings") && (t.openApiParamMappings = n.convertToType(e.openApiParamMappings, [M])), e.hasOwnProperty("sql") && (t.sql = n.convertToType(e.sql, "String")), e.hasOwnProperty("tableName") && (t.tableName = n.convertToType(e.tableName, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String"))), t;
      }
    }]);
  }();
  h.prototype.concurrencyStamp = void 0, h.prototype.creationTime = void 0, h.prototype.creatorId = void 0, h.prototype.dbConnectionStringId = void 0, h.prototype.deleterId = void 0, h.prototype.deletionTime = void 0, h.prototype.flag = void 0, h.prototype.id = void 0, h.prototype.isDeleted = void 0, h.prototype.lastModificationTime = void 0, h.prototype.lastModifierId = void 0, h.prototype.mappingType = void 0, h.prototype.openApiId = void 0, h.prototype.openApiParamMappings = void 0, h.prototype.sql = void 0, h.prototype.tableName = void 0, h.prototype.tenantId = void 0;
  var Me = /*#__PURE__*/function () {
    function Me() {
      _classCallCheck(this, Me);
    }
    return _createClass(Me, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Me(), e.hasOwnProperty("openApiName") && (t.openApiName = n.convertToType(e.openApiName, "String"))), t;
      }
    }]);
  }();
  Me.prototype.openApiName = void 0;
  var w = /*#__PURE__*/function () {
    function w() {
      _classCallCheck(this, w);
    }
    return _createClass(w, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new w(), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("content") && (t.content = n.convertToType(e.content, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("mappingType") && (t.mappingType = n.convertToType(e.mappingType, "String")), e.hasOwnProperty("method") && (t.method = n.convertToType(e.method, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiName") && (t.openApiName = n.convertToType(e.openApiName, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String")), e.hasOwnProperty("version") && (t.version = n.convertToType(e.version, "String"))), t;
      }
    }]);
  }();
  w.prototype.concurrencyStamp = void 0, w.prototype.content = void 0, w.prototype.creationTime = void 0, w.prototype.dbConnectionStringId = void 0, w.prototype.description = void 0, w.prototype.id = void 0, w.prototype.mappingType = void 0, w.prototype.method = void 0, w.prototype.openApiId = void 0, w.prototype.openApiName = void 0, w.prototype.tenantId = void 0, w.prototype.version = void 0;
  var F = /*#__PURE__*/function () {
    function F() {
      _classCallCheck(this, F);
    }
    return _createClass(F, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new F(), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("mappingType") && (t.mappingType = Te.constructFromObject(e.mappingType)), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiParamMappings") && (t.openApiParamMappings = n.convertToType(e.openApiParamMappings, [E])), e.hasOwnProperty("sql") && (t.sql = n.convertToType(e.sql, "String")), e.hasOwnProperty("tableName") && (t.tableName = n.convertToType(e.tableName, "String"))), t;
      }
    }]);
  }();
  F.prototype.concurrencyStamp = void 0, F.prototype.dbConnectionStringId = void 0, F.prototype.flag = void 0, F.prototype.id = void 0, F.prototype.mappingType = void 0, F.prototype.openApiId = void 0, F.prototype.openApiParamMappings = void 0, F.prototype.sql = void 0, F.prototype.tableName = void 0;
  var R = /*#__PURE__*/function () {
    function R() {
      _classCallCheck(this, R);
    }
    return _createClass(R, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new R(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("paramType") && (t.paramType = Ce.constructFromObject(e.paramType)), e.hasOwnProperty("queryMode") && (t.queryMode = xe.constructFromObject(e.queryMode)), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("type") && (t.type = ie.constructFromObject(e.type))), t;
      }
    }]);
  }();
  R.prototype.code = void 0, R.prototype.id = void 0, R.prototype.name = void 0, R.prototype.openApiId = void 0, R.prototype.paramType = void 0, R.prototype.queryMode = void 0, R.prototype.seqNo = void 0, R.prototype.type = void 0;
  var He = {
    _1: 1,
    _2: 2,
    _3: 3,
    constructFromObject: function constructFromObject(d) {
      return d;
    }
  };
  var m = /*#__PURE__*/function () {
    function m() {
      _classCallCheck(this, m);
    }
    return _createClass(m, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new m(), e.hasOwnProperty("address") && (t.address = n.convertToType(e.address, "String")), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("isEnabled") && (t.isEnabled = n.convertToType(e.isEnabled, "Number")), e.hasOwnProperty("isPostQuery") && (t.isPostQuery = n.convertToType(e.isPostQuery, "Number")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("method") && (t.method = ve.constructFromObject(e.method)), e.hasOwnProperty("methodName") && (t.methodName = n.convertToType(e.methodName, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openApiParamSettings") && (t.openApiParamSettings = n.convertToType(e.openApiParamSettings, [R])), e.hasOwnProperty("propose") && (t.propose = n.convertToType(e.propose, "String")), e.hasOwnProperty("qps") && (t.qps = n.convertToType(e.qps, "Number")), e.hasOwnProperty("secretKey") && (t.secretKey = n.convertToType(e.secretKey, "String")), e.hasOwnProperty("status") && (t.status = He.constructFromObject(e.status)), e.hasOwnProperty("statusName") && (t.statusName = n.convertToType(e.statusName, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String")), e.hasOwnProperty("timeout") && (t.timeout = n.convertToType(e.timeout, "Number")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("usageScene") && (t.usageScene = n.convertToType(e.usageScene, "String")), e.hasOwnProperty("version") && (t.version = n.convertToType(e.version, "String"))), t;
      }
    }]);
  }();
  m.prototype.address = void 0, m.prototype.code = void 0, m.prototype.concurrencyStamp = void 0, m.prototype.creationTime = void 0, m.prototype.creatorId = void 0, m.prototype.deleterId = void 0, m.prototype.deletionTime = void 0, m.prototype.description = void 0, m.prototype.id = void 0, m.prototype.isDeleted = void 0, m.prototype.isEnabled = void 0, m.prototype.isPostQuery = void 0, m.prototype.lastModificationTime = void 0, m.prototype.lastModifierId = void 0, m.prototype.method = void 0, m.prototype.methodName = void 0, m.prototype.name = void 0, m.prototype.openApiParamSettings = void 0, m.prototype.propose = void 0, m.prototype.qps = void 0, m.prototype.secretKey = void 0, m.prototype.status = void 0, m.prototype.statusName = void 0, m.prototype.tenantId = void 0, m.prototype.timeout = void 0, m.prototype.type = void 0, m.prototype.usageScene = void 0, m.prototype.version = void 0;
  var Y = /*#__PURE__*/function () {
    function Y() {
      _classCallCheck(this, Y);
    }
    return _createClass(Y, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Y(), e.hasOwnProperty("isEnabled") && (t.isEnabled = n.convertToType(e.isEnabled, "Number")), e.hasOwnProperty("keywords") && (t.keywords = n.convertToType(e.keywords, "String")), e.hasOwnProperty("status") && (t.status = He.constructFromObject(e.status)), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String"))), t;
      }
    }]);
  }();
  Y.prototype.isEnabled = void 0, Y.prototype.keywords = void 0, Y.prototype.status = void 0, Y.prototype.type = void 0;
  var B = /*#__PURE__*/function () {
    function B() {
      _classCallCheck(this, B);
    }
    return _createClass(B, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new B(), e.hasOwnProperty("destParamCode") && (t.destParamCode = n.convertToType(e.destParamCode, "String")), e.hasOwnProperty("destParamName") && (t.destParamName = n.convertToType(e.destParamName, "String")), e.hasOwnProperty("paramValueType") && (t.paramValueType = ie.constructFromObject(e.paramValueType)), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("sourceParamCode") && (t.sourceParamCode = n.convertToType(e.sourceParamCode, "String")), e.hasOwnProperty("sourceParamName") && (t.sourceParamName = n.convertToType(e.sourceParamName, "String")), e.hasOwnProperty("sqlParamType") && (t.sqlParamType = Ne.constructFromObject(e.sqlParamType))), t;
      }
    }]);
  }();
  B.prototype.destParamCode = void 0, B.prototype.destParamName = void 0, B.prototype.paramValueType = void 0, B.prototype.seqNo = void 0, B.prototype.sourceParamCode = void 0, B.prototype.sourceParamName = void 0, B.prototype.sqlParamType = void 0;
  var g = /*#__PURE__*/function () {
    function g() {
      _classCallCheck(this, g);
    }
    return _createClass(g, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new g(), e.hasOwnProperty("address") && (t.address = n.convertToType(e.address, "String")), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = n.convertToType(e.concurrencyStamp, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("method") && (t.method = ve.constructFromObject(e.method)), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openApiParamSettings") && (t.openApiParamSettings = n.convertToType(e.openApiParamSettings, [U])), e.hasOwnProperty("propose") && (t.propose = n.convertToType(e.propose, "String")), e.hasOwnProperty("qps") && (t.qps = n.convertToType(e.qps, "Number")), e.hasOwnProperty("secretKey") && (t.secretKey = n.convertToType(e.secretKey, "String")), e.hasOwnProperty("timeout") && (t.timeout = n.convertToType(e.timeout, "Number")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("usageScene") && (t.usageScene = n.convertToType(e.usageScene, "String")), e.hasOwnProperty("version") && (t.version = n.convertToType(e.version, "String"))), t;
      }
    }]);
  }();
  g.prototype.address = void 0, g.prototype.code = void 0, g.prototype.concurrencyStamp = void 0, g.prototype.description = void 0, g.prototype.id = void 0, g.prototype.method = void 0, g.prototype.name = void 0, g.prototype.openApiParamSettings = void 0, g.prototype.propose = void 0, g.prototype.qps = void 0, g.prototype.secretKey = void 0, g.prototype.timeout = void 0, g.prototype.type = void 0, g.prototype.usageScene = void 0, g.prototype.version = void 0;
  var z = /*#__PURE__*/function () {
    function z() {
      _classCallCheck(this, z);
    }
    return _createClass(z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new z(), e.hasOwnProperty("requestParamMappings") && (t.requestParamMappings = n.convertToType(e.requestParamMappings, [B])), e.hasOwnProperty("requestParamSource") && (t.requestParamSource = n.convertToType(e.requestParamSource, [X])), e.hasOwnProperty("responseParamMappings") && (t.responseParamMappings = n.convertToType(e.responseParamMappings, [B])), e.hasOwnProperty("responseParamSource") && (t.responseParamSource = n.convertToType(e.responseParamSource, [X]))), t;
      }
    }]);
  }();
  z.prototype.requestParamMappings = void 0, z.prototype.requestParamSource = void 0, z.prototype.responseParamMappings = void 0, z.prototype.responseParamSource = void 0;
  var Z = /*#__PURE__*/function () {
    function Z() {
      _classCallCheck(this, Z);
    }
    return _createClass(Z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Z(), e.hasOwnProperty("notes") && (t.notes = n.convertToType(e.notes, "String")), e.hasOwnProperty("sql") && (t.sql = n.convertToType(e.sql, "String")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String"))), t;
      }
    }]);
  }();
  Z.prototype.notes = void 0, Z.prototype.sql = void 0, Z.prototype.type = void 0;
  var Q = /*#__PURE__*/function () {
    function Q() {
      _classCallCheck(this, Q);
    }
    return _createClass(Q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Q(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("tableName") && (t.tableName = n.convertToType(e.tableName, "String"))), t;
      }
    }]);
  }();
  Q.prototype.code = void 0, Q.prototype.id = void 0, Q.prototype.name = void 0, Q.prototype.tableName = void 0;
  var _ = /*#__PURE__*/function () {
    function _() {
      _classCallCheck(this, _);
    }
    return _createClass(_, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new _(), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("openApiParamMappings") && (t.openApiParamMappings = n.convertToType(e.openApiParamMappings, [E])), e.hasOwnProperty("sql") && (t.sql = n.convertToType(e.sql, "String"))), t;
      }
    }]);
  }();
  _.prototype.dbConnectionStringId = void 0, _.prototype.openApiId = void 0, _.prototype.openApiParamMappings = void 0, _.prototype.sql = void 0;
  var qe = /*#__PURE__*/function () {
    function qe() {
      _classCallCheck(this, qe);
    }
    return _createClass(qe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new qe(), e.hasOwnProperty("file") && (t.file = n.convertToType(e.file, "Blob"))), t;
      }
    }]);
  }();
  qe.prototype.file = void 0;
  var b = /*#__PURE__*/function () {
    function b() {
      _classCallCheck(this, b);
    }
    return _createClass(b, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new b(), e.hasOwnProperty("dbConnectionStringId") && (t.dbConnectionStringId = n.convertToType(e.dbConnectionStringId, "String")), e.hasOwnProperty("mappingType") && (t.mappingType = Te.constructFromObject(e.mappingType)), e.hasOwnProperty("openApiId") && (t.openApiId = n.convertToType(e.openApiId, "String")), e.hasOwnProperty("parsingContent") && (t.parsingContent = n.convertToType(e.parsingContent, "String"))), t;
      }
    }]);
  }();
  b.prototype.dbConnectionStringId = void 0, b.prototype.mappingType = void 0, b.prototype.openApiId = void 0, b.prototype.parsingContent = void 0;
  var De = /*#__PURE__*/function () {
    function De() {
      _classCallCheck(this, De);
    }
    return _createClass(De, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new De(), e.hasOwnProperty("file") && (t.file = n.convertToType(e.file, "Blob"))), t;
      }
    }]);
  }();
  De.prototype.file = void 0;
  var ge = /*#__PURE__*/function () {
    function ge() {
      _classCallCheck(this, ge);
    }
    return _createClass(ge, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ge(), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isEnabled") && (t.isEnabled = n.convertToType(e.isEnabled, "Boolean"))), t;
      }
    }]);
  }();
  ge.prototype.id = void 0, ge.prototype.isEnabled = void 0;
  var oe = /*#__PURE__*/function () {
    function oe() {
      _classCallCheck(this, oe);
    }
    return _createClass(oe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new oe(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [u])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  oe.prototype.items = void 0, oe.prototype.totalCount = void 0;
  var ae = /*#__PURE__*/function () {
    function ae() {
      _classCallCheck(this, ae);
    }
    return _createClass(ae, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ae(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [O])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  ae.prototype.items = void 0, ae.prototype.totalCount = void 0;
  var se = /*#__PURE__*/function () {
    function se() {
      _classCallCheck(this, se);
    }
    return _createClass(se, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new se(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [f])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  se.prototype.items = void 0, se.prototype.totalCount = void 0;
  var le = /*#__PURE__*/function () {
    function le() {
      _classCallCheck(this, le);
    }
    return _createClass(le, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new le(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [T])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  le.prototype.items = void 0, le.prototype.totalCount = void 0;
  var ce = /*#__PURE__*/function () {
    function ce() {
      _classCallCheck(this, ce);
    }
    return _createClass(ce, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ce(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [w])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  ce.prototype.items = void 0, ce.prototype.totalCount = void 0;
  var j = /*#__PURE__*/function () {
    function j() {
      _classCallCheck(this, j);
    }
    return _createClass(j, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new j(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [m])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  j.prototype.items = void 0, j.prototype.totalCount = void 0;
  var q = /*#__PURE__*/function () {
    function q() {
      _classCallCheck(this, q);
    }
    return _createClass(q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new q(), e.hasOwnProperty("item1") && (t.item1 = n.convertToType(e.item1, "Number")), e.hasOwnProperty("item2") && (t.item2 = n.convertToType(e.item2, "String"))), t;
      }
    }]);
  }();
  q.prototype.item1 = void 0, q.prototype.item2 = void 0;
  var ye = /*#__PURE__*/function () {
    function ye() {
      _classCallCheck(this, ye);
    }
    return _createClass(ye, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ye(), e.hasOwnProperty("item1") && (t.item1 = n.convertToType(e.item1, "String")), e.hasOwnProperty("item2") && (t.item2 = n.convertToType(e.item2, "String"))), t;
      }
    }]);
  }();
  ye.prototype.item1 = void 0, ye.prototype.item2 = void 0;
  var Be = /*#__PURE__*/function () {
    function Be(e) {
      _classCallCheck(this, Be);
      this.apiClient = e || n.GetInstance("open-api-management", "ApplyApplicationApi");
    }
    return _createClass(Be, [{
      key: "approveApplyOpenApiWithHttpInfo",
      value: function approveApplyOpenApiWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = [C];
        return this.apiClient.callApi("/api/open-api-management/apply-applications/approve", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "approveApplyOpenApi",
      value: function approveApplyOpenApi(e) {
        return this.approveApplyOpenApiWithHttpInfo(e);
      }
    }, {
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = null;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/{id}", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "callExportWithHttpInfo",
      value: function callExportWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/apply-applications/export", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callExport",
      value: function callExport(e) {
        return this.callExportWithHttpInfo(e);
      }
    }, {
      key: "callImportWithHttpInfo",
      value: function callImportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            file: e.file
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/apply-applications/import", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callImport",
      value: function callImport(e) {
        return this.callImportWithHttpInfo(e);
      }
    }, {
      key: "cancelSubmitApplyOpenApiWithHttpInfo",
      value: function cancelSubmitApplyOpenApiWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = [C];
        return this.apiClient.callApi("/api/open-api-management/apply-applications/cancel", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "cancelSubmitApplyOpenApi",
      value: function cancelSubmitApplyOpenApi(e) {
        return this.cancelSubmitApplyOpenApiWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = u;
        return this.apiClient.callApi("/api/open-api-management/apply-applications", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "decryptSecretKeyWithHttpInfo",
      value: function decryptSecretKeyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            encryptSecretKey: e.encryptSecretKey
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = re;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/decrypt-secret-key", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "decryptSecretKey",
      value: function decryptSecretKey(e) {
        return this.decryptSecretKeyWithHttpInfo(e);
      }
    }, {
      key: "deleteApplyOpenApiRecordsWithHttpInfo",
      value: function deleteApplyOpenApiRecordsWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'applyOpenApiRecordId' when calling deleteApplyOpenApiRecords");
        var r = {
            applyOpenApiRecordId: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = "Boolean";
        return this.apiClient.callApi("/api/open-api-management/apply-applications/delete-apply-openapi-record/{applyOpenApiRecordId}", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "deleteApplyOpenApiRecords",
      value: function deleteApplyOpenApiRecords(e) {
        return this.deleteApplyOpenApiRecordsWithHttpInfo(e);
      }
    }, {
      key: "deleteManyWithHttpInfo",
      value: function deleteManyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            ids: this.apiClient.buildCollectionParam(e.ids, "multi")
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/many", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "deleteMany",
      value: function deleteMany(e) {
        return this.deleteManyWithHttpInfo(e);
      }
    }, {
      key: "downloadTemplateWithHttpInfo",
      value: function downloadTemplateWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = "Blob";
        return this.apiClient.callApi("/api/open-api-management/apply-applications/download-template", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "downloadTemplate",
      value: function downloadTemplate() {
        return this.downloadTemplateWithHttpInfo();
      }
    }, {
      key: "generateSecretKeyWithHttpInfo",
      value: function generateSecretKeyWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = "String";
        return this.apiClient.callApi("/api/open-api-management/apply-applications/generate-secret-key", "POST", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "generateSecretKey",
      value: function generateSecretKey() {
        return this.generateSecretKeyWithHttpInfo();
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = u;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/{id}", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getApplyOpenApiRecordPagedResultWithHttpInfo",
      value: function getApplyOpenApiRecordPagedResultWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            Keywords: e.keywords,
            ApiType: e.apiType,
            AuditStatus: e.auditStatus,
            Name: e.name,
            Department: e.department,
            IsQueryNotSubmittedRecord: e.isQueryNotSubmittedRecord,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = ae;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/apply-openapi-records", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getApplyOpenApiRecordPagedResult",
      value: function getApplyOpenApiRecordPagedResult(e) {
        return this.getApplyOpenApiRecordPagedResultWithHttpInfo(e);
      }
    }, {
      key: "getAuditStatusWithHttpInfo",
      value: function getAuditStatusWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            isContainNotSubmitStatus: e.isContainNotSubmitStatus
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = [q];
        return this.apiClient.callApi("/api/open-api-management/apply-applications/audit-status-list", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getAuditStatus",
      value: function getAuditStatus(e) {
        return this.getAuditStatusWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            Name: e.name,
            ApplyDepartment: e.applyDepartment,
            ApplyUser: e.applyUser,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = oe;
        return this.apiClient.callApi("/api/open-api-management/apply-applications", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "insertManyWithHttpInfo",
      value: function insertManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/many", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "insertMany",
      value: function insertMany(e) {
        return this.insertManyWithHttpInfo(e);
      }
    }, {
      key: "submitApplyOpenApiWithHttpInfo",
      value: function submitApplyOpenApiWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = [C];
        return this.apiClient.callApi("/api/open-api-management/apply-applications/submit", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "submitApplyOpenApi",
      value: function submitApplyOpenApi(e) {
        return this.submitApplyOpenApiWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var r = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var p = {
            id: e
          },
          i = {},
          o = t.header || {},
          a = {},
          s = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          c = ["application/json", "text/json", "text/plain"],
          x = u;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/{id}", "PUT", p, i, o, a, r, s, l, c, x);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }, {
      key: "updateManyWithHttpInfo",
      value: function updateManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/apply-applications/many", "PUT", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "updateMany",
      value: function updateMany(e) {
        return this.updateManyWithHttpInfo(e);
      }
    }]);
  }();
  ee(Be, "Methods", {
    approveApplyOpenApi: {
      desc: "审核申请OpenApi",
      method: "POST",
      path: "/api/open-api-management/apply-applications/approve"
    },
    callDelete: {
      method: "DELETE",
      path: "/api/open-api-management/apply-applications/{id}"
    },
    callExport: {
      desc: "导出",
      method: "POST",
      path: "/api/open-api-management/apply-applications/export"
    },
    callImport: {
      desc: "导入",
      method: "POST",
      path: "/api/open-api-management/apply-applications/import"
    },
    cancelSubmitApplyOpenApi: {
      desc: "撤回提交",
      method: "POST",
      path: "/api/open-api-management/apply-applications/cancel"
    },
    create: {
      method: "POST",
      path: "/api/open-api-management/apply-applications"
    },
    decryptSecretKey: {
      desc: "解密密钥",
      method: "POST",
      path: "/api/open-api-management/apply-applications/decrypt-secret-key"
    },
    deleteApplyOpenApiRecords: {
      desc: "删除 ApplyApplication 申请 OpenApi 记录",
      method: "DELETE",
      path: "/api/open-api-management/apply-applications/delete-apply-openapi-record/{applyOpenApiRecordId}"
    },
    deleteMany: {
      method: "DELETE",
      path: "/api/open-api-management/apply-applications/many"
    },
    downloadTemplate: {
      desc: "下载导入模板",
      method: "GET",
      path: "/api/open-api-management/apply-applications/download-template"
    },
    generateSecretKey: {
      desc: "生成密钥",
      method: "POST",
      path: "/api/open-api-management/apply-applications/generate-secret-key"
    },
    get: {
      method: "GET",
      path: "/api/open-api-management/apply-applications/{id}"
    },
    getApplyOpenApiRecordPagedResult: {
      desc: "分页查询",
      method: "GET",
      path: "/api/open-api-management/apply-applications/apply-openapi-records"
    },
    getAuditStatus: {
      desc: "获取审核状态列表",
      method: "GET",
      path: "/api/open-api-management/apply-applications/audit-status-list"
    },
    getList: {
      method: "GET",
      path: "/api/open-api-management/apply-applications"
    },
    insertMany: {
      method: "POST",
      path: "/api/open-api-management/apply-applications/many"
    },
    submitApplyOpenApi: {
      desc: "提交申请OpenApi",
      method: "POST",
      path: "/api/open-api-management/apply-applications/submit"
    },
    update: {
      method: "PUT",
      path: "/api/open-api-management/apply-applications/{id}"
    },
    updateMany: {
      method: "PUT",
      path: "/api/open-api-management/apply-applications/many"
    }
  });
  var Ge = /*#__PURE__*/function () {
    function Ge(e) {
      _classCallCheck(this, Ge);
      this.apiClient = e || n.GetInstance("open-api-management", "DbConnectionStringApi");
    }
    return _createClass(Ge, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = null;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/{id}", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "callExportWithHttpInfo",
      value: function callExportWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/export", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callExport",
      value: function callExport(e) {
        return this.callExportWithHttpInfo(e);
      }
    }, {
      key: "callImportWithHttpInfo",
      value: function callImportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            file: e.file
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/import", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callImport",
      value: function callImport(e) {
        return this.callImportWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = f;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "deleteManyWithHttpInfo",
      value: function deleteManyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            ids: this.apiClient.buildCollectionParam(e.ids, "multi")
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/many", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "deleteMany",
      value: function deleteMany(e) {
        return this.deleteManyWithHttpInfo(e);
      }
    }, {
      key: "downloadTemplateWithHttpInfo",
      value: function downloadTemplateWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = "Blob";
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/download-template", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "downloadTemplate",
      value: function downloadTemplate() {
        return this.downloadTemplateWithHttpInfo();
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = f;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/{id}", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getDbTypesWithHttpInfo",
      value: function getDbTypesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/db-types", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getDbTypes",
      value: function getDbTypes() {
        return this.getDbTypesWithHttpInfo();
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            DbName: e.dbName,
            DbType: e.dbType,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = se;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "insertManyWithHttpInfo",
      value: function insertManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/many", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "insertMany",
      value: function insertMany(e) {
        return this.insertManyWithHttpInfo(e);
      }
    }, {
      key: "testConnectWithHttpInfo",
      value: function testConnectWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            connectionString: e.connectionString,
            dbType: e.dbType
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Boolean";
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/test-connect", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "testConnect",
      value: function testConnect(e) {
        return this.testConnectWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var r = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var p = {
            id: e
          },
          i = {},
          o = t.header || {},
          a = {},
          s = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          c = ["application/json", "text/json", "text/plain"],
          x = f;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/{id}", "PUT", p, i, o, a, r, s, l, c, x);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }, {
      key: "updateManyWithHttpInfo",
      value: function updateManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/db-connection-strings/many", "PUT", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "updateMany",
      value: function updateMany(e) {
        return this.updateManyWithHttpInfo(e);
      }
    }]);
  }();
  ee(Ge, "Methods", {
    callDelete: {
      method: "DELETE",
      path: "/api/open-api-management/db-connection-strings/{id}"
    },
    callExport: {
      desc: "导出",
      method: "POST",
      path: "/api/open-api-management/db-connection-strings/export"
    },
    callImport: {
      desc: "导出",
      method: "POST",
      path: "/api/open-api-management/db-connection-strings/import"
    },
    create: {
      method: "POST",
      path: "/api/open-api-management/db-connection-strings"
    },
    deleteMany: {
      method: "DELETE",
      path: "/api/open-api-management/db-connection-strings/many"
    },
    downloadTemplate: {
      desc: "下载导入模板",
      method: "GET",
      path: "/api/open-api-management/db-connection-strings/download-template"
    },
    get: {
      method: "GET",
      path: "/api/open-api-management/db-connection-strings/{id}"
    },
    getDbTypes: {
      desc: "获取数据库类型",
      method: "GET",
      path: "/api/open-api-management/db-connection-strings/db-types"
    },
    getList: {
      method: "GET",
      path: "/api/open-api-management/db-connection-strings"
    },
    insertMany: {
      method: "POST",
      path: "/api/open-api-management/db-connection-strings/many"
    },
    testConnect: {
      desc: "测试连接数据库",
      method: "POST",
      path: "/api/open-api-management/db-connection-strings/test-connect"
    },
    update: {
      method: "PUT",
      path: "/api/open-api-management/db-connection-strings/{id}"
    },
    updateMany: {
      method: "PUT",
      path: "/api/open-api-management/db-connection-strings/many"
    }
  });
  var Ue = /*#__PURE__*/function () {
    function Ue(e) {
      _classCallCheck(this, Ue);
      this.apiClient = e || n.GetInstance("open-api-management", "OpenApiApi");
    }
    return _createClass(Ue, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = null;
        return this.apiClient.callApi("/api/open-api-management/open-apis/{id}", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "callExportWithHttpInfo",
      value: function callExportWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-apis/export", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callExport",
      value: function callExport(e) {
        return this.callExportWithHttpInfo(e);
      }
    }, {
      key: "callImportWithHttpInfo",
      value: function callImportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            file: e.file
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-apis/import", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callImport",
      value: function callImport(e) {
        return this.callImportWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = m;
        return this.apiClient.callApi("/api/open-api-management/open-apis", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "deleteManyWithHttpInfo",
      value: function deleteManyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            ids: this.apiClient.buildCollectionParam(e.ids, "multi")
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-apis/many", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "deleteMany",
      value: function deleteMany(e) {
        return this.deleteManyWithHttpInfo(e);
      }
    }, {
      key: "downloadTemplateWithHttpInfo",
      value: function downloadTemplateWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-apis/download-template", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "downloadTemplate",
      value: function downloadTemplate() {
        return this.downloadTemplateWithHttpInfo();
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = m;
        return this.apiClient.callApi("/api/open-api-management/open-apis/{id}", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getAllowedRequestMethodsWithHttpInfo",
      value: function getAllowedRequestMethodsWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-apis/allowed-request-method", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getAllowedRequestMethods",
      value: function getAllowedRequestMethods() {
        return this.getAllowedRequestMethodsWithHttpInfo();
      }
    }, {
      key: "getDistinctApiTypeWithHttpInfo",
      value: function getDistinctApiTypeWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = ["String"];
        return this.apiClient.callApi("/api/open-api-management/open-apis/types", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getDistinctApiType",
      value: function getDistinctApiType() {
        return this.getDistinctApiTypeWithHttpInfo();
      }
    }, {
      key: "getEmptyDataMappingsOpenApiWithHttpInfo",
      value: function getEmptyDataMappingsOpenApiWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            Keywords: e.keywords,
            Type: e.type,
            IsEnabled: e.isEnabled,
            Status: e.status,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = j;
        return this.apiClient.callApi("/api/open-api-management/open-apis/empty-data-mappings-openapis", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getEmptyDataMappingsOpenApi",
      value: function getEmptyDataMappingsOpenApi(e) {
        return this.getEmptyDataMappingsOpenApiWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            Keywords: e.keywords,
            Type: e.type,
            IsEnabled: e.isEnabled,
            Status: e.status,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = j;
        return this.apiClient.callApi("/api/open-api-management/open-apis", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "getOpenApiRequestUriWithHttpInfo",
      value: function getOpenApiRequestUriWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            openApiId: e.openApiId,
            applyApplicationId: e.applyApplicationId
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = "String";
        return this.apiClient.callApi("/api/open-api-management/open-apis/request-uri", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getOpenApiRequestUri",
      value: function getOpenApiRequestUri(e) {
        return this.getOpenApiRequestUriWithHttpInfo(e);
      }
    }, {
      key: "getParamQueryModesWithHttpInfo",
      value: function getParamQueryModesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-apis/param-query-modes", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getParamQueryModes",
      value: function getParamQueryModes() {
        return this.getParamQueryModesWithHttpInfo();
      }
    }, {
      key: "getParamTypesWithHttpInfo",
      value: function getParamTypesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-apis/param-types", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getParamTypes",
      value: function getParamTypes() {
        return this.getParamTypesWithHttpInfo();
      }
    }, {
      key: "getParamValueTypesWithHttpInfo",
      value: function getParamValueTypesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-apis/param-value-types", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getParamValueTypes",
      value: function getParamValueTypes() {
        return this.getParamValueTypesWithHttpInfo();
      }
    }, {
      key: "getStatusWithHttpInfo",
      value: function getStatusWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-apis/status-list", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getStatus",
      value: function getStatus() {
        return this.getStatusWithHttpInfo();
      }
    }, {
      key: "getUrlPrefixWithHttpInfo",
      value: function getUrlPrefixWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            isPostQuery: e.isPostQuery
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = "String";
        return this.apiClient.callApi("/api/open-api-management/open-apis/url-prefix", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getUrlPrefix",
      value: function getUrlPrefix(e) {
        return this.getUrlPrefixWithHttpInfo(e);
      }
    }, {
      key: "insertManyWithHttpInfo",
      value: function insertManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-apis/many", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "insertMany",
      value: function insertMany(e) {
        return this.insertManyWithHttpInfo(e);
      }
    }, {
      key: "modifyAvailableStatusWithHttpInfo",
      value: function modifyAvailableStatusWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            id: e.id,
            isEnabled: e.isEnabled
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = m;
        return this.apiClient.callApi("/api/open-api-management/open-apis/modify-available-status", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "modifyAvailableStatus",
      value: function modifyAvailableStatus(e) {
        return this.modifyAvailableStatusWithHttpInfo(e);
      }
    }, {
      key: "publishWithHttpInfo",
      value: function publishWithHttpInfo(e, t) {
        t = t || {};
        var r = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling publish");
        var p = {
            id: e
          },
          i = {},
          o = t.header || {},
          a = {},
          s = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          c = ["application/json", "text/json", "text/plain"],
          x = m;
        return this.apiClient.callApi("/api/open-api-management/open-apis/publish/{id}", "POST", p, i, o, a, r, s, l, c, x);
      }
    }, {
      key: "publish",
      value: function publish(e, t) {
        return this.publishWithHttpInfo(e, t);
      }
    }, {
      key: "publishListWithHttpInfo",
      value: function publishListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = [m];
        return this.apiClient.callApi("/api/open-api-management/open-apis/publish-list", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "publishList",
      value: function publishList(e) {
        return this.publishListWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var r = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var p = {
            id: e
          },
          i = {},
          o = t.header || {},
          a = {},
          s = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          c = ["application/json", "text/json", "text/plain"],
          x = m;
        return this.apiClient.callApi("/api/open-api-management/open-apis/{id}", "PUT", p, i, o, a, r, s, l, c, x);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }, {
      key: "updateManyWithHttpInfo",
      value: function updateManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-apis/many", "PUT", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "updateMany",
      value: function updateMany(e) {
        return this.updateManyWithHttpInfo(e);
      }
    }]);
  }();
  ee(Ue, "Methods", {
    callDelete: {
      method: "DELETE",
      path: "/api/open-api-management/open-apis/{id}"
    },
    callExport: {
      desc: "导出",
      method: "POST",
      path: "/api/open-api-management/open-apis/export"
    },
    callImport: {
      desc: "导入",
      method: "POST",
      path: "/api/open-api-management/open-apis/import"
    },
    create: {
      method: "POST",
      path: "/api/open-api-management/open-apis"
    },
    deleteMany: {
      method: "DELETE",
      path: "/api/open-api-management/open-apis/many"
    },
    downloadTemplate: {
      desc: "下载导入模板",
      method: "GET",
      path: "/api/open-api-management/open-apis/download-template"
    },
    get: {
      method: "GET",
      path: "/api/open-api-management/open-apis/{id}"
    },
    getAllowedRequestMethods: {
      desc: "获取允许的请求方式列表",
      method: "GET",
      path: "/api/open-api-management/open-apis/allowed-request-method"
    },
    getDistinctApiType: {
      desc: "获取API类型",
      method: "GET",
      path: "/api/open-api-management/open-apis/types"
    },
    getEmptyDataMappingsOpenApi: {
      desc: "查询未配置数据映射的 OpenApi",
      method: "GET",
      path: "/api/open-api-management/open-apis/empty-data-mappings-openapis"
    },
    getList: {
      method: "GET",
      path: "/api/open-api-management/open-apis"
    },
    getOpenApiRequestUri: {
      desc: "获取 OpenApi 请求地址",
      method: "GET",
      path: "/api/open-api-management/open-apis/request-uri"
    },
    getParamQueryModes: {
      desc: "获取参数查询类型列表",
      method: "GET",
      path: "/api/open-api-management/open-apis/param-query-modes"
    },
    getParamTypes: {
      desc: "获取参数类型列表",
      method: "GET",
      path: "/api/open-api-management/open-apis/param-types"
    },
    getParamValueTypes: {
      desc: "获取参数值类型列表",
      method: "GET",
      path: "/api/open-api-management/open-apis/param-value-types"
    },
    getStatus: {
      desc: "获取 OpenApi 状态列表",
      method: "GET",
      path: "/api/open-api-management/open-apis/status-list"
    },
    getUrlPrefix: {
      desc: "获取 OpenApi Url 前缀",
      method: "GET",
      path: "/api/open-api-management/open-apis/url-prefix"
    },
    insertMany: {
      method: "POST",
      path: "/api/open-api-management/open-apis/many"
    },
    modifyAvailableStatus: {
      desc: "修改可用状态",
      method: "POST",
      path: "/api/open-api-management/open-apis/modify-available-status"
    },
    publish: {
      desc: "发布",
      method: "POST",
      path: "/api/open-api-management/open-apis/publish/{id}"
    },
    publishList: {
      desc: "批量发布",
      method: "POST",
      path: "/api/open-api-management/open-apis/publish-list"
    },
    update: {
      method: "PUT",
      path: "/api/open-api-management/open-apis/{id}"
    },
    updateMany: {
      method: "PUT",
      path: "/api/open-api-management/open-apis/many"
    }
  });
  var Ke = /*#__PURE__*/function () {
    function Ke(e) {
      _classCallCheck(this, Ke);
      this.apiClient = e || n.GetInstance("open-api-management", "OpenApiCallRecordApi");
    }
    return _createClass(Ke, [{
      key: "getApiCallDetailInfoWithHttpInfo",
      value: function getApiCallDetailInfoWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling getApiCallDetailInfo");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = pe;
        return this.apiClient.callApi("/api/open-api-management/open-api-call-record/api-call-detail-info/{id}", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getApiCallDetailInfo",
      value: function getApiCallDetailInfo(e) {
        return this.getApiCallDetailInfoWithHttpInfo(e);
      }
    }, {
      key: "getHuizhou2SummaryResultWithHttpInfo",
      value: function getHuizhou2SummaryResultWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = V;
        return this.apiClient.callApi("/api/open-api-management/open-api-call-record/huizhou2-bim-summary", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getHuizhou2SummaryResult",
      value: function getHuizhou2SummaryResult() {
        return this.getHuizhou2SummaryResultWithHttpInfo();
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = le;
        return this.apiClient.callApi("/api/open-api-management/open-api-call-record", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "getSummaryWithHttpInfo",
      value: function getSummaryWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            type: e.type
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = A;
        return this.apiClient.callApi("/api/open-api-management/open-api-call-record/summary", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getSummary",
      value: function getSummary(e) {
        return this.getSummaryWithHttpInfo(e);
      }
    }]);
  }();
  ee(Ke, "Methods", {
    getApiCallDetailInfo: {
      desc: "获取 API 调用详细信息",
      method: "GET",
      path: "/api/open-api-management/open-api-call-record/api-call-detail-info/{id}"
    },
    getHuizhou2SummaryResult: {
      desc: "惠州BIM数字化电厂统计结果",
      method: "GET",
      path: "/api/open-api-management/open-api-call-record/huizhou2-bim-summary"
    },
    getList: {
      desc: "分页获取调用记录",
      method: "POST",
      path: "/api/open-api-management/open-api-call-record"
    },
    getSummary: {
      desc: "数据服务监控",
      method: "GET",
      path: "/api/open-api-management/open-api-call-record/summary"
    }
  });
  var Le = /*#__PURE__*/function () {
    function Le(e) {
      _classCallCheck(this, Le);
      this.apiClient = e || n.GetInstance("open-api-management", "OpenApiDataMappingApi");
    }
    return _createClass(Le, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = null;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/{id}", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "callExportWithHttpInfo",
      value: function callExportWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/export", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callExport",
      value: function callExport(e) {
        return this.callExportWithHttpInfo(e);
      }
    }, {
      key: "callImportWithHttpInfo",
      value: function callImportWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            file: e.file
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/import", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "callImport",
      value: function callImport(e) {
        return this.callImportWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = h;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "deleteManyWithHttpInfo",
      value: function deleteManyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            ids: this.apiClient.buildCollectionParam(e.ids, "multi")
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/many", "DELETE", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "deleteMany",
      value: function deleteMany(e) {
        return this.deleteManyWithHttpInfo(e);
      }
    }, {
      key: "downloadTemplateWithHttpInfo",
      value: function downloadTemplateWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = "Blob";
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/download-template", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "downloadTemplate",
      value: function downloadTemplate() {
        return this.downloadTemplateWithHttpInfo();
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var r = {
            id: e
          },
          p = {},
          i = {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = h;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/{id}", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getMappingTypesWithHttpInfo",
      value: function getMappingTypesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [q];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/mapping-types", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getMappingTypes",
      value: function getMappingTypes() {
        return this.getMappingTypesWithHttpInfo();
      }
    }, {
      key: "getMetricsListWithHttpInfo",
      value: function getMetricsListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            keyword: e.keyword
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = [W];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/metrics-list", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getMetricsList",
      value: function getMetricsList(e) {
        return this.getMetricsListWithHttpInfo(e);
      }
    }, {
      key: "getPagedResultWithHttpInfo",
      value: function getPagedResultWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            OpenApiName: e.openApiName,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = ce;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getPagedResult",
      value: function getPagedResult(e) {
        return this.getPagedResultWithHttpInfo(e);
      }
    }, {
      key: "getSqlExamplesWithHttpInfo",
      value: function getSqlExamplesWithHttpInfo() {
        var e = null,
          t = {},
          r = {},
          p = {},
          i = {},
          o = ["oauth2"],
          a = [],
          s = ["application/json", "text/json", "text/plain"],
          l = [Z];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/sql-examples", "GET", t, r, p, i, e, o, a, s, l);
      }
    }, {
      key: "getSqlExamples",
      value: function getSqlExamples() {
        return this.getSqlExamplesWithHttpInfo();
      }
    }, {
      key: "getSqlParamTypesWithHttpInfo",
      value: function getSqlParamTypesWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            paramType: e.paramType
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = [q];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/sql-param-types", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getSqlParamTypes",
      value: function getSqlParamTypes(e) {
        return this.getSqlParamTypesWithHttpInfo(e);
      }
    }, {
      key: "getStdClassListWithHttpInfo",
      value: function getStdClassListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            keyword: e.keyword
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = [Q];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/class-list", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getStdClassList",
      value: function getStdClassList(e) {
        return this.getStdClassListWithHttpInfo(e);
      }
    }, {
      key: "getTablesWithHttpInfo",
      value: function getTablesWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {
            dbConnectionStringId: e.dbConnectionStringId
          },
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = [],
          l = ["application/json", "text/json", "text/plain"],
          c = [ye];
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/tables", "GET", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "getTables",
      value: function getTables(e) {
        return this.getTablesWithHttpInfo(e);
      }
    }, {
      key: "insertManyWithHttpInfo",
      value: function insertManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/many", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "insertMany",
      value: function insertMany(e) {
        return this.insertManyWithHttpInfo(e);
      }
    }, {
      key: "parsingParamsWithHttpInfo",
      value: function parsingParamsWithHttpInfo(e) {
        e = e || {};
        var t = null,
          r = {},
          p = {},
          i = e.header || {},
          o = {
            dbConnectionStringId: e.dbConnectionStringId,
            mappingType: e.mappingType,
            openApiId: e.openApiId,
            parsingContent: e.parsingContent
          },
          a = ["oauth2"],
          s = ["multipart/form-data"],
          l = ["application/json", "text/json", "text/plain"],
          c = z;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/parsing-content", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "parsingParams",
      value: function parsingParams(e) {
        return this.parsingParamsWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var r = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var p = {
            id: e
          },
          i = {},
          o = t.header || {},
          a = {},
          s = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          c = ["application/json", "text/json", "text/plain"],
          x = h;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/{id}", "PUT", p, i, o, a, r, s, l, c, x);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }, {
      key: "updateManyWithHttpInfo",
      value: function updateManyWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/many", "PUT", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "updateMany",
      value: function updateMany(e) {
        return this.updateManyWithHttpInfo(e);
      }
    }, {
      key: "verifySqlSyntaxWithHttpInfo",
      value: function verifySqlSyntaxWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          r = {},
          p = {},
          i = e.header || {},
          o = {},
          a = ["oauth2"],
          s = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          c = e.returnType || null;
        return this.apiClient.callApi("/api/open-api-management/open-api-data-mappings/verify-sql-syntax", "POST", r, p, i, o, t, a, s, l, c);
      }
    }, {
      key: "verifySqlSyntax",
      value: function verifySqlSyntax(e) {
        return this.verifySqlSyntaxWithHttpInfo(e);
      }
    }]);
  }();
  ee(Le, "Methods", {
    callDelete: {
      method: "DELETE",
      path: "/api/open-api-management/open-api-data-mappings/{id}"
    },
    callExport: {
      desc: "导出",
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings/export"
    },
    callImport: {
      desc: "导入",
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings/import"
    },
    create: {
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings"
    },
    deleteMany: {
      method: "DELETE",
      path: "/api/open-api-management/open-api-data-mappings/many"
    },
    downloadTemplate: {
      desc: "下载模板",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/download-template"
    },
    get: {
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/{id}"
    },
    getMappingTypes: {
      desc: "获取数据映射方式列表",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/mapping-types"
    },
    getMetricsList: {
      desc: "查询指标列表（已发布状态）",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/metrics-list"
    },
    getPagedResult: {
      desc: "分页查询",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings"
    },
    getSqlExamples: {
      desc: "获取 sql 示例",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/sql-examples"
    },
    getSqlParamTypes: {
      desc: "获取Sql参数类型列表",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/sql-param-types"
    },
    getStdClassList: {
      desc: "查询实体列表（已审批状态）",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/class-list"
    },
    getTables: {
      desc: "获取所有表",
      method: "GET",
      path: "/api/open-api-management/open-api-data-mappings/tables"
    },
    insertMany: {
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings/many"
    },
    parsingParams: {
      desc: "解析参数",
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings/parsing-content"
    },
    update: {
      method: "PUT",
      path: "/api/open-api-management/open-api-data-mappings/{id}"
    },
    updateMany: {
      method: "PUT",
      path: "/api/open-api-management/open-api-data-mappings/many"
    },
    verifySqlSyntax: {
      desc: "校验sql语法",
      method: "POST",
      path: "/api/open-api-management/open-api-data-mappings/verify-sql-syntax"
    }
  }), y.AbpRemoteServiceErrorInfo = L, y.AbpRemoteServiceErrorResponse = Se, y.AbpRemoteServiceValidationErrorInfo = te, y.ApiClient = n, y.ApplyApplicationApi = Be, y.ApplyapplicationsDecryptsecretkeyBody = we, y.ApplyapplicationsImportBody = Ae, y.DbConnectionStringApi = Ge, y.DbconnectionstringsImportBody = Ie, y.DbconnectionstringsTestconnectBody = ue, y.OpenApiApi = Ue, y.OpenApiCallRecordApi = Ke, y.OpenApiDataMappingApi = Le, y.OpenApiManagementApiCallRecordDetailDto = pe, y.OpenApiManagementApplyApplicationCreateInputDto = G, y.OpenApiManagementApplyApplicationDto = u, y.OpenApiManagementApplyApplicationExportInputDto = de, y.OpenApiManagementApplyApplicationUpdateInputDto = H, y.OpenApiManagementApplyOpenApiRecordCreateOrUpdateBaseDto = J, y.OpenApiManagementApplyOpenApiRecordDto = C, y.OpenApiManagementApplyOpenApiRecordPagedResultDto = O, y.OpenApiManagementApproveApplyOpenApiInputDto = he, y.OpenApiManagementAuditStatusFlag = Ee, y.OpenApiManagementDataserviceApiCallrecordSummaryResultDto = A, y.OpenApiManagementDbConnectionStringCreateInputDto = $, y.OpenApiManagementDbConnectionStringDto = f, y.OpenApiManagementDbConnectionStringExportInputDto = fe, y.OpenApiManagementDbConnectionStringUpdateInputDto = k, y.OpenApiManagementDbTypeFlag = ne, y.OpenApiManagementDecryptSecretKeyResultDto = re, y.OpenApiManagementDestParamMappingDto = X, y.OpenApiManagementHuizhou2SummaryResultDto = V, y.OpenApiManagementJumpRequestTypeFlag = Fe, y.OpenApiManagementMappingTypeFlag = Te, y.OpenApiManagementMetricsDto = W, y.OpenApiManagementMetricsTypeEnum = Re, y.OpenApiManagementOpenApiCallRecordDto = T, y.OpenApiManagementOpenApiCallRecordPageRequestInputDto = N, y.OpenApiManagementOpenApiCreateInputDto = I, y.OpenApiManagementOpenApiDataMappingCreateInputDto = K, y.OpenApiManagementOpenApiDataMappingDto = h, y.OpenApiManagementOpenApiDataMappingExportInputDto = Me, y.OpenApiManagementOpenApiDataMappingListResultDto = w, y.OpenApiManagementOpenApiDataMappingUpdateInputDto = F, y.OpenApiManagementOpenApiDto = m, y.OpenApiManagementOpenApiExportRequestInputDto = Y, y.OpenApiManagementOpenApiMethodFlag = ve, y.OpenApiManagementOpenApiParamMappingCreateInputDto = B, y.OpenApiManagementOpenApiParamMappingCreateOrUpdateBaseDto = E, y.OpenApiManagementOpenApiParamMappingDto = M, y.OpenApiManagementOpenApiParamSettingsDto = R, y.OpenApiManagementOpenApiParamSettingsUpdateInputDto = U, y.OpenApiManagementOpenApiStatusFlag = He, y.OpenApiManagementOpenApiUpdateInputDto = g, y.OpenApiManagementParamQueryModeFlag = xe, y.OpenApiManagementParamTypeFlag = Ce, y.OpenApiManagementParamValueTypeFlag = ie, y.OpenApiManagementParsedParamResponseDto = z, y.OpenApiManagementPoint = D, y.OpenApiManagementSqlExampleDto = Z, y.OpenApiManagementSqlParamTypeFlag = Ne, y.OpenApiManagementStdClassDto = Q, y.OpenApiManagementVerifySqlInputDto = _, y.OpenapidatamappingsImportBody = qe, y.OpenapidatamappingsParsingcontentBody = b, y.OpenapisImportBody = De, y.OpenapisModifyavailablestatusBody = ge, y.PagedResultDtoOpenApiManagementApplyApplicationDto = oe, y.PagedResultDtoOpenApiManagementApplyOpenApiRecordPagedResultDto = ae, y.PagedResultDtoOpenApiManagementDbConnectionStringDto = se, y.PagedResultDtoOpenApiManagementOpenApiCallRecordDto = le, y.PagedResultDtoOpenApiManagementOpenApiDataMappingListResultDto = ce, y.PagedResultDtoOpenApiManagementOpenApiDto = j, y.TupleInt32Int32StringString = q, y.TupleStringStringStringString = ye, Object.defineProperty(y, Symbol.toStringTag, {
    value: "Module"
  });
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer, __webpack_require__("62e4")(module)))

/***/ }),

/***/ "f018":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("d28b");
__webpack_require__("d9e2");
__webpack_require__("99af");
__webpack_require__("caad");
__webpack_require__("e260");
__webpack_require__("a15b");
__webpack_require__("fb6a");
__webpack_require__("4e82");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("2532");
__webpack_require__("3ca3");
__webpack_require__("ddb0");
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }
  return _typeof(obj);
}

/**
 * Module of mixed-in functions shared between node and client code
 */
var isObject = __webpack_require__("8622");
/**
 * Expose `RequestBase`.
 */

module.exports = RequestBase;
/**
 * Initialize a new `RequestBase`.
 *
 * @api public
 */

function RequestBase(obj) {
  if (obj) return mixin(obj);
}
/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in RequestBase.prototype) {
    if (Object.prototype.hasOwnProperty.call(RequestBase.prototype, key)) obj[key] = RequestBase.prototype[key];
  }
  return obj;
}
/**
 * Clear previous timeout.
 *
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.clearTimeout = function () {
  clearTimeout(this._timer);
  clearTimeout(this._responseTimeoutTimer);
  clearTimeout(this._uploadTimeoutTimer);
  delete this._timer;
  delete this._responseTimeoutTimer;
  delete this._uploadTimeoutTimer;
  return this;
};
/**
 * Override default response body parser
 *
 * This function will be called to convert incoming data into request.body
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.parse = function (fn) {
  this._parser = fn;
  return this;
};
/**
 * Set format of binary response body.
 * In browser valid formats are 'blob' and 'arraybuffer',
 * which return Blob and ArrayBuffer, respectively.
 *
 * In Node all values result in Buffer.
 *
 * Examples:
 *
 *      req.get('/')
 *        .responseType('blob')
 *        .end(callback);
 *
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.responseType = function (val) {
  this._responseType = val;
  return this;
};
/**
 * Override default request body serializer
 *
 * This function will be called to convert data set via .send or .attach into payload to send
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.serialize = function (fn) {
  this._serializer = fn;
  return this;
};
/**
 * Set timeouts.
 *
 * - response timeout is time between sending request and receiving the first byte of the response. Includes DNS and connection time.
 * - deadline is the time from start of the request to receiving response body in full. If the deadline is too short large files may not load at all on slow connections.
 * - upload is the time  since last bit of data was sent or received. This timeout works only if deadline timeout is off
 *
 * Value of 0 or false means no timeout.
 *
 * @param {Number|Object} ms or {response, deadline}
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.timeout = function (options) {
  if (!options || _typeof(options) !== 'object') {
    this._timeout = options;
    this._responseTimeout = 0;
    this._uploadTimeout = 0;
    return this;
  }
  for (var option in options) {
    if (Object.prototype.hasOwnProperty.call(options, option)) {
      switch (option) {
        case 'deadline':
          this._timeout = options.deadline;
          break;
        case 'response':
          this._responseTimeout = options.response;
          break;
        case 'upload':
          this._uploadTimeout = options.upload;
          break;
        default:
          console.warn('Unknown timeout option', option);
      }
    }
  }
  return this;
};
/**
 * Set number of retry attempts on error.
 *
 * Failed requests will be retried 'count' times if timeout or err.code >= 500.
 *
 * @param {Number} count
 * @param {Function} [fn]
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.retry = function (count, fn) {
  // Default to 1 if no count passed or true
  if (arguments.length === 0 || count === true) count = 1;
  if (count <= 0) count = 0;
  this._maxRetries = count;
  this._retries = 0;
  this._retryCallback = fn;
  return this;
};
var ERROR_CODES = ['ECONNRESET', 'ETIMEDOUT', 'EADDRINFO', 'ESOCKETTIMEDOUT'];
/**
 * Determine if a request should be retried.
 * (Borrowed from segmentio/superagent-retry)
 *
 * @param {Error} err an error
 * @param {Response} [res] response
 * @returns {Boolean} if segment should be retried
 */

RequestBase.prototype._shouldRetry = function (err, res) {
  if (!this._maxRetries || this._retries++ >= this._maxRetries) {
    return false;
  }
  if (this._retryCallback) {
    try {
      var override = this._retryCallback(err, res);
      if (override === true) return true;
      if (override === false) return false; // undefined falls back to defaults
    } catch (err_) {
      console.error(err_);
    }
  }
  if (res && res.status && res.status >= 500 && res.status !== 501) return true;
  if (err) {
    if (err.code && ERROR_CODES.includes(err.code)) return true; // Superagent timeout

    if (err.timeout && err.code === 'ECONNABORTED') return true;
    if (err.crossDomain) return true;
  }
  return false;
};
/**
 * Retry request
 *
 * @return {Request} for chaining
 * @api private
 */

RequestBase.prototype._retry = function () {
  this.clearTimeout(); // node

  if (this.req) {
    this.req = null;
    this.req = this.request();
  }
  this._aborted = false;
  this.timedout = false;
  this.timedoutError = null;
  return this._end();
};
/**
 * Promise support
 *
 * @param {Function} resolve
 * @param {Function} [reject]
 * @return {Request}
 */

RequestBase.prototype.then = function (resolve, reject) {
  var _this = this;
  if (!this._fullfilledPromise) {
    var self = this;
    if (this._endCalled) {
      console.warn('Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises');
    }
    this._fullfilledPromise = new Promise(function (resolve, reject) {
      self.on('abort', function () {
        if (_this._maxRetries && _this._maxRetries > _this._retries) {
          return;
        }
        if (_this.timedout && _this.timedoutError) {
          reject(_this.timedoutError);
          return;
        }
        var err = new Error('Aborted');
        err.code = 'ABORTED';
        err.status = _this.status;
        err.method = _this.method;
        err.url = _this.url;
        reject(err);
      });
      self.end(function (err, res) {
        if (err) reject(err);else resolve(res);
      });
    });
  }
  return this._fullfilledPromise.then(resolve, reject);
};
RequestBase.prototype.catch = function (cb) {
  return this.then(undefined, cb);
};
/**
 * Allow for extension
 */

RequestBase.prototype.use = function (fn) {
  fn(this);
  return this;
};
RequestBase.prototype.ok = function (cb) {
  if (typeof cb !== 'function') throw new Error('Callback required');
  this._okCallback = cb;
  return this;
};
RequestBase.prototype._isResponseOK = function (res) {
  if (!res) {
    return false;
  }
  if (this._okCallback) {
    return this._okCallback(res);
  }
  return res.status >= 200 && res.status < 300;
};
/**
 * Get request header `field`.
 * Case-insensitive.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

RequestBase.prototype.get = function (field) {
  return this._header[field.toLowerCase()];
};
/**
 * Get case-insensitive header `field` value.
 * This is a deprecated internal API. Use `.get(field)` instead.
 *
 * (getHeader is no longer used internally by the superagent code base)
 *
 * @param {String} field
 * @return {String}
 * @api private
 * @deprecated
 */

RequestBase.prototype.getHeader = RequestBase.prototype.get;
/**
 * Set header `field` to `val`, or multiple fields with one object.
 * Case-insensitive.
 *
 * Examples:
 *
 *      req.get('/')
 *        .set('Accept', 'application/json')
 *        .set('X-API-Key', 'foobar')
 *        .end(callback);
 *
 *      req.get('/')
 *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
 *        .end(callback);
 *
 * @param {String|Object} field
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.set = function (field, val) {
  if (isObject(field)) {
    for (var key in field) {
      if (Object.prototype.hasOwnProperty.call(field, key)) this.set(key, field[key]);
    }
    return this;
  }
  this._header[field.toLowerCase()] = val;
  this.header[field] = val;
  return this;
};
/**
 * Remove header `field`.
 * Case-insensitive.
 *
 * Example:
 *
 *      req.get('/')
 *        .unset('User-Agent')
 *        .end(callback);
 *
 * @param {String} field field name
 */

RequestBase.prototype.unset = function (field) {
  delete this._header[field.toLowerCase()];
  delete this.header[field];
  return this;
};
/**
 * Write the field `name` and `val`, or multiple fields with one object
 * for "multipart/form-data" request bodies.
 *
 * ``` js
 * request.post('/upload')
 *   .field('foo', 'bar')
 *   .end(callback);
 *
 * request.post('/upload')
 *   .field({ foo: 'bar', baz: 'qux' })
 *   .end(callback);
 * ```
 *
 * @param {String|Object} name name of field
 * @param {String|Blob|File|Buffer|fs.ReadStream} val value of field
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.field = function (name, val) {
  // name should be either a string or an object.
  if (name === null || undefined === name) {
    throw new Error('.field(name, val) name can not be empty');
  }
  if (this._data) {
    throw new Error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObject(name)) {
    for (var key in name) {
      if (Object.prototype.hasOwnProperty.call(name, key)) this.field(key, name[key]);
    }
    return this;
  }
  if (Array.isArray(val)) {
    for (var i in val) {
      if (Object.prototype.hasOwnProperty.call(val, i)) this.field(name, val[i]);
    }
    return this;
  } // val should be defined now

  if (val === null || undefined === val) {
    throw new Error('.field(name, val) val can not be empty');
  }
  if (typeof val === 'boolean') {
    val = String(val);
  }
  this._getFormData().append(name, val);
  return this;
};
/**
 * Abort the request, and clear potential timeout.
 *
 * @return {Request} request
 * @api public
 */

RequestBase.prototype.abort = function () {
  if (this._aborted) {
    return this;
  }
  this._aborted = true;
  if (this.xhr) this.xhr.abort(); // browser

  if (this.req) this.req.abort(); // node

  this.clearTimeout();
  this.emit('abort');
  return this;
};
RequestBase.prototype._auth = function (user, pass, options, base64Encoder) {
  switch (options.type) {
    case 'basic':
      this.set('Authorization', "Basic ".concat(base64Encoder("".concat(user, ":").concat(pass))));
      break;
    case 'auto':
      this.username = user;
      this.password = pass;
      break;
    case 'bearer':
      // usage would be .auth(accessToken, { type: 'bearer' })
      this.set('Authorization', "Bearer ".concat(user));
      break;
    default:
      break;
  }
  return this;
};
/**
 * Enable transmission of cookies with x-domain requests.
 *
 * Note that for this to work the origin must not be
 * using "Access-Control-Allow-Origin" with a wildcard,
 * and also must set "Access-Control-Allow-Credentials"
 * to "true".
 *
 * @api public
 */

RequestBase.prototype.withCredentials = function (on) {
  // This is browser-only functionality. Node side is no-op.
  if (on === undefined) on = true;
  this._withCredentials = on;
  return this;
};
/**
 * Set the max redirects to `n`. Does nothing in browser XHR implementation.
 *
 * @param {Number} n
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.redirects = function (n) {
  this._maxRedirects = n;
  return this;
};
/**
 * Maximum size of buffered response body, in bytes. Counts uncompressed size.
 * Default 200MB.
 *
 * @param {Number} n number of bytes
 * @return {Request} for chaining
 */

RequestBase.prototype.maxResponseSize = function (n) {
  if (typeof n !== 'number') {
    throw new TypeError('Invalid argument');
  }
  this._maxResponseSize = n;
  return this;
};
/**
 * Convert to a plain javascript object (not JSON string) of scalar properties.
 * Note as this method is designed to return a useful non-this value,
 * it cannot be chained.
 *
 * @return {Object} describing method, url, and data of this request
 * @api public
 */

RequestBase.prototype.toJSON = function () {
  return {
    method: this.method,
    url: this.url,
    data: this._data,
    headers: this._header
  };
};
/**
 * Send `data` as the request body, defaulting the `.type()` to "json" when
 * an object is given.
 *
 * Examples:
 *
 *       // manual json
 *       request.post('/user')
 *         .type('json')
 *         .send('{"name":"tj"}')
 *         .end(callback)
 *
 *       // auto json
 *       request.post('/user')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // manual x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send('name=tj')
 *         .end(callback)
 *
 *       // auto x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // defaults to x-www-form-urlencoded
 *      request.post('/user')
 *        .send('name=tobi')
 *        .send('species=ferret')
 *        .end(callback)
 *
 * @param {String|Object} data
 * @return {Request} for chaining
 * @api public
 */
// eslint-disable-next-line complexity

RequestBase.prototype.send = function (data) {
  var isObj = isObject(data);
  var type = this._header['content-type'];
  if (this._formData) {
    throw new Error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObj && !this._data) {
    if (Array.isArray(data)) {
      this._data = [];
    } else if (!this._isHost(data)) {
      this._data = {};
    }
  } else if (data && this._data && this._isHost(this._data)) {
    throw new Error("Can't merge these send calls");
  } // merge

  if (isObj && isObject(this._data)) {
    for (var key in data) {
      if (Object.prototype.hasOwnProperty.call(data, key)) this._data[key] = data[key];
    }
  } else if (typeof data === 'string') {
    // default to x-www-form-urlencoded
    if (!type) this.type('form');
    type = this._header['content-type'];
    if (type === 'application/x-www-form-urlencoded') {
      this._data = this._data ? "".concat(this._data, "&").concat(data) : data;
    } else {
      this._data = (this._data || '') + data;
    }
  } else {
    this._data = data;
  }
  if (!isObj || this._isHost(data)) {
    return this;
  } // default to json

  if (!type) this.type('json');
  return this;
};
/**
 * Sort `querystring` by the sort function
 *
 *
 * Examples:
 *
 *       // default order
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery()
 *         .end(callback)
 *
 *       // customized sort function
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery(function(a, b){
 *           return a.length - b.length;
 *         })
 *         .end(callback)
 *
 *
 * @param {Function} sort
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.sortQuery = function (sort) {
  // _sort default to true but otherwise can be a function or boolean
  this._sort = typeof sort === 'undefined' ? true : sort;
  return this;
};
/**
 * Compose querystring to append to req.url
 *
 * @api private
 */

RequestBase.prototype._finalizeQueryString = function () {
  var query = this._query.join('&');
  if (query) {
    this.url += (this.url.includes('?') ? '&' : '?') + query;
  }
  this._query.length = 0; // Makes the call idempotent

  if (this._sort) {
    var index = this.url.indexOf('?');
    if (index >= 0) {
      var queryArr = this.url.slice(index + 1).split('&');
      if (typeof this._sort === 'function') {
        queryArr.sort(this._sort);
      } else {
        queryArr.sort();
      }
      this.url = this.url.slice(0, index) + '?' + queryArr.join('&');
    }
  }
}; // For backwards compat only

RequestBase.prototype._appendQueryString = function () {
  console.warn('Unsupported');
};
/**
 * Invoke callback with timeout error.
 *
 * @api private
 */

RequestBase.prototype._timeoutError = function (reason, timeout, errno) {
  if (this._aborted) {
    return;
  }
  var err = new Error("".concat(reason + timeout, "ms exceeded"));
  err.timeout = timeout;
  err.code = 'ECONNABORTED';
  err.errno = errno;
  this.timedout = true;
  this.timedoutError = err;
  this.abort();
  this.callback(err);
};
RequestBase.prototype._setTimeouts = function () {
  var self = this; // deadline

  if (this._timeout && !this._timer) {
    this._timer = setTimeout(function () {
      self._timeoutError('Timeout of ', self._timeout, 'ETIME');
    }, this._timeout);
  } // response timeout

  if (this._responseTimeout && !this._responseTimeoutTimer) {
    this._responseTimeoutTimer = setTimeout(function () {
      self._timeoutError('Response timeout of ', self._responseTimeout, 'ETIMEDOUT');
    }, this._responseTimeout);
  }
};

/***/ })

}]);
//# sourceMappingURL=visualization-cockpit.umd.73.js.map